//************压缩图片************************************************************
/**
 * 压缩图片
 * @param base64code //被压缩图片的base64编码
 * @param maxWidth //压缩后图片最大宽度
 * @param maxHeight //压缩后图片的最大高度
 * @param callback(dataUrl) 压缩回调方法,参数为压缩后的url，若压缩失败，则返回"";
 * @returns
 */
function compressImg(base64code,maxWidth,maxHeight,callback) {
    //var base64code = "";
    var image = new Image();
    image.src = base64code;
    var dataURL = "";
    imgLoad(image, function() {
        //解决canvas无法读取画布问题
        image.setAttribute('crossOrigin', 'anonymous');
        var mpImg = new MegaPixImage(image);
        //console.log('加载完毕')
        var resCanvas2 =document.createElement("canvas");
        if(isIOS()){
        	mpImg.render(resCanvas2, {maxWidth: maxWidth, maxHeight: maxHeight, orientation: 4});
        }else{
        	mpImg.render(resCanvas2, {maxWidth: maxWidth, maxHeight: maxHeight, orientation: 0});
        }
        dataURL = resCanvas2.toDataURL("image/jpeg");
        callback(dataURL);
    });
   // return dataURL;
}
function imgLoad(img, callback) {
    var timer = setInterval(function() {
        if (img.complete) {
            callback(img)
            clearInterval(timer)
        }
    }, 50)
}
//********************************************************************************************
function isIOS(){
	var userAgentInfo = navigator.userAgent;    
	var Agents = new Array("iPhone","iPad", "iPod"); /*"Android",  */
	var flag = false;  
	var v=0  
	for ( v = 0; v < Agents.length; v++){    
	    if (userAgentInfo.indexOf(Agents[v]) > 0) { 
	    	flag = true; break; 
	   	}    
	}    
	return flag;
}
//********************************************************************************************
function dataURLToBlob(dataURL) {
    var BASE64_MARKER = ';base64,';
    var parts, contentType, raw;
    if (dataURL.indexOf(BASE64_MARKER) == -1) {
        parts = dataURL.split(',');
        contentType = parts[0].split(':')[1];
        raw = decodeURIComponent(parts[1]);

        return new Blob([raw], {type: contentType});
    }

    parts = dataURL.split(BASE64_MARKER);
    contentType = parts[0].split(':')[1];
    raw = window.atob(parts[1]);
    var rawLength = raw.length;

    var uInt8Array = new Uint8Array(rawLength);

    for (var i = 0; i < rawLength; ++i) {
        uInt8Array[i] = raw.charCodeAt(i);
    }

    return new Blob([uInt8Array], {type: contentType});
}