// Initialize your app
var myApp = new Framework7();

// Export selectors engine
var $$ = Dom7;

// Add views
var view1 = myApp.addView('#view-1', {
    // Because we use fixed-through navbar we can enable dynamic navbar
    dynamicNavbar: true
});
var view2 = myApp.addView('#view-2');
var view3 = myApp.addView('#view-3', {
    // Because we use fixed-through navbar we can enable dynamic navbar
    dynamicNavbar: true
});
var view4 = myApp.addView('#view-4');

$$('.ac-message').on('click', function () {
    var buttons1 = [
        {
            text: '请选择',
            label: true
        },
        {
            text: '同意',
        },
        {
            text: '不同意',
        }
    ];
    var buttons2 = [
        {
            text: '取消',
            color: 'red'
        }
    ];
    var groups = [buttons1, buttons2];
    myApp.actions(groups);
});


//模型加载基础设置
var BimMobleBdip = {   				//模型基础数据存储表
	view : null,      				//模型对象
	viewToolBar : null,				//模型按钮组
	button_viewpoint : null,		//涂鸦工具条按钮
	button_discuss : null,		//涂鸦工具条按钮
	button_panoram : null,			//360全景图按钮
	view_modelUrl : null,  			//模型存储路径
	lvmid : null,					//模型编号
	modelVersion : null,			//模型版本号
	createTreeData : null,			//我创建的树列表数据
	jointreeData : null,			//我参与的数树列表数据
	currentNodeData : null,			//当前节点数据
	lastNodeId : null,				//上一次节点Id
	lastNodeIdArr : null,			//历史点击
	currentNodeId : null,			//当前节点Id
	currentModelId : null,			//当前模型Id
	currentModelUrl : null,			//当前模型Url
	currentUserId : null,			//当前用户ID
	currentUserName : null,			//当前用户名字
	currentModelListF7:null,		//当前存放模型列表的framework7List对象
	treeTittle: null,				//树导航
	messageCenterData: null,		//消息中心数据
	messageCenterCount:null,		//未读消息条数
	currentMessageId:null,			//当前点击消息id
	currentMessageCustom:null,		//当前点击消息Custom
	messageCenterFlag:null,			//是否执行ajax请求
	activaCopy:null,				//激活复制
	ISCREATE : null,				//代表我创建的--常量
	ISJOIN : null,					//代表我参加的--常量
	NODETYPE : null,				//节点类型--常量
	listType: null,					//0未点击，1我创建的，2我参与的（判断返回按钮是否出现）
	JoinPelopleTreeId:null,			//用于操作参加人员时，临时用来保存TreeId
	isFirstHelp:null,				//是否是第一次加载帮助	
	chooseFile : null,				//tzw ===== 开始
	openPanorama : null,
	beVisible : null,
	beVisibleToPoint : null,			//判断视点Panel是否选中
	beVisibleToDiscuss : null,		//判断实时讨论Panel是否选中
	btnElement : null,				//获取资料上传按钮信息
	btnElementToPoint : null,		//获取视点保存按钮信息
	btnElementToDiscuss : null, //获取实时讨论按钮信息
	mobileViewer : null,
	beShow : null,
	mainPanel : null,					//视点保存Panel
	DiscussPanel : null,				//实时讨论Panel
	toolPanel : null,					//视点保存工具条Panel
	onceEdit : null,
	markup : null,	
	Toolbar : null,
	markup : null,
	treeNode : null,			//清除保存过的视点涂鸦
	count : null,  				//当点击新建视点时判断工具条出现次数
	showTool : null, 			//当点击视点时判断工具条出现次数
	tdUrl : null,
	isFromButton:false,
	isFromButtonToPoint:false,
	isFromButtonToDiscuss : false,
	dockingPanelNone : function (CancelPanel) {
		var markupClass = $("."+CancelPanel);
        if(markupClass && markupClass.length>0){
            for(var i = 0;i<markupClass.length;i++){
                var mark = markupClass[i];
                mark.style.display = "none";
                mark.remove();
            }
        }
	},				
	CancelSelectBox : function () {
		var selectboxClass = $(".selector-box");
        if(selectboxClass && selectboxClass.length>0){
            for(var i = 0;i<selectboxClass.length;i++){
                var mark = selectboxClass[i];
                mark.style.display = "none";
                mark.parentNode.remove();
            }
        }
	},										//tzw ===== 结束
	init : function () {			//初始化数据
		rightClick = false;// 关闭右键菜单 定义在viewer3D.js
		myApp.showIndicator();
		BimMobleBdip.ISCREATE = 'create';
		BimMobleBdip.ISJOIN = 'join';
		//BimMobleBdip.currentUserId = $("#userId").val();
		BimMobleBdip.currentUserId = "";
		BimMobleBdip.verifyUser();
		BimMobleBdip.createTreeData = [];
		BimMobleBdip.jointreeData = [];
		BimMobleBdip.currentNodeData = [];
		BimMobleBdip.lastNodeIdArr = [];
		BimMobleBdip.messageCenterData = [];
		BimMobleBdip.currentModelListF7={};
		BimMobleBdip.messageCenterCount = 0;
		BimMobleBdip.currentMessageId=0;
		BimMobleBdip.currentMessageCustom=0;
		BimMobleBdip.currentModelId=0;
		BimMobleBdip.listType = 0;
		BimMobleBdip.currentNodeId = 0;
		BimMobleBdip.JoinPelopleTreeId = 0;
		BimMobleBdip.treeTittle = "";
		BimMobleBdip.NODETYPE ="";
		BimMobleBdip.activaCopy = true;
		BimMobleBdip.modelVersion = 1;
		BimMobleBdip.isFirstHelp=true;
		BimMobleBdip.chooseFile = 0;				//tzw =====开始
		BimMobleBdip.openPanorama = true;  //判断全景图标记开启关闭
		BimMobleBdip.beVisible = false;
		BimMobleBdip.beVisibleToPoint = false;
		BimMobleBdip.beVisibleToDiscuss = false;
		BimMobleBdip.beVisible3D = false;
		BimMobleBdip.count = 0; 						//判断工具条出现次数
		BimMobleBdip.showTool = 0;      			//当点击视点时判断工具条出现次数
		BimMobleBdip.onceEdit = false;
		BimMobleBdip.beShow = false;			//tzw =====结束
		//BimMobleBdip.lastNodeId = 0;
		BimMobleBdip.viewToolBar = new Autodesk.Viewing.UI.ControlGroup("bimbdip_viewToolBar");
		BimMobleBdip.button_viewpoint = new Autodesk.Viewing.UI.Button("BimMobleBdip_button_viewpoint");
		BimMobleBdip.button_discuss = new Autodesk.Viewing.UI.Button("BimMobleBdip_button_discuss");
		BimMobleBdip.button_panoram = new Autodesk.Viewing.UI.Button("BimMobleBdip_button_panoram");
		//BimMobleBdip.loadTreeData();
	},
	loginOut : function(){
		//console.log("loginOut");
		writerFile('user/currentUser.json',"",function(){
			window.location.href="logins.html";
		},function(){
			window.location.href="logins.html";
		});//清空json文件中的内容
		
	},
	accountStatus:function(){
		//window.location.href="/bdip/baseModel/price";
		//view3.router.loadPage("accountStatus.html");
		titleNViewWebview(publicJS.tomcat_url+"/page/bdip/baseModel/price");
	},
	verifyUser : function (){
		//debugger;
		readerFile('user/currentUser.json',function(e){
			if(e.target.result == null || e.target.result == ""){
				plus.navigator.closeSplashscreen();
				BimMobleBdip.loginOut();
				return;
			}
			var currentUser = $.parseJSON(e.target.result);
			BimMobleBdip.currentUserId = currentUser.id;
			BimMobleBdip.currentUserName = currentUser.id;
			$("#userId").attr("value",BimMobleBdip.currentUserId);
			$("#identifier").attr("value",currentUser.identifier);
			$("#userHeadImage").attr("src",currentUser.headImage);
			$("#userName").attr("value",currentUser.name);
			$("#userEnterprise").attr("value",currentUser.enterprise);
			$("#userPosition").attr("value",currentUser.position);
			BimMobleBdip.getHomePage();
			BimMobleBdip.getMessageCenter();
			var countUserInfo = $("#countUserInfo").val();
			if(countUserInfo == "1"){
				// 统计用户信息
				var id = BimMobleBdip.currentUserId;
				$.ajax({
			 		url: publicJS.tomcat_url + "/user/countUserInfo?id="+id,
			 		type:'GET',
			 		data:{},
			 		dataType:'json',
			 		success : function(data){
			 			if(data.code == "200"){
			 				$("#countUserInfo").val("2");
			 			}
			 		},
			 		error:function(error){
			 		}
			 	});
			}
			plus.navigator.closeSplashscreen();
		},function(e){
			BimMobleBdip.loginOut();
		}) ;
		
	},
	modelLoad : function (name,id,baseUrl,url,tdid) {
		BimMobleBdip.modelName = name;
		//BimMobleBdip.currentModelUrl = url ;
		if(url=="" && av.isIOSDevice()){//2d图纸在IOS上不执行GEOMETRY_LOADED_EVENT
			
		}else{
			//myApp.showIndicator();
		}
		BimMobleBdip.currentModelId = id ;
		if(baseUrl == undefined || baseUrl == null ||  baseUrl == ""){
			//myApp.alert('模型上传中...','BDIP ');
			myApp.addNotification({
			    message: '模型上传中...',
			    hold:1500,
			    closeIcon:false,
			    closeOnClick:true,
			    additionalClass:"notification-li-custom notification-li-custom-success"
			});
			//myApp.hideIndicator();
			return;
		}
		var httpUrl = "";
		if(baseUrl=='test' && url=='test'){
			httpUrl = "http://cloud.bimbdip.com/models/firstShowModel/Resource/____/_3D_ 154947/_3D_.svf";
		}else{
			if(url == "" && tdid ==""){
				myApp.hideIndicator();
				console.log("模型路径不通");
				//$("#viewer").html("<p>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;模型路径出错</p>")
				myApp.addNotification({
		    		message: '模型路径出错',
		    	    hold:1500,
		    	    closeIcon:false,
		    	    closeOnClick:true,
		    	    additionalClass:"notification-li-custom notification-li-custom-error"
		    	});
				return;
			}else if(url == "" && tdid !=""){
				httpUrl = tdid;
			}else{
				httpUrl = url;
				//httpUrl ="http://cloud.bimbdip.com/models/firstShowModel/Resource/____/_3D_ 154947/_3D_.svf";
			}
		}
		if(!BimMobleBdip.checkLocalUrl(httpUrl)){
			//myApp.hideIndicator();
			console.log("模型路径不通");
			//$("#viewer").html("<p>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;模型路径出错</p>")
			myApp.addNotification({
	    		message: '模型路径出错',
	    	    hold:1500,
	    	    closeIcon:false,
	    	    closeOnClick:true,
	    	    additionalClass:"notification-li-custom notification-li-custom-error"
	    	});
			return;
		}
		view1.router.loadPage("model.html");//跳转到加载模型页面
		setTimeout(function(){
			console.log(httpUrl);
			BimMobleBdip.currentModelUrl = httpUrl;   //tzw
			var docs3D =[{"path":httpUrl,"name":"三维"}];
			var BimMobleBdipViewConfig = {
		        disabledExtensions: {
		            measure: false,
		            section: false,
		        },
		        memory: {
		            limit: 32 * 1024    //32 GB
		        }
			};
		    var options3D ={ 'docid': docs3D[0].path, 
			     env: 'Local',
				 offline: 'true',
				 useADP: false	 } ;
		    $("#viewer").html("");
		    BimMobleBdip.view = new Autodesk.Viewing.Private.GuiViewer3D ($("#viewer")[0], BimMobleBdipViewConfig) ; // With toolbar
		    Autodesk.Viewing.Initializer (options3D, function () {
		    	//BimMobleBdip.view.initialize () ;
		    	BimMobleBdip.view.start() ;
		    	BimMobleBdip.view.load (options3D.docid, undefined, BimMobleBdip.onLoadSuccess, BimMobleBdip.onLoadError) ;
		    	BimMobleBdip.view.loadExtension("MyUIExtension");
		    	BimMobleBdip.creatViewButton();
		    	$("#model-title").html(name);
		    	if(url=="" && av.isIOSDevice()){//2d图纸在IOS上不执行GEOMETRY_LOADED_EVENT
		    		setTimeout(function() {
	    		    	//myApp.hideIndicator();
	    		    	//全景图标记
	    		    	$("#bimbdip_viewToolBar").show();//防止按钮不加载
	    		    	$("toolbar-sectionTool").show();//防止按钮不加载
	    		    	DiscussMobile.loadMessageModelInView1Chat();//通过实时讨论消息进入模型，需加载点，是否加载的逻辑由此方法判断
					}, 1000);
	    		}else{
	    			BimMobleBdip.view.addEventListener (Autodesk.Viewing.GEOMETRY_LOADED_EVENT, function (event) {
			    		//BimMobleBdip.view.fitToView (true) ;
			    		//BimMobleBdip.view.setGhosting(false);
			        	//myApp.hideIndicator();
			        	$("#bimbdip_viewToolBar").show();//防止按钮不加载
			        	$("toolbar-sectionTool").show();//防止按钮不加载
			        	DiscussMobile.loadMessageModelInView1Chat();//通过实时讨论消息进入模型，需加载点，是否加载的逻辑由此方法判断
			    	}) ; 
	    		}
		    	BimMobleBdip.view.addEventListener("selection",function (event){
		    		_ocurSelSet=event.dbIdArray;
		    	});
		    }) ;
		},500);
	},
	onLoadSuccess:function(event) {
        console.log('success');
    },
    onLoadError :function(event) {
        console.log('fail');
    },
	//加载按钮到模型上
	creatViewButton : function () {
		var urlIndex = BimMobleBdip.currentModelUrl.lastIndexOf("."); 
		var type = BimMobleBdip.currentModelUrl.substr(urlIndex);
		BimMobleBdip.setUp_button_viewpoint();
		BimMobleBdip.setUp_button_discuss();
		BimMobleBdip.setUp_button_panorama();
		BimMobleBdip.viewToolBar.addControl(BimMobleBdip.button_viewpoint);
		if(type == '.f2d'){//tzw
			//console.log("2D图纸无全景图");
			BimMobleBdip.viewToolBar.removeControl(BimMobleBdip.button_panoram);
			BimMobleBdip.viewToolBar.removeControl(BimMobleBdip.button_discuss);
		}else{
			BimMobleBdip.viewToolBar.addControl(BimMobleBdip.button_panoram);
			BimMobleBdip.viewToolBar.addControl(BimMobleBdip.button_discuss);
		}
		BimMobleBdip.view.toolbar.addControl(BimMobleBdip.viewToolBar);
	},
	setUp_button_viewpoint : function () {
		BimMobleBdip.button_viewpoint.setIcon("viewpoint-play");
		BimMobleBdip.button_viewpoint.setToolTip("视点保存");
		BimMobleBdip.button_viewpoint.onClick = function(e) {
			//bimViewPoint.viewpoint_load();
			BimMobleBdip.toggleVisibilityForViewPoint();
			//BimMobleBdip.showMarkup();
		}
	},
	setUp_button_discuss : function () {
		BimMobleBdip.button_discuss.setIcon("discuss-play");
		BimMobleBdip.button_discuss.setToolTip("实时讨论");
		BimMobleBdip.button_discuss.onClick = function(e) {
			BimMobleBdip.toggleVisibilityForDiscuss();
			//DiscussMobile.findAllPoint();
		}
	},
	toggleVisibilityForDiscuss : function(){  //实时讨论
		BimMobleBdip.setVisibleForDiscuss(!BimMobleBdip.beVisibleToDiscuss);
	},
	toggleVisibilityForViewPoint : function(){ //视点保存
		BimMobleBdip.setVisibleForMarkup(!BimMobleBdip.beVisibleToPoint);
	},
	setUp_button_panorama : function(){
		BimMobleBdip.button_panoram.setIcon("panorama-play");
		BimMobleBdip.button_panoram.setToolTip("资料管理");
		BimMobleBdip.button_panoram.onClick = function(e) {
			if(BimMobleBdip.openPanorama == true){
				mobilePanorama.toggleVisibilityForPanorama();
				BimMobleBdip.openPanorama = false;
			}else{
				mobilePanorama.toggleVisibilityForPanorama();
			}
		}
	},
	loadTreeData : function(s){ //加载树列表数据
		if(s == BimMobleBdip.ISCREATE){
			$.ajax({
	            type: "GET",
	            url: publicJS.tomcat_url+"/modeltree/getAllChildTreeNodeByUserId?userId="+BimMobleBdip.currentUserId,
	            dataType: "json",
	            async: false,
	            success: function(data){
	               if(data.code == 200){
	            	   BimMobleBdip.treeData = data.data;
	               }
	            },
	            error: function(data){
	                //myApp.alert('获取数据失败，检查网络后重试','BDIP');
	                myApp.addNotification({
	                    message: '获取数据失败，检查网络后重试',
	                    hold:1500,
	                    closeIcon:false,
	                    closeOnClick:true,
	                    additionalClass:"notification-li-custom notification-li-custom-error"
	                });
	            }
	        });
		}else if (s == BimMobleBdip.ISJOIN){
			$.ajax({
	            type: "GET",
	            url: publicJS.tomcat_url+"/modeltree/getSharedModel?participantId="+BimMobleBdip.currentUserId+"&enable=1&participantStatus=1&progress=pass",
	            dataType: "json",
	            async: false,
	            success: function(data){
	               if(data.code == 200){
	            	   BimMobleBdip.treeData = data.data;
	               }
	            },
	            error: function(data){
	                //myApp.alert('获取数据失败，检查网络后重试','BDIP');
	                myApp.addNotification({
	                    message: '获取数据失败，检查网络后重试',
	                    hold:1500,
	                    closeIcon:false,
	                    closeOnClick:true,
	                    additionalClass:"notification-li-custom notification-li-custom-error"
	                });
	            }
	        });
		}
		
	},
	getMyCreateCurrentNode : function (){ 	//我创建的
		myApp.showIndicator();
		BimMobleBdip.listType = 1 ;
		BimMobleBdip.currentNodeId=BimMobleBdip.ISCREATE;
		BimMobleBdip.NODETYPE = BimMobleBdip.ISCREATE;
		BimMobleBdip.loadTreeData(BimMobleBdip.ISCREATE);
		BimMobleBdip.lastNodeIdArr = [];
		BimMobleBdip.treeTittle ="";
		BimMobleBdip.getCurrentNode(0,true,"我创建的"); //获取根节点数据
		
	},
	getMyjoinCurrentNode : function (){	//我参与的
		myApp.showIndicator();
		BimMobleBdip.listType = 2 ;
		BimMobleBdip.currentNodeId=BimMobleBdip.ISJOIN;
		BimMobleBdip.NODETYPE = BimMobleBdip.ISJOIN;
		BimMobleBdip.loadTreeData(BimMobleBdip.ISJOIN);
		BimMobleBdip.lastNodeIdArr = [];
		BimMobleBdip.treeTittle ="";
		BimMobleBdip.getCurrentNode(0,true,"我参与的"); //获取根节点数据
	},
	getCurrentNode : function (id,flag,currentName){ //获取当前节点数据  id:节点id;flag:判断是进步(true)还是退步(false);currentName：当前节点名称
		var data = BimMobleBdip.treeData;
		if(data == null || data == undefined){
			myApp.hideIndicator();
			return; 
		}
		if(flag){
			BimMobleBdip.lastNodeIdArr.push(BimMobleBdip.currentNodeId);
			BimMobleBdip.treeTittle = BimMobleBdip.treeTittle + "/" + currentName;
		}else{
			// = BimMobleBdip.treeTittle + "/" + currentName;
			var index = BimMobleBdip.treeTittle.lastIndexOf("\/");  
			BimMobleBdip.treeTittle  = BimMobleBdip.treeTittle .substring(0,index);
		}
		$("#main-block-title").html(BimMobleBdip.treeTittle);
		BimMobleBdip.currentNodeId = id ;
		BimMobleBdip.currentNodeData = [];
		var j = 0 ;
		for(var i = 0 ; i < data.length ; i++){
			if(data[i].pId == id){
				//BimMobleBdip.treeRootData.add(data[i]);
				BimMobleBdip.currentNodeData[j]=data[i];
				j++;
			}
		}
		//$("#list-block-virtual-list").html("");
		BimMobleBdip.renderTreePage(BimMobleBdip.currentNodeData);
	},
	renderTreePage : function (data){ //渲染树首页
		//判断返回键是否出现
		if(BimMobleBdip.listType!=0){
			$("#btn_back1").show();
			$("#btn_operation").show();
		}else{
			$("#btn_back1").hide();
			$("#btn_operation").hide();
		}
		
		if(data==""){
			$("#no-content-msg").show();
		}else{
			$("#no-content-msg").hide();
		}
		
		//渲染页面
		BimMobleBdip.currentModelListF7 = myApp.virtualList('.list-block.virtual-list', {
			items : data,
		    // Custom render function to render item's HTML
		    renderItem: function (index,item) {
		    	var s = '';
		    		s+=	'<li class="swipeout" id="model-list-id-'+item.id+'">';
		    		//普通元素开始
		    		s+=	'<div class="swipeout-content">';
		    		if(item.type == 0 ){ //文件夹
		    			s+=		'<a href="#" onclick="BimMobleBdip.getCurrentNode('+item.id+','+true+',\''+item.name+'\')"  class="item-link">';
		    		}else if(item.type == 1){ //文件
		    			s+=		'<a href="#" onclick="offlineManager.modelLoadBefore(\''+item.name+'\',\''+item.id+'\',\''+item.baseUrl+'\',\''+item.url+'\',\''+item.tdid+'\')"  class="item-link">';
		    		}else if(item.type == BimMobleBdip.ISCREATE){ //我创建的
		    			s+=		'<a href="#" onclick="BimMobleBdip.getMyCreateCurrentNode()"  class="item-link">';
		    		}else if(item.type == BimMobleBdip.ISJOIN){ //我参与的
		    			s+=		'<a href="#" onclick="BimMobleBdip.getMyjoinCurrentNode()"  class="item-link">';
		    		}else{	
		    			s+=		'<a href="#" class="item-link">';
		    		}
					s+=		'<div class="item-content">';
		    		s+=			'<div class="item-media">';
		    		if(item.type == 0 ){ //文件夹
		    			s+=				'<i class="icon item-media-icon-folder"></i>';
		    		}else if(item.type == 1){ //文件
		    			s+=				'<i class="icon item-media-icon-model"></i>';
		    		}else{	
		    			s+=				'<i class="icon item-media-icon-folder"></i>';
		    		}
		    		s+=			'</div>';
		    		s+=			'<div class="item-inner">'
		    		s+=			'<div class="item-title">'+item.name+'</div>';
		    		if(item.type == 0 && BimMobleBdip.NODETYPE == BimMobleBdip.ISCREATE){ //我创建的文件夹 
		    			s+= '<div class="item-after">';
			    		s+= 	'<i onclick="BimMobleBdip.btnGetJoinPelopleByTreeId('+item.id+')" class="icon item-media-icon-xzz"></i>';
			    		s+= 	'<i onclick="BimMobleBdip.btnCreateNewBimModelTreeShareUrl('+item.id+','+item.pId+')" class="icon item-media-icon-fx"></i>';
			    		s+= '</div>';
		    		}else if(item.type == 1 && BimMobleBdip.NODETYPE == BimMobleBdip.ISCREATE){ //我创建的模型
		    			s+= '<div class="item-after">';
			    		s+= 	'<i onclick="BimMobleBdip.btnCreateBimModelShareUrl('+item.id+')" class="icon item-media-icon-fx"></i>';
			    		s+= '</div>';
		    		}else if(item.type == 0 && BimMobleBdip.NODETYPE == BimMobleBdip.ISJOIN && BimMobleBdip.currentNodeId==0){ //我参与的文件夹并且是第一层
		    			s+= '<div class="item-after">';
			    		s+= 	'<i onclick="BimMobleBdip.btnLogOffShare('+item.id+')" class="icon item-media-icon-tc"></i>';
			    		s+= '</div>';
		    		}
		    		s+=			'</div>';
		    		s+=		'</div>';
		    		s+=		'</a>';
		    		s+=	'</div>';
		    		//普通元素结束
		    		if(item.type == 0 && BimMobleBdip.NODETYPE == BimMobleBdip.ISCREATE){ //我创建的文件夹 
		    			s+=		'<div class="swipeout-actions-left">';
			    		s+=			'<a class="swipeout-close bg-lightblue open-popup " data-popup=".popup-joinpeople" onclick="BimMobleBdip.getJoinPelopleByTreeId('+item.id+')" href="#">协作者</a>';
			    		s+=		'</div>';
			    		s+=		'<div class="swipeout-actions-right">';
			    		//s+=			'<a class="swipeout-close bg-orange" href="#">重命名</a>';
			    		//s+=			'<a class="swipeout-close bg-red" href="#">删除</a>';
			    		s+=			'<a class="swipeout-close bg-green open-popup " data-popup=".popup-share" onclick="BimMobleBdip.createNewBimModelTreeShareUrl('+item.id+','+item.pId+')"  href="#">邀请</a>';
			    		s+=		'</div>';
		    		}else if(item.type == 1 && BimMobleBdip.NODETYPE == BimMobleBdip.ISCREATE){ //我创建的模型
		    			s+=		'<div class="swipeout-actions-right">';
			    		//s+=			'<a class="swipeout-close bg-orange" href="#">重命名</a>';
			    		//s+=			'<a class="swipeout-close bg-red" href="#">删除</a>';
			    		s+=			'<a class="swipeout-close bg-green open-popup " data-popup=".popup-share" onclick="BimMobleBdip.createBimModelShareUrl('+item.id+')"  href="#">分享</a>';
			    		s+=		'</div>';
		    		}else if(item.type == 0 && BimMobleBdip.NODETYPE == BimMobleBdip.ISJOIN && BimMobleBdip.currentNodeId==0){ //我参与的文件夹并且是第一层
		    			s+=		'<div class="swipeout-actions-right">';
			    		s+=			'<a class="swipeout-close bg-red"  onclick="BimMobleBdip.logOffShare('+item.id+')"  href="#">退出协作</a>';
			    		s+=		'</div>';
		    		}
		    		//右结束
		    		s+=	'</li> '
		        return 	s
		    },
		    searchAll: function (query, items) {
		        var foundItems = [];
		        for (var i = 0; i < items.length; i++) {
		            if (items[i].name.indexOf(query.trim()) >= 0) foundItems.push(i);
		        }
		        return foundItems; 
		    }
		});
		myApp.hideIndicator();
	},
	btnGetJoinPelopleByTreeId:function(id){
		var event = window.event || arguments.callee.caller.arguments[0]; 
		event.stopPropagation();
		event.preventDefault();
		myApp.popup(".popup-joinpeople");
		BimMobleBdip.getJoinPelopleByTreeId(id);
	},
	btnCreateNewBimModelTreeShareUrl:function(id,pid){
		var event = window.event || arguments.callee.caller.arguments[0];
		event.stopPropagation();
		event.preventDefault();
		myApp.popup(".popup-share");
		BimMobleBdip.createNewBimModelTreeShareUrl(id,pid);
	},
	btnCreateBimModelShareUrl:function(id){
		var event = window.event || arguments.callee.caller.arguments[0];
		event.stopPropagation();
		event.preventDefault();
		myApp.popup(".popup-share");
		BimMobleBdip.createBimModelShareUrl(id);
	},
	btnLogOffShare:function(id){
		var event = window.event || arguments.callee.caller.arguments[0];
		event.stopPropagation();
		event.preventDefault();
		BimMobleBdip.logOffShare(id);
	},
	getLastNode : function (){
		if(BimMobleBdip.lastNodeIdArr.length > 1){
			BimMobleBdip.getCurrentNode(BimMobleBdip.lastNodeIdArr[BimMobleBdip.lastNodeIdArr.length-1],false);
			BimMobleBdip.lastNodeIdArr.pop();
		}else{
			BimMobleBdip.getHomePage();
		}
		
	},
	getHomePage : function (){
		BimMobleBdip.lastNodeIdArr = [];
		BimMobleBdip.listType = 0;
		BimMobleBdip.treeTittle ="";
		$("#main-block-title").html(BimMobleBdip.treeTittle);
		var items= [
	        {
	        	name: '我创建的',
	            id: 0,
	            type:'create'
	        },
	        {
	        	name: '我参与的',
	        	id: 0,
	        	type:'join'
	        }
	    ]
		BimMobleBdip.renderTreePage(items);
	},
	logOffShare : function (treeid){ // 退出协作
		//alert(treeid);
		myApp.confirm("是否确认退出协作？","BDIP",function(){
			$.ajax({
	            type: "GET",
	            url: publicJS.tomcat_url+"/modeltreeshare/logOffShareByTreeIdAndParId?treeId="+treeid+"&participantId="+BimMobleBdip.currentUserId,
	            dataType: "json",
	            async: false,
	            success: function(data){
	            	if(data.code==200){
	            		BimMobleBdip.getMyjoinCurrentNode();
	            		myApp.addNotification({
	    					message: '退出成功',
	    				    hold:1500,
	    				    closeIcon:false,
	    				    closeOnClick:true,
	    				    additionalClass:"notification-li-custom notification-li-custom-success"
	    				});
	            	}else{
	            		myApp.addNotification({
	    					message: '退出失败,请重试',
	    				    hold:1500,
	    				    closeIcon:false,
	    				    closeOnClick:true,
	    				    additionalClass:"notification-li-custom notification-li-custom-error"
	    				});
	            	}
	            },
	            error: function(data){
	            	myApp.addNotification({
    					message: '退出失败,请重试',
    				    hold:1500,
    				    closeIcon:false,
    				    closeOnClick:true,
    				    additionalClass:"notification-li-custom notification-li-custom-error"
    				});
	            }
	        });
		});
	},
	modelBack:function(){ //模型返回按钮 点击事件,需初始化模型加载页面
		myApp.hideIndicator(); 
		$("#viewer").html("");
		BimMobleBdip.view = null ;
	},
	createBimModelShareUrl:function(id){ //在模型列表分享模型
		$("#qrcode").html("");
		$("#model-tree-share-url").html("");
		var date = new Date().valueOf();
		var tempUrl = "/bdip/modeltool/sharepoint/sharePoint2?treeID="+id+"&s="+date;
		var surl = BimMobleBdip.getMoblieShortUrl(tempUrl);
		$("#model-tree-share-url").html("我分享了来自BDIP-简约版的模型，点击查看："+surl);
		var qrcode = new QRCode(document.getElementById("qrcode"), {
	        width : 200,//设置宽高
	        height : 200
	    });
		qrcode.makeCode(surl);
		//激活复制
		var clipboard = null
		if(BimMobleBdip.activaCopy){
			clipboard = new Clipboard('.g-share-copy');
			clipboard.on('success', function(e) {
				//myApp.alert('复制成功','BDIP');
				myApp.addNotification({
					message: '复制成功',
				    hold:1500,
				    closeIcon:false,
				    closeOnClick:true,
				    additionalClass:"notification-li-custom notification-li-custom-success"
				});
       	   	});
       	   	clipboard.on('error', function(e) {
   	   			console.log(e);
       	   	});
       	   	BimMobleBdip.activaCopy=false
		}	
		
		BimMobleBdip.shareIconIsShow({
			"content": "我分享了来自BDIP-简约版的模型，点击查看",
			"href": surl			
		});
//		BimMobleBdip.shareEvent({
//			"content": "我分享了来自BDIP-简约版的模型，点击查看：",
//			"href": surl
//		})
	},
	createNewBimModelTreeShareUrl : function(id,pid){ //在模型列表分享文件夹
		$.ajax({
            type: "POST",
            url: publicJS.tomcat_url+"/modeltreeshareurl/createNewBimModelTreeShareUrl?hostId="+BimMobleBdip.currentUserId+"&treeId="+id+"&enable=1&parentId="+pid,
            dataType: "json",
            async: false,
            success: function(data){
            	$("#qrcode").html("");
				$("#model-tree-share-url").html("");
				$("#btn-cancel-share").show();
				$('#btn-cancel-share').unbind("click"); //移除点击事件
				$('#input-share-checkbox').unbind("change"); //移除点击事件
				$(".share-message-title-approve").show();
				$(".switch-body-custom").show();
        		if(data.code == 200){
					var _data = data.data;
					$("#btn-cancel-share").click(function(){ //重新绑定点击事件
						BimMobleBdip.cancelShare(_data.id);
					});
					if(_data.remark=="apply"){
						$("#input-share-checkbox").get(0).checked = true;
					}else{
						$("#input-share-checkbox").get(0).checked = false;
					}
					$("#input-share-checkbox").change(function(){
					    if($("#input-share-checkbox").prop("checked")){
					        //当前为选中状态
					    	BimMobleBdip.isNeedApproval(_data.id,"apply");
					    }else{
					        //当前为不选中状态
					    	BimMobleBdip.isNeedApproval(_data.id,"pass");
					    }
					});
					$("#model-tree-share-url").html("我分享了来自BDIP-简约版的模型文件夹，点击查看："+_data.shareUrl);
					//$("#model-tree-share-url").val(_data.shareUrl);
					var qrcode = new QRCode(document.getElementById("qrcode"), {
            	        width : 200,//设置宽高
            	        height : 200
            	    });
					qrcode.makeCode(_data.shareUrl);
					//激活复制
					var clipboard = null
					if(BimMobleBdip.activaCopy){
            			clipboard = new Clipboard('.g-share-copy');
            			clipboard.on('success', function(e) {
            				//myApp.alert('复制成功','BDIP');
            				myApp.addNotification({
            					message: '复制成功',
            				    hold:1500,
            				    closeIcon:false,
            				    closeOnClick:true,
            				    additionalClass:"notification-li-custom notification-li-custom-success"
            				});
	               	   	});
	               	   	clipboard.on('error', function(e) {
               	   			console.log(e);
	               	   	});
	               	   	BimMobleBdip.activaCopy=false
					}	
            	   
        		}else{
        			//myApp.alert('获取数据失败，检查网络后重试','BDIP');
        			myApp.addNotification({
	                    message: '获取数据失败，检查网络后重试',
	                    hold:1500,
	                    closeIcon:false,
	                    closeOnClick:true,
	                    additionalClass:"notification-li-custom notification-li-custom-error"
	                });
        		}
        		
        		BimMobleBdip.shareIconIsShow({
					"content": "我分享了来自BDIP-简约版的模型文件夹，点击查看",
					"href": _data.shareUrl
        		});
//      		BimMobleBdip.shareEvent({
//					"content": "我分享了来自BDIP-简约版的模型文件夹，点击查看：",
//					"href": _data.shareUrl
//				})
            },
            error: function(data){
            	$("#qrcode").html("");
				$("#model-tree-share-url").html("");
				$('#btn-cancel-share').unbind("click"); //移除点击事件
				$('#input-share-checkbox').unbind("change"); //移除点击事件
                //myApp.alert('获取数据失败，检查网络后重试','BDIP');
				myApp.addNotification({
                    message: '获取数据失败，检查网络后重试',
                    hold:1500,
                    closeIcon:false,
                    closeOnClick:true,
                    additionalClass:"notification-li-custom notification-li-custom-error"
                });
            }
        });
		
	},
	isNeedApproval:function(id,remark){ //是否需要审批
		$.ajax({
			url:publicJS.tomcat_url + "/modeltreeshareurl/updateUrlRemark?id="+id+"&remark="+remark,
			type:"GET",
			success:function(){
				myApp.addNotification({
                    message: '操作成功',
                    hold:1500,
                    closeIcon:false,
                    closeOnClick:true,
                    additionalClass:"notification-li-custom notification-li-custom-success"
                });
			},
			error:function(){
				myApp.addNotification({
                    message: '操作失败',
                    hold:1500,
                    closeIcon:false,
                    closeOnClick:true,
                    additionalClass:"notification-li-custom notification-li-custom-error"
                });
			}
		})
	},
	cancelShare :function(id){//取消分享
		//http://localhost:9180/bim-bdip-cloud-home-biz-web/modeltreeshareurl/expireBimModelTreeShareUrlById?id=269
		myApp.confirm('取消后他人无法再通过连接请求加入协作，重新点击邀请使连接生效。','是否取消分享？',
			function () {
				myApp.showIndicator();
				//alert(id);
				$.ajax({  
					url:publicJS.tomcat_url+"/modeltreeshareurl/expireBimModelTreeShareUrlById?id="+id,  
			 		type : 'get',
			 		async: false,
			 		success: function(data){
			 			myApp.hideIndicator();
			 			myApp.addNotification({
			 		        message: '取消成功',
			 		        hold:1500,
			 		        closeIcon:false,
			 		        closeOnClick:true,
			 		        additionalClass:"notification-li-custom notification-li-custom-success"
			 		    });
			 			myApp.closeModal(".popup-share");
			 		},
			 		error: function(data){
			 			//myApp.alert('获取数据失败，检查网络后重试','BDIP');
			 			myApp.addNotification({
    	                    message: '获取数据失败，检查网络后重试',
    	                    hold:1500,
    	                    closeIcon:false,
    	                    closeOnClick:true,
    	                    additionalClass:"notification-li-custom notification-li-custom-error"
    	                });
		            }
				});
		  	}
		);
	},
	getJoinPelopleByTreeId:function(id){
		$.ajax({
            type: "GET",
            url: publicJS.tomcat_url+"/modeltreeshare/getParticipantByTreeId?treeId="+id+"&enable=1",
            dataType: "json",
            async: false,
            success: function(data){
               if(data.code == 200){
            	   BimMobleBdip.JoinPelopleTreeId = id;
            	   var _data = data.data;
            	   var s = '';
            	   var j = 0 ;
            	   var i = 0 ;
            	   if(_data!=""){
	            	   for(i=0;i<_data.length ; i++){
	            		   if(_data[i].progress=='pass'){
					    		s += '<li>';
					    		s += 	'<label class="label-radio item-content">';
					    		if(i == 0 ){
					    			s += 	'<input type="radio" name="joinpeople-radio" value="'+_data[i].id+'" checked="checked">';
					    		}else{
					    			s += 	'<input type="radio" name="joinpeople-radio" value="'+_data[i].id+'">';
					    		}
					    		s += 		'<div class="item-media">';
					    		s += 			'<i class="icon icon-form-radio"></i>';
					    		s += 		'</div>';
					    		s += 		'<div class="item-inner">';
					    		s += 			'<div class="item-title">'+_data[i].participantName+'</div>';
					    		s += 		'</div>';
					    		s += 	'</label>';
					    		s += '</li>';
	            		   }else{
	            			   j++
	            		   }
	            	   }
	            	   if(i == j){
	            		   s='<p>该节点无协同人员</p>';
	            		   $("#btn-delete-join-pelople-by-treeId").hide();
	            	   }else{
	            		   $("#btn-delete-join-pelople-by-treeId").show();
	            	   }
            	   }else{
            		   s='<p>该节点无协同人员</p>';
            		   $("#btn-delete-join-pelople-by-treeId").hide();
            	   }
            	   $("#joinpeople-list").html(s);
               }
            },
            error: function(data){
                //myApp.alert('获取数据失败，检查网络后重试','BDIP');
            	myApp.addNotification({
                    message: '获取数据失败，检查网络后重试',
                    hold:1500,
                    closeIcon:false,
                    closeOnClick:true,
                    additionalClass:"notification-li-custom notification-li-custom-error"
                });
            }
        });
	},
	deleteJoinPelopleByTreeId:function(){
		var id = $("input[name='joinpeople-radio']:checked").val();
		$.ajax({
            type: "POST",
            url: publicJS.tomcat_url+"/modeltreeshare/updateBimModelTreeShare?id="+id+"&progress=refuse",
            dataType: "json",
            async: false,
            success: function(data){
               if(data.code == 200){
            	   BimMobleBdip.getJoinPelopleByTreeId(BimMobleBdip.JoinPelopleTreeId);
            	   //myApp.alert('删除成功','BDIP');
            	   myApp.addNotification({
            			message: '删除成功',
            		    hold:1500,
            		    closeIcon:false,
            		    closeOnClick:true,
            		    additionalClass:"notification-li-custom notification-li-custom-success"
            		});
               }   
            },
            error: function(data){
                //myApp.alert('获取数据失败，检查网络后重试','BDIP');
            	myApp.addNotification({
                    message: '获取数据失败，检查网络后重试',
                    hold:1500,
                    closeIcon:false,
                    closeOnClick:true,
                    additionalClass:"notification-li-custom notification-li-custom-error"
                });
            }
        });
	},
	getMessageCenter:function(){ //获取消息中心的消息
		var limitsData = [];
		var discussionData = [];
		var length = 0 ;
		$.ajax({ //模型分享
            type: "GET",
            url: publicJS.tomcat_url+"/message/search_receiver_messages?receiveId="+BimMobleBdip.currentUserId+"&messageType=modelUrlShare",
            dataType: "json",
            async: false,
            success: function(data){
               if(data.code == 200){
            	   limitsData = data.data;
            	   length = length + data.data.length;
               }
            },
            error: function(data){
                //myApp.alert('获取数据失败，检查网络后重试','BDIP');
            	myApp.addNotification({
                    message: '获取数据失败，检查网络后重试',
                    hold:1500,
                    closeIcon:false,
                    closeOnClick:true,
                    additionalClass:"notification-li-custom notification-li-custom-error"
                });
            }
        });
		$.ajax({ //实时讨论
            type: "GET",
            url: publicJS.tomcat_url+"/message/search_receiver_messages?receiveId="+BimMobleBdip.currentUserId+"&messageType=DISCUSS",
            dataType: "json",
            async: false,
            success: function(data){
               if(data.code == 200){
            	   discussionData = data.data;
            	   length = length + data.data.length;
               }
            },
            error: function(data){
                //myApp.alert('获取数据失败，检查网络后重试','BDIP');
            	myApp.addNotification({
                    message: '获取数据失败，检查网络后重试',
                    hold:1500,
                    closeIcon:false,
                    closeOnClick:true,
                    additionalClass:"notification-li-custom notification-li-custom-error"
                });
            }
        });
		$.ajax({ //新手帮助
            type: "GET",
            url: publicJS.tomcat_url+"/message/search_receiver_messages?receiveId="+BimMobleBdip.currentUserId+"&messageType=welcomeMobile",
            dataType: "json",
            async: false,
            success: function(data){
               if(data.code == 200 && data.data.length>0){ 
            	   BimMobleBdip.popupHelp();
            	   BimMobleBdip.messageCenterUpdateReadStatus(data.data[0].id);//更新消息为已读
               }
            },
            error: function(data){
                //myApp.alert('获取数据失败，检查网络后重试','BDIP');
            	myApp.addNotification({
                    message: '获取数据失败，检查网络后重试',
                    hold:1500,
                    closeIcon:false,
                    closeOnClick:true,
                    additionalClass:"notification-li-custom notification-li-custom-error"
                });
            }
        });
		BimMobleBdip.renderMessageCenterPage(limitsData,discussionData,length);
	},
	renderMessageCenterPage:function(limitsData,discussionData,count){
		if(limitsData.length == 0 && discussionData.length == 0){
			$("#no-message-msg").show();
		}
		//拼接
		var s = '';
		if(limitsData.length == 0){
			$(".message-ceneter-limits").hide();
		}else{
			$(".message-ceneter-limits").show();
			$("#no-message-msg").hide();
			for(var i=0;i<limitsData.length;i++){
				var time  = getDateTime(limitsData[i].createTime);
				s +=	'<li>' ;
				s +=	'<a href="#" onclick = "BimMobleBdip.setCurrentMessageId('+limitsData[i].id+',\''+limitsData[i].subject+'\',\''+limitsData[i].content+'\',\''+limitsData[i].custom+'\',\''+time+'\')" class="item-link item-content ac-message open-popup" data-popup=".popup-message" >';  //onclick="BimMobleBdip.setCurrentMessageId('+item.id+')" 
		    	s +=  		'<div class="item-inner">' ;
		    	s +=      		'<div class="item-title"><b style="color:red;">'+limitsData[i].subject+'</b>申请加入<b style="color:red;">'+limitsData[i].content+'</b>-<b>'+time+'</b></div>' ;
		    	s +=  		'</div>' ;
		    	s +=	'</a>';
		    	s +=	'</li>';
			}
		}
		//渲染
		$("#main-message-list").html(s);
		
		//拼接
		var ss = '';
		if(discussionData.length == 0){
			//s +='<li class="item-content"><p id="no-message-msg">&nbsp;&nbsp;&nbsp;暂无消息</p></li>';
			$(".message-ceneter-discussion").hide();
		}else{
			$(".message-ceneter-discussion").show();
			$("#no-message-msg").hide();
			for(var i=0;i<discussionData.length;i++){
				var time  = getDateTime(discussionData[i].createTime);
				ss +=	'<li>' ;
				ss +=	'<a href="#" onclick = "BimMobleBdip.loadMessageModel('+discussionData[i].id+',\''+discussionData[i].discussId+'\',\''+discussionData[i].custom+'\',\''+discussionData[i].treeId+'\')" class="item-link item-content ac-message">';  //onclick="BimMobleBdip.setCurrentMessageId('+item.id+')" 
		    	ss +=  		'<div class="item-inner">' ;
		    	ss +=      		'<div class="item-title">模型实时讨论更新-<b>'+time+'</b></div>' ;
		    	ss +=  		'</div>' ;
		    	ss +=	'</a>';
		    	ss +=	'</li>';
			}
		}
		//渲染
		$("#main-message-discussion").html(ss);
		
		if(count==0){
			$("#message-ceneter-count").hide();
		}else{
			$("#message-ceneter-count").show();
			$("#message-ceneter-count").html(count);
		}
	},
	setCurrentMessageId:function(id,subject,content,custom,time){
		BimMobleBdip.currentMessageId = id;
		$("#message-subject").html("模型协作申请");
		if(custom == "1"){
			BimMobleBdip.currentMessageCustom = id;
			$("#message-center-agree").hide();
			$("#message-center-disagree").hide();
			$("#message-center-ok").show();
			$("#message-content").html("<b style='color:red;'>"+subject+"</b>申请加入<b style='color:red;'>"+content+"</b>，请知晓。<P><b>"+time+"</b></p>");
		}else{
			BimMobleBdip.currentMessageCustom = custom;
			$("#message-center-agree").show();
			$("#message-center-disagree").show();
			$("#message-center-ok").hide();
			$("#message-content").html("<b style='color:red;'>"+subject+"</b>申请加入<b style='color:red;'>"+content+"</b>，请审批。<P><b>"+time+"</b></p>");
		}
	},
	loadMessageModel:function(id,discussId,url,modelId){
		BimMobleBdip.currentModelUrl = url ;
		BimMobleBdip.currentModelId = modelId ;
		if(discussId!=null && discussId!="" && discussId!=undefined){
			popupDiscuss(discussId,false);
		}
		BimMobleBdip.messageCenterUpdateReadStatus(id);//更新消息为已读
	},
	messageCenterAgree:function(){ //同意消息
		//myApp.alert('同意'+BimMobleBdip.currentMessageId,'BDIP');
		$.ajax({
            type: "POST",
            url: publicJS.tomcat_url+"/modeltreeshare/updateBimModelTreeShare?id="+BimMobleBdip.currentMessageCustom+"&progress=pass",
            dataType: "json",
            async: false,
            success: function(data){
               if(data.code == 200){
            	   BimMobleBdip.messageCenterUpdateReadStatus(BimMobleBdip.currentMessageId);
            	   myApp.addNotification({
                       message: '以同意',
                       hold:1500,
                       closeIcon:false,
                       closeOnClick:true,
                       additionalClass:"notification-li-custom notification-li-custom-success"
                   });
               }   
            },
            error: function(data){
                //myApp.alert('获取数据失败，检查网络后重试','BDIP');
            	myApp.addNotification({
                    message: '获取数据失败，检查网络后重试',
                    hold:1500,
                    closeIcon:false,
                    closeOnClick:true,
                    additionalClass:"notification-li-custom notification-li-custom-error"
                });
            }
        });
	},
	messageCenterDisagree:function (){//不同意消息
		//myApp.alert('不同意'+BimMobleBdip.currentMessageId,'BDIP');
		$.ajax({
            type: "POST",
            url: publicJS.tomcat_url+"/modeltreeshare/updateBimModelTreeShare?id="+BimMobleBdip.currentMessageCustom+"&progress=refuse",
            dataType: "json",
            async: false,
            success: function(data){
               if(data.code == 200){
            	   BimMobleBdip.messageCenterUpdateReadStatus(BimMobleBdip.currentMessageId);
            	   myApp.addNotification({
                       message: '以拒绝',
                       hold:1500,
                       closeIcon:false,
                       closeOnClick:true,
                       additionalClass:"notification-li-custom notification-li-custom-success"
                   });
               }   
            },
            error: function(data){
                //myApp.alert('获取数据失败，检查网络后重试','BDIP');
            	myApp.addNotification({
                    message: '获取数据失败，检查网络后重试',
                    hold:1500,
                    closeIcon:false,
                    closeOnClick:true,
                    additionalClass:"notification-li-custom notification-li-custom-error"
                });
            }
        });
	},
	messageCenterOK:function(){ //开启了不用审核，只需通知用户即可
		BimMobleBdip.messageCenterUpdateReadStatus(BimMobleBdip.currentMessageCustom);//更新消息为已读
	},
	messageCenterUpdateReadStatus:function (id){ //将消息变成已读
		$.ajax({
            type: "GET",
            url: publicJS.tomcat_url+"/message/update_read_status?messageId="+id,
            dataType: "json",
            async: false,
            success: function(data){
               if(data.code == 200){
            	   BimMobleBdip.getMessageCenter();
               }   
            },
            error: function(data){
                //myApp.alert('获取数据失败，检查网络后重试','BDIP');
            	myApp.addNotification({
                    message: '获取数据失败，检查网络后重试',
                    hold:1500,
                    closeIcon:false,
                    closeOnClick:true,
                    additionalClass:"notification-li-custom notification-li-custom-error"
                });
            }
        });
	},
	//获取视点保存按钮信息
	setVisibleForMarkup : function(show){  
		BimMobleBdip.isFromButtonToPoint = true;
		
		BimMobleBdip.mobileViewer  = BimMobleBdip.view;
		var panoramToolbar = BimMobleBdip.mobileViewer.getToolbar(true);
		var ctrlGroup= panoramToolbar.getControl("bimbdip_viewToolBar");
		var button = ctrlGroup.getControl('BimMobleBdip_button_viewpoint');
		BimMobleBdip.btnElementToPoint = button.container;
		
		BimMobleBdip.beVisibleToPoint = show;
		BimMobleBdip.btnElementToPoint.classList.toggle('active');
		if(BimMobleBdip.beVisibleToPoint){
			BimMobleBdip.showMarkup();
		}else{
			BimMobleBdip.mainPanel.setVisible(false);
		}
	},
	//获取实时讨论按钮信息
	setVisibleForDiscuss : function(show){		
		BimMobleBdip.isFromButtonToDiscuss = true;
		
		BimMobleBdip.mobileViewer  = BimMobleBdip.view;
		var DiscussToolbar = BimMobleBdip.mobileViewer.getToolbar(true);
		var ctrlGroup= DiscussToolbar.getControl("bimbdip_viewToolBar");
		var button = ctrlGroup.getControl('BimMobleBdip_button_discuss');
		BimMobleBdip.btnElementToDiscuss = button.container;
		
		BimMobleBdip.beVisibleToDiscuss = show;
		BimMobleBdip.btnElementToDiscuss.classList.toggle('active');
		if(BimMobleBdip.beVisibleToDiscuss){
			DiscussMobile.findAllPoint();
		}else{
			BimMobleBdip.DiscussPanel.setVisible(false);
		}
	},
	showMarkup : function(){
		BimMobleBdip.dockingPanelNone("markup-mobile-body");
		BimMobleBdip.view.unloadExtension('Autodesk.ADN.Viewing.Extension.MarkupMobile');
		BimMobleBdip.view.loadExtension('Autodesk.ADN.Viewing.Extension.MarkupMobile');
		BimMobleBdip.mainPanel = BimMobleBdip.view.loadedExtensions['Autodesk.ADN.Viewing.Extension.MarkupMobile'].getPanelObject();
		//当选中资料管理后宰选中视点保存按钮时，资料管理被选中状态取消，没有选中框
		DiscussMobile.discussClean();   		//移除实时讨论点
		mobilePanorama.closePanorama();	//移除资料管理
		mobilePanorama.hidePanoramaButton();
		mobilePanorama.hideDiscussButton();
	},
	getPointById : function(nodes){
		var date = new Date().valueOf();
		//tzw
		var shareUrl = "/bdip/modeltool/sharepoint/sharePoint2?id="+nodes[0].id+"&s="+date+"&modelid="+BimMobleBdip.currentModelId+"&modelName="+BimMobleBdip.modelName;
		var surl = BimMobleBdip.getMoblieShortUrl(shareUrl);
      	$("#model-tree-share-url").html("我分享了来自BDIP-简约版的模型视点，点击查看："+surl);
      	$("#qrcode").html("");
      	var qrcode = new QRCode(document.getElementById("qrcode"), {
      	        width : 200,//设置宽高
      	        height : 200
      	});
       qrcode.makeCode(surl);
      	   
  	   //激活复制
  	   var clipboard = null
  	   if(BimMobleBdip.activaCopy){
  		   clipboard = new Clipboard('.g-share-copy');
  		   clipboard.on('success', function(e) {
     	   		//myApp.alert('复制成功','BDIP');
	     	   	myApp.addNotification({
	     	   		message: '复制成功',
	     	   		hold:1500,
	     	   		closeIcon:false,
	     	   		closeOnClick:true,
	     	   		additionalClass:"notification-li-custom notification-li-custom-success"
	     	   });
           });
           clipboard.on('error', function(e) {
         	   	console.log(e);
           });
  		   BimMobleBdip.activaCopy=false
  	   }
  	   
  	   	BimMobleBdip.shareIconIsShow({
	  	   	"content": "我分享了来自BDIP-简约版的模型视点，点击查看",
			"href": surl
		});
  	   
/*  	   if(BimMobleBdip.view != null ){
			var dataUrl = BimMobleBdip.view.getScreenShotBuffer();
			console.log("压缩前的dataUrl数据："+dataUrl);
			compressImg(dataUrl,300,600,function(finalDataUrl){
			    if (finalDataUrl) {
			    	console.log("压缩后的dataUrl数据："+finalDataUrl);
					var arr = [];
					arr.push(finalDataUrl);
					
					
					BimMobleBdip.shareIconIsShow({
				  	   	"content": "我分享了来自BDIP-简约版的模型视点，点击查看",
				  	   	"thumbs": arr,
						"pictures": arr,
						"href": surl
					});
			    	
			    }else{

					BimMobleBdip.shareIconIsShow({
				  	   	"content": "我分享了来自BDIP-简约版的模型视点，点击查看",
						"href": surl
					});
			    }
			});
		}else{

			BimMobleBdip.shareIconIsShow({
		  	   	"content": "我分享了来自BDIP-简约版的模型视点，点击查看",
				"href": surl
			});
		}*/

	},
	getPointByDbid : function(dbid){
		var date = new Date().valueOf();
	/*	$$('.popup-share').on('opened', function () {
			  console.log('Services Popup is opening')
		});
		*/
		//$$('div[data-i18n=分享构件]').on('click', function () {
		//});
		//tzw
		/*var currentUrl = BimMobleBdip.currentModelUrl.split("http://static.cloud.bimbdip.com/filebim/wendang/");
		var url =  $.base64.btoa(currentUrl[1]);*/
		console.log(BimMobleBdip.currentModelId);
		var shareUrl ="/bdip/modeltool/sharepoint/sharePoint2?dbid="+dbid+"&treeID="+BimMobleBdip.currentModelId+"&s="+date+"&modelName="+BimMobleBdip.modelName;
		var surl = BimMobleBdip.getMoblieShortUrl(shareUrl);
      	$("#model-tree-share-url").html("我分享了来自BDIP-简约版的模型构件，点击查看："+surl);
      	$("#qrcode").html("");
      	var qrcode = new QRCode(document.getElementById("qrcode"), {
  	        width : 200,//设置宽高
  	        height : 200
      	});
       qrcode.makeCode(surl);
      	   
  	   //激活复制
  	   var clipboard = null
  	   if(BimMobleBdip.activaCopy){
  		   clipboard = new Clipboard('.g-share-copy');
  		   clipboard.on('success', function(e) {
     	   		//myApp.alert('复制成功','BDIP');
	     	   	myApp.addNotification({
	     	   		message: '复制成功',
	     	   		hold:1500,
	     	   		closeIcon:false,
	     	   		closeOnClick:true,
	     	   		additionalClass:"notification-li-custom notification-li-custom-success"
	     	   });
           });
           clipboard.on('error', function(e) {
         	   	console.log(e);
           });
  		   BimMobleBdip.activaCopy=false
  	   }
		myApp.popup('.popup-share');
		
		BimMobleBdip.shareIconIsShow({
		   	"content": "我分享了来自BDIP-简约版的模型构件，点击查看",
			"href": surl
		});
		
		/*if(BimMobleBdip.view != null ){
			var dataUrl = BimMobleBdip.view.getScreenShotBuffer();
			console.log("压缩前的dataUrl数据："+dataUrl);
			compressImg(dataUrl,300,600,function(finalDataUrl){
			    if (finalDataUrl) {
			    	console.log("压缩后的dataUrl数据："+finalDataUrl);
					var arr = [];
					arr.push(finalDataUrl);
					
					BimMobleBdip.shareIconIsShow({
				  	   	"content": "我分享了来自BDIP-简约版的模型构件，点击查看",
				  	   	"thumbs": arr,
						"pictures": arr,
						"href": surl
					});
			    	
			    }else{
			    	BimMobleBdip.shareIconIsShow({
					   	"content": "我分享了来自BDIP-简约版的模型构件，点击查看",
						"href": surl
					});
			    }
			});
		}else{
			BimMobleBdip.shareIconIsShow({
			   	"content": "我分享了来自BDIP-简约版的模型构件，点击查看",
				"href": surl
			});
		}*/
		
	},
	
	//转换baseUrl为Blob格式
	dataURLtoBlob : function (dataurl) {
		var arr = dataurl.split(','), mime = arr[0].match(/:(.*?);/)[1],
		bstr = atob(arr[1]), n = bstr.length, u8arr = new Uint8Array(n);
		while(n--){
			u8arr[n] = bstr.charCodeAt(n);
		}
		return new Blob([u8arr], {type:mime});
	},
	checkLocalUrl : function (filepath) {
    	var xmlhttp;
        if (window.XMLHttpRequest){
          xmlhttp=new XMLHttpRequest();
        }else{
          xmlhttp=new ActiveXObject("Microsoft.XMLHTTP");
        }
        try{
        	
        	 xmlhttp.open("GET",filepath,false);
        	// XMLhttp.setTimeouts(1000,1000,1000,3000);
        	 xmlhttp.send();
        	 
        }catch (e) {
    	}
        if(xmlhttp.readyState==4){  
            if(xmlhttp.status==200) return true; //url存在  
            else if(xmlhttp.status==404) return false; //url不存在  
            else return false;//其他状态  
        } 
    },
    popupHelp:function(){//弹出帮助
    	myApp.popup('.popup-help');
    	if(BimMobleBdip.isFirstHelp){
    		var mySwiper = myApp.swiper('.swiper-container', {
    			pagination:'.swiper-pagination',
    			nextButton: '.swiper-button-next',
    			prevButton: '.swiper-button-prev',
    		});
    		BimMobleBdip.isFirstHelp = false;
    	}
    },
    renderHelpVideo:function(){
    	$.ajax({
            type: "GET",
            url: "http://115.159.217.210:8018/university/api/getVideoBytype?type=15",
            dataType:"jsonp",  
            jsonp:"jsonpCallback",
            async: false,
            success: function(data){
               if(data.code == 200){
            	   _data = data.data;
            	   view3.router.loadPage("helpVideoList.html");
            	   var s = '';
            	   setTimeout(function() {
            		   for (var i = 0; i < _data.length; i++) {
                		   s+='<li>';
                		   s+=	'<a href="#" onclick="BimMobleBdip.popupHelpVideo(\''+_data[i].videourl+'\',\''+_data[i].title+'\')"  class="item-link item-content">';
                		   s+=		'<div class="item-inner">';
                		   s+=			'<div class="item-title">'+_data[i].title+'</div>';
                		   s+=		'</div>';
                		   s+=	'</a>';
                		   s+='</li>';
                	   }
                	   $("#help-video-list-content").html(s);
            	   }, 200);
            	   //console.log(data.data);
               }   
            },
            error: function(data){
                //myApp.alert('获取数据失败，检查网络后重试','BDIP');
            	myApp.addNotification({
                    message: '获取数据失败，检查网络后重试',
                    hold:1500,
                    closeIcon:false,
                    closeOnClick:true,
                    additionalClass:"notification-li-custom notification-li-custom-error"
                });
            }
        });
    },
    popupHelpVideo : function(videoName,titleName){ //弹出帮助
    	var helpVideo = myApp.photoBrowser({
    	    photos : [
    	        {
    	            html: '<video autoplay="aotoplay" class="u-video" width="300" height="500"  src="http://file.asset.17bim.com/university/'+videoName+'" controls=""></video>',
    	            caption: titleName
    	        }
    	    ],
    	    backLinkText: '帮助视频',
		    swipeToClose : true,
		    maxZoom : 3
    	});
    	helpVideo.open();
    	setTimeout(function() {
    		$("[pseudo='-internal-media-controls-download-button']").hide();
		}, 100);
    },
    goBBS:function(){
    	//window.location.href="http://bbs.bimbdip.com/";
    	//view3.router.loadPage("goBBS.html");
    	titleNViewWebview("http://bbs.bimbdip.com/");
    },
    getMoblieShortUrl:function(url){
    	var lurl = encodeURIComponent(url);
    	var surl = "";
    	$.ajax({
            type: "GET",
            url: publicJS.tomcat_url+"/s/getMobileShortUrl?url="+lurl,
            dataType: "json",
            async: false,
            success: function(data){
               if(data.code == 200){
            	   surl = data.data;
               }   
            },
            error: function(data){
                //myApp.alert('获取数据失败，检查网络后重试','BDIP');
            	myApp.addNotification({
                    message: '获取数据失败，检查网络后重试',
                    hold:1500,
                    closeIcon:false,
                    closeOnClick:true,
                    additionalClass:"notification-li-custom notification-li-custom-error"
                });
            }
        });
    	return surl;
    },
    
    // fcq 2018年4月13日16:18:11 
    isInstalled: function(id) { // 判断客户端有无安装
    	if(myApp.device.ios) {
    		switch (id) {
				case "qq":
					var TencentOAuth = plus.ios.import("TencentOAuth");
					return TencentOAuth.iphoneQQInstalled();
				case "weixin":
					var WXApi = plus.ios.import("WXApi");
					return WXApi.isWXAppInstalled()
				case "sinaweibo":
					var SinaAPI = plus.ios.import("WeiboSDK");
					return SinaAPI.isWeiboAppInstalled()
				default:
					break;
			}
    	}
    	
    	if(myApp.device.android) {
    		var main = plus.android.runtimeMainActivity();
			var packageManager = main.getPackageManager();
			var PackageManager = plus.android.importClass(packageManager)
			var packageName = {
				"qq": "com.tencent.mobileqq",
				"weixin": "com.tencent.mm",
				"sinaweibo": "com.sina.weibo"
			}
			try {
				return packageManager.getPackageInfo(packageName[id], PackageManager.GET_ACTIVITIES);
			} catch (e) {
//					console.log(e)
			}
    	}
    },
    shareIconIsShow: function(obj) { // 分享按钮的控制
    	plus.oauth.getServices(function(services) {
    		var shareIcon = document.getElementById("shareIcon");
			var htmlStr = "";
//			var weixinStr = "<a href='#' class='button' onclick='BimMobleBdip.shareEvent(\"WXSceneSession\",\""+obj.content+"\",\""+obj.href+"\",\""+obj.pictures+"\")'>分享给微信好友</a>";
//				weixinStr += "<a href='#' class='button' onclick='BimMobleBdip.shareEvent(\"WXSceneTimeline\",\""+obj.content+"\",\""+obj.href+"\",\""+obj.pictures+"\")'>分享到朋友圈</a>";
	
			var	weixinStr = "<a href='#' class='button shareBtn' onclick='BimMobleBdip.shareEvent(\"WXSceneSession\",\""+obj.content+"\",\""+obj.href+"\",\""+obj.pictures+"\")'>";
				weixinStr += "<i class='icon iconfont icon-weixin myIcon'></i>";
				weixinStr += "<span>微信</span>";
				weixinStr += "</a>";
				weixinStr += "<a href='#' class='button shareBtn' onclick='BimMobleBdip.shareEvent(\"WXSceneTimeline\",\""+obj.content+"\",\""+obj.href+"\",\""+obj.pictures+"\")'>";
				weixinStr += "<i class='icon iconfont icon-pengyouquan myIcon'></i>";
				weixinStr += "<span>朋友圈</span>";
				weixinStr += "</a>";
				
//			var qqStr = '<a href="#" class="button" onclick="BimMobleBdip.shareEvent(\'qq\',\''+obj.content+'\',\''+obj.href+'\')",\''+obj.pictures+'\')">分享到qq</a>';
			var	qqStr = '<a href="#" class="button shareBtn" onclick="BimMobleBdip.shareEvent(\'qq\',\''+obj.content+'\',\''+obj.href+'\',\''+obj.pictures+'\')">';
				qqStr += '<i class="icon iconfont icon-QQ myIcon"></i>';
				qqStr += '<span>QQ</span>';
				qqStr += '</a>';

//			for (var i = 0,len = services.length; i < len; i++) {
//				var isInstalled = BimMobleBdip.isInstalled(services[i].id);
//				console.log(JSON.stringify(isInstalled))
//				if(!isInstalled && services[i].id !== "xiaomi" && services[i].id !== "sinaweibo") { // 本地未安装客户端
//					
//					if(services[i].id === "weixin") {
//						console.log("kkk1")
//						
//						weixinStr = '';
//						weixinStr += '<a href="#" class="button shareBtn disabled">';
//						weixinStr += '<i class="icon iconfont icon-weixin myIcon"></i>';
//						weixinStr += '<span>发送给朋友</span>';
//						weixinStr += '</a>';
//						weixinStr += '<a href="#" class="button shareBtn disabled">';
//						weixinStr += '<i class="icon iconfont icon-pengyouquan myIcon"></i>';
//						weixinStr += '<span>微信朋友圈</span>';
//						weixinStr += '</a>';
//						
//					}else if(services[i].id === "qq"){
//						console.log("kkk2")
//						
//						qqStr = '';
//						qqStr += '<a href="#" class="button shareBtn disabled">';
//						qqStr += '<i class="icon iconfont icon-QQ myIcon"></i>';
//						qqStr += '<span>分享到QQ</span>';
//						qqStr += '</a>';
//					}
//				}
//			}

			htmlStr += '<p class="buttons-row">';
			htmlStr += weixinStr;
			htmlStr += qqStr;
			htmlStr += '</p>';
			

			shareIcon.innerHTML = htmlStr;
			
		}, function(e) {
			myApp.alert("获取登录服务列表失败：" + e.message + " - " + e.code, '提示');
		});
    },
    shareAction: function(s, obj) { // 授权认证操作
	    if (!s.authenticated ) {	
			s.authorize(function() {
				console.log("授权认证完成");
				BimMobleBdip.shareWeixinMessage(s, obj);
			}, function(e){
				console.log("授权认证失败");
				myApp.addNotification({
			    	message: "授权认证失败",
			        hold:2000,
			        closeIcon:false
			    });
			})
		}else {
			BimMobleBdip.shareWeixinMessage(s, obj);
		}
  	},
  	shareWeixinMessage: function(sharewx, obj) { // 分享操作
	    sharewx.send({
	    	title: "BDIP简约版app",
	      	content: obj.content,
	      	thumbs: obj.thumbs, // 分享消息的缩略图
	      	pictures: obj.pictures,
	      	href: obj.href,
	      	extra: obj.extra
	    },  function(){
	      	myApp.addNotification({
		    	message: "分享成功",
		        hold:2000,
		        closeIcon:false,
		        additionalClass:"notification-li-custom notification-li-custom-success"
		    });
	    },  function(e){
			myApp.addNotification({
		    	message: "分享失败："+e.message,
		        hold:2000,
		        closeIcon:false,
		        additionalClass:"notification-li-custom notification-li-custom-error"
		    });
	    });
  	},
  	shareEvent: function(type, content, href, pictures) { // 分享事件
		var shares = null,
			sharewx = null;
			thumbs = pictures === "undefined" ? false : pictures;
		
		console.log(thumbs)
		/*
		 * "WXSceneSession" 分享到微信的“我的好友”
		 * "WXSceneTimeline" 分享到微信的“朋友圈”中
		 * "WXSceneFavorite" 分享到微信的“我的收藏”中
		 */
		switch(type) {
			case "WXSceneSession":
				var shareObj = {
					"content": content,
					"thumbs": ["http://cloud.bimbdip.com/img/bim60.png"],
					"pictures": ["http://cloud.bimbdip.com/img/bim60.png"],
					"href": href,
					"extra": {
						"scene": "WXSceneSession"
					}
				}
	
				plus.share.getServices(function(s) {
					shares = s;
					for(var i in s) {
	
						if('weixin' == s[i].id) {
							sharewx = s[i];
						}
					}
		
					if(sharewx.nativeClient) {
						BimMobleBdip.shareAction(sharewx, shareObj);
					} else {
						myApp.addNotification({
					    	message: "未安裝微信客戶端，请下载微信！",
					        hold:2000,
					        closeIcon:false,
					        additionalClass:"notification-li-custom notification-li-custom-error"
					    });
					}
		
				}, function(e) {
					myApp.addNotification({
				    	message: "获取分享服务列表失败：" + e.message,
				        hold:2000,
				        closeIcon:false,
				        additionalClass:"notification-li-custom notification-li-custom-error"
				    });
				});
				break;
			case "WXSceneTimeline":
				var shareObj = {
					"content": content,
					"thumbs": ["http://cloud.bimbdip.com/img/bim60.png"],
					"pictures": ["http://cloud.bimbdip.com/img/bim60.png"],
					"href": href,
					"extra": {
						"scene": "WXSceneTimeline"
					}
				}
	
				plus.share.getServices(function(s) {
					shares = s;
					for(var i in s) {
	
						if('weixin' == s[i].id) {
							sharewx = s[i];
						}
					}
		
					if(sharewx.nativeClient) {
						BimMobleBdip.shareAction(sharewx, shareObj);
					} else {					
						myApp.addNotification({
					    	message: "未安裝微信客戶端，请下载微信！",
					        hold:2000,
					        closeIcon:false,
					        additionalClass:"notification-li-custom notification-li-custom-error"
					    });
					}
		
				}, function(e) {					
					myApp.addNotification({
				    	message: "获取分享服务列表失败：" + e.message,
				        hold:2000,
				        closeIcon:false,
				        additionalClass:"notification-li-custom notification-li-custom-error"
				    });
				});
				break;
			case "qq":
				var shareObj = {
					"content": content,
					"thumbs": ["http://cloud.bimbdip.com/img/bim60.png"],
					"pictures": ["http://cloud.bimbdip.com/img/bim60.png"],
					"href": href,
					"extra": {}
				}
	
				plus.share.getServices(function(s) {
					shares = s;
					for(var i in s) {
	
						if('qq' == s[i].id) {
							sharewx = s[i];
						}
					}

					if(sharewx.nativeClient) {
						BimMobleBdip.shareAction(sharewx, shareObj);
					} else {
						myApp.addNotification({
					    	message: '未安裝qq客戶端，请下载手机qq！',
					        hold:2000,
					        closeIcon:false,
			        		additionalClass:"notification-li-custom notification-li-custom-error"
					    });
					}
		
				}, function(e) {				
					myApp.addNotification({
				    	message: "获取分享服务列表失败：" + e.message,
				        hold:2000,
				        closeIcon:false,
				        additionalClass:"notification-li-custom notification-li-custom-error"
				    });
				});
				break;
			default: 
				break;
		}
	}
}

var mySearchbar = myApp.searchbar('.searchbar', {
    searchList: '.list-block-search',
    searchIn: '.item-title'
}); 

//下拉刷新页面
var ptrContent = $$('.pull-to-refresh-content');
 
// 添加'refresh'监听器
ptrContent.on('refresh', function (e) {
	setTimeout(function () {
		BimMobleBdip.getMessageCenter();
		myApp.pullToRefreshDone();//重置下拉刷新
	}, 1000);
});

/**==========================tzw==全景图===开始==========================**/
var mobilePanorama = {
		DBID : null,                //模型检测用dbid
		dt_fragId : null,			//模型检测用fragId
		fragId : null,				//模型跳转用fragId
		externalId : null,			//模型跳转用externalId
		dbId : null,				//模型跳转用dbid
		jsonString : null,		//定位全景图
		num_full : 0,				//全景图放大缩小
		jsonString : null,     //定位全景图所以当前状态
		value : null,				//点击标记传的值
		realpath : null,			//全景图图片路劲
		myPhoto : null,
		mymodal:null,
		id : null,
		ids : null,
		createTime : null,
		search_name : null,
		search_typeUrl : null,
		table : null,
		gyroext_id : null,
		gyroext_dbid : null,
		gyroext_fragId : null,
		gyroext_typeUrl : null,
		_data : null,
		firstClick : true, 		//选中列表行判断是否第一次选中
		passId : '',			//选中列表行判断是否是当前节点
		tr_elem : null,
		uploadCount : 0, 		//上传百分比只显示一次
		progressModal : null,
		//使用全景图方法
		doPanorama : function () {
			BimMobleBdip.view.model.getData().instanceTree.enumNodeFragments(BimMobleBdip.view.getSelection()[0],function(fragId){
				mobilePanorama.DBID = BimMobleBdip.view.getSelection()[0];
				mobilePanorama.dt_fragId = fragId;
	        });
			var tmpState=BimMobleBdip.view.getState();
			var jsonTmp=JSON.stringify(tmpState);
			jsonTmp =jsonTmp.replace(/\"/g,"'");
			BimMobleBdip.jsonString = $.base64.btoa(jsonTmp);
			var d = new Date();
			mobilePanorama.createTime = d.getFullYear()+"-"+(d.getMonth() + 1) +"-"+d.getDate();
			BimMobleBdip.view.getProperties(mobilePanorama.DBID,function (data){
				mobilePanorama.externalId = data.externalId;
				mobilePanorama.dbId = data.dbId;
				BimMobleBdip.view.model.getData().instanceTree.enumNodeFragments(BimMobleBdip.view.getSelection()[0],function(fragId){
					mobilePanorama.fragId = fragId;
                    //$("#ifm1").attr('src','../modeltool/360jsp/bind?dbId='+bimPanorama.dbId+'&fragId='+bimPanorama.fragId+'&lmvId='+BimBdip.lvmid+'&url='+BimBdip.view_modelUrl+'&externalId='+bimPanorama.externalId+'&modelVersion='+BimBdip.modelVersion+'&jsonString='+bimPanorama.jsonString);
                });
            });
			
			
			var stitle ='上传资料';
			var stext = '';
			
			stext +='<form  name="form" method="post" id="frm"  action="#" enctype="multipart/form-data">';
			stext +=	'<div class="list-block">';
			stext +=		'<ul>';
			stext +=			'<input type="file" id="fileName" name="attachmentFile" onchange="mobilePanorama.showFileInfo();">';
			stext +=			'<li>';
			stext +=				'<div class="item-content">';
			stext +=					'<div class="item-inner">';
			stext +=						'<a class="button btn-upload" onclick="mobilePanorama.showFile();">选择</a>';
			stext +=					'</div>';
			stext +=				'</div>';
			stext +=			'</li>';
			stext +=			'<li>';
			stext +=				'<div class="item-content">';
			stext +=					'<div class="item-media"><i class="icon icon-folder"></i></div>';
			stext +=					'<div class="item-inner">';
			stext +=						'<div class="item-input">';
			stext +=							'<input type="text" id="name"  readonly="readonly" placeholder="现场资料名字" name="name">';
			stext +=						'</div>';
			stext +=					'</div>';
			stext +=				'</div>';
			stext +=			'</li>';
			stext +=			'<li>';
			stext +=				'<div class="item-content">';
			stext +=					'<div class="item-media"><i class="icon selectOption"></i></div>';
			stext +=					'<div class="item-inner">';
			stext +=						'<div class="item-input">';
			stext +=							'<select name="typeUrl" class="type">';
			stext +=								'<option class="option-security" value="/img/modeltool/red.png">安全</option>';
			stext +=								'<option class="option-quality" value="/img/modeltool/green.png" >质量</option>';
			stext +=								'<option class="option-schedule" value="/img/modeltool/blue.png">进度</option>';
			stext +=							'</select>';
			stext +=						'</div>';
			stext +=					'</div>';
			stext +=				'</div>';
			stext +=				'<b class="panorama_name" hidden="true"></b>';
			stext +=			'</li>';
			stext +=		'</ul>';
			stext +=	'</div>';
			
			stext +=	'<input type="hidden" id="dbId" name = "dbId" >';
			stext +=	'<input type="hidden" id="fragId" name = "fragId" >';
			stext +=	'<input type="hidden" id="lmvId" name = "lmvId" >';
			stext +=	'<input type="hidden" id="url" name = "url" >';
			stext +=	'<input type="hidden" id="modelVersion" name = "modelVersion">';
			stext +=	'<input type="hidden" id="jsonString" name = "jsonString" >';
			stext +=	'<input type="hidden" id="externalId" name = "externalId" >';
			stext +=	'<input type="hidden" id="createTime" name = "createTime" >';
			stext +='</form>';
			

			mobilePanorama.mymodal = myApp.modal({
			    title: stitle,
			    text: stext,
			    buttons: [
				      {
				    	   text: '保存',
				    	   bold: true,
				    	   onClick:function(){
				    		   mobilePanorama.upload();
				    	   },
				    	   close:false
				      },
				      {
					  		text:'取消',
					        bold: true
					   },
			    ]
			});
		},
		proModalShow:function(){
			var pro = '';
			pro +=	'<div class="page-content  panoramaProgress">';
			pro +=		'<div class="content-block row">';
			pro +=			'<div class="colprogree col-dark">';
			pro +=				'<span class="preloader" style=" width: 58px;height: 64px;margin-top: -71%;margin-left: -26%;"></span><br>';
			pro +=				'<b class="panorama_progress">100%</b>';
			pro +=			'</div>';
			pro +=		'</div>';
			pro +=	'</div>';
			
			mobilePanorama.progressModal = myApp.modal({
				text: pro,
				title: "正在上传"
			});
			
			$(".modal-inner").css("width","30%");
			$(".modal-inner").css("height","87px");
			$(".modal-inner").css("margin-left","26%");
		},
		proModalHide:function (){
			$(".modal-inner").removeAttr("style");
			myApp.closeModal(mobilePanorama.progressModal);
		},
		toggleVisibilityForPanorama : function(){
			mobilePanorama.getPanorama(!BimMobleBdip.beVisible);
		},
		hideViewPointButton : function(){
			$(BimMobleBdip.btnElementToPoint).removeClass('active');
			$(BimMobleBdip.btnElementToPoint).addClass('inactive');
			BimMobleBdip.beVisibleToPoint = false;
			if($('.markup-mobile-body') != ""){
				$('.markup-mobile-body').hide();
			}
			BimMobleBdip.isFromButton = false;    //还原资料管理
			BimMobleBdip.isFromButtonToDiscuss = false; //还原实时讨论
		},
		hidePanoramaButton : function(){
			$(BimMobleBdip.btnElement).removeClass('active');
			$(BimMobleBdip.btnElement).addClass('inactive');
			BimMobleBdip.beVisible = false;
			if($('.panorama-mobile-body') != ""){
				$('.panorama-mobile-body').hide();
			}
			BimMobleBdip.isFromButtonToPoint = false; //还原视点保存
			BimMobleBdip.isFromButtonToDiscuss = false; //还原实时讨论
		},
		hideDiscussButton : function(){
			$(BimMobleBdip.btnElementToDiscuss).removeClass('active');
			$(BimMobleBdip.btnElementToDiscuss).addClass('inactive');
			BimMobleBdip.beVisibleToDiscuss = false;
			if($('.discuss-mobile-body') != ""){
				$('.discuss-mobile-body').hide();
			}
			BimMobleBdip.isFromButton = false;    //还原资料管理
			BimMobleBdip.isFromButtonToPoint = false; //还原视点保存
		},
		showFile : function(){
			document.getElementById("fileName").click();
		},
		showFileInfo : function(){
			if(BimMobleBdip.chooseFile == 0){
				var files =  document.getElementById('fileName').files;
				var filename = files[0].name;
				var filesize = files[0].size;
				document.getElementById("name").readOnly = false;
				$('#name').val(filename);
				
				//$('.panorama_name').text(filename);
			}
		},
		upload : function(){
			if($('#name').val() == ''){
				myApp.addNotification({
			    	message: '请检查是否有选择文件或者文件名是否为空',
			        hold:1500,
			        closeIcon:false,
			        closeOnClick:true,
			        additionalClass:"notification-li-custom notification-li-custom-error"
			    });
    		  return;
			}
			else{
					//myApp.showIndicator();
					myApp.closeModal(mobilePanorama.mymodal);
					mobilePanorama.proModalShow();
					$("#dbId").val(mobilePanorama.dbId);
					$("#fragId").val(mobilePanorama.fragId);
					$("#lmvId").val(BimMobleBdip.currentModelId);
					$("#url").val(BimMobleBdip.currentModelUrl );
					$("#modelVersion").val(BimMobleBdip.modelVersion);
					var jsonVal = $.base64.atob(BimMobleBdip.jsonString);
					$("#jsonString").val(jsonVal);
					$("#externalId").val(mobilePanorama.externalId);
					$("#createTime").val(mobilePanorama.createTime);
					$.ajax({
						url: publicJS.tomcat_url+ "/panorama/creatPanorama",
						type: 'post',
						data: new FormData($("#frm")[0]),
						cache: false,
						dataType: 'json',
						processData: false, // Don't process the files
						contentType: false, // Set content type to false as jQuery will tell the server its a query string request'
						xhr:function(){
							var myXhr = $.ajaxSettings.xhr();
							if(myXhr.upload){
								myXhr.upload.addEventListener("progress" , mobilePanorama.onProgress, false);
							}
							return myXhr;
						},
						success : function(data){
							//$("#frm")[0].reset();
							$('.panorama_name').text("");
							$('.panorama_progress').text ("0%") ;
							mobilePanorama.toggleVisibilityForPanorama();
							//myApp.closeModal(mobilePanorama.mymodal);
							var type = "";
							var image = data.data;
							var file = "http://static.cloud.bimbdip.com/360/";
							var realpath = file +image;
							if(image.length>0 && image && image!=null){
								var point = image.lastIndexOf("."); 
							    var type = image.substr(point); 
							    myApp.addNotification({
							    	message: '上传成功',
							        hold:1500,
							        closeIcon:false,
							        closeOnClick:true,
							        additionalClass:"notification-li-custom notification-li-custom-success"
							    });
					    		if(point == '-1' || type == '.png' || type == '.jpg' || type == '.jpeg' || type == '.JPG' || type == '.PNG' || type == '.JPEG'){
									var myPhoto = myApp.photoBrowser({
										photos : [{url:realpath}],
						    		    backLinkText: '返回',
						    		    swipeToClose : true,
						    		    maxZoom : 3
						    		});
									myPhoto.open(); //上传成功后自动显示上传后的图片
					    		}else if(type == '.MOV' ||type == '.mov' || type == '.avi' || type == '.rmvb' || type == '.rm' || type == '.asf' || type == '.divx' || type == '.mpg' || type == '.mpeg' || type == '.mpe' || type == '.wmv' || type == '.mp4' || type == '.mkv' || type == '.vob'){
					    			var myPhoto = myApp.photoBrowser({
					    				photos : [{html:'<video autoplay="aotoplay" class="u-video" width="300" height="500"  src="'+realpath+'" controls=""></video>'}],
						    		    backLinkText: '返回',
						    		    swipeToClose : true
						    		});
									myPhoto.open(); //上传成功后自动显示上传后的视频、动图
					    		}else{
					    			myApp.addNotification({
					    			    message: '该文件手机端暂不支持，请至PC端查看',
					    			    hold:1500,
					    			    closeIcon:false,
					    			    closeOnClick:true,
					    			    additionalClass:"notification-li-custom notification-li-custom-error"
					    			});
					    		}
							}
							//myApp.hideIndicator();	
							mobilePanorama.proModalHide();
						},
						error : function(){
							//console.log("失败");
							mobilePanorama.upload();
							//myApp.hideIndicator();
							mobilePanorama.proModalHide();
						}
					}); 
			}
		},
		onProgress : function(evt){
			var loaded = evt.loaded;     //已经上传大小情况 
    		var tot = evt.total;      //附件总大小 
    		 /**已经上传的百分比**/ 
    		var per = Math.floor(100*loaded/tot); 
    		//if(mobilePanorama.uploadCount == 0){
    			$('.panorama_progress').text (per+"%") ;
				//mobilePanorama.uploadCount = 1;
			//}
		},
		closePanorama:function() {
			_dbid = "svf"; 
			var pnames = document.getElementsByName("360ViewTags");
			if(pnames.length==0){
				//myApp.alert("该模型暂未绑定资料","BDIP");
			}else{
				for(var i = 0 ; i < pnames.length ; i++) {
					pnames[i].style.display = "none";
				}
			}
		},
		cleanAll:function(){
			//删除360 和实时讨论
			var pnames = document.getElementsByClassName("pnamed");
			for(var i = 0 ; i < pnames.length ; i++) {
				pnames[i].style.display = "none";
			}
		},
		showPanoramaPanel : function(){
			BimMobleBdip.dockingPanelNone("panorama-mobile-body");
			BimMobleBdip.view.unloadExtension('Autodesk.ADN.Viewing.Extension.PanoramaMobile');
			BimMobleBdip.view.loadExtension('Autodesk.ADN.Viewing.Extension.PanoramaMobile');
			BimMobleBdip.mainPanel = BimMobleBdip.view.loadedExtensions['Autodesk.ADN.Viewing.Extension.PanoramaMobile'].getPanelObject();
			//当选中视点保存后宰选中资料管理时，视点保存被选中状态取消，没有选中框
			mobilePanorama.hideViewPointButton();
			mobilePanorama.hideDiscussButton();
		},
		getPanorama : function(show){
			BimMobleBdip.isFromButton = true;
			//获取全景图按钮信息
			BimMobleBdip.mobileViewer  = BimMobleBdip.view;
			var panoramToolbar = BimMobleBdip.mobileViewer.getToolbar(true);
			var ctrlGroup= panoramToolbar.getControl("bimbdip_viewToolBar");
			var button = ctrlGroup.getControl('BimMobleBdip_button_panoram');
			BimMobleBdip.btnElement = button.container;
			
			BimMobleBdip.beVisible = show;
			BimMobleBdip.btnElement.classList.toggle('active');
			if(BimMobleBdip.beVisible){
				var name = "";
			    var typeUrl = "";
			 	var s = ["svf"];
			 	mobilePanorama.showPanoramaPanel(); //显示资料上传信息列表
			 	mobilePanorama.showAllPanorama(s,name,typeUrl);//显示所有全景图标记
			}else{
				//mobilePanorama.toggleVisibilityForPanorama();
				mobilePanorama.closePanorama();
				BimMobleBdip.openPanorama = true;
				BimMobleBdip.mainPanel.setVisible(false);
				mobilePanorama.id = null;
			}
		},
		showSelectPan : function(){// 查询全景列表——获取表单中的name和typeUrl
			 BimMobleBdip.mainPanel.loadElementById();
			 var name = mobilePanorama.search_name.val();
			 var typeUrl = mobilePanorama.search_typeUrl.val();
			 typeUrl = typeUrl.replace("//","/");
			 var s = ["svf"];
			 mobilePanorama.showAllPanorama(s,name,typeUrl);
		},
		showAllPanorama : function(s,_name,_typeUrl){
			  var _dbid = s[0];
			  //var _dbidurl = _dbid+";"+BimBdip.view_modelUrl;
			  var _dbidurl = ";"+BimMobleBdip.currentModelId;
			  var head = window.location.protocol;
			  var body = window.location.host;
			  var realurl = publicJS.tomcat_url+"/panorama/getPanorama?lmvid="+_dbidurl+"&name="+_name+"&typeurl="+_typeUrl;
			  $.ajax({
			    type: "GET",
				url: realurl, 
				processData: false,
				contentType: false,
				dataType:"json",
				success: function(data){
					$(".360table").html("");
					var htmli = "";
					// 隐藏实时讨论
					mobilePanorama.cleanAll();
					//closeAsideDiv();
					mobilePanorama._data = "" ;
					var _data = "";
					if(data.code == 200){
						if(typeof(_name)!="undefined" && typeof(_typeUrl)!="undefined"){ 
							$(".360showbox").show();
						}
						mobilePanorama._data = data.data;
						_data = mobilePanorama._data;
						$(".360table tr:gt(1)").remove();
						/*if(_data=="" || _data.length<0 || _data == null){
							myApp.addNotification({
			    			    message: '该模型暂未绑定资料',
			    			    hold:1500,
			    			    closeIcon:false,
			    			    closeOnClick:true,
			    			    additionalClass:"notification-li-custom notification-li-custom-error"
			    			});
							return ;
						}
						else{*/
						$("div[name='360ViewTags']").each(function(){
							if(this!=null){
								this.remove();
							}
						});
						$(".overlayDivClass").remove();
						for(var i = 0 ; i<_data.length ; i++){
							var json = _data[i].jsonString;
							var id = _data[i].id;
							if(json =='' || json == undefined || json == null || json=='null'){
								var jsonValue="";
							}else{
								var jsonValue = json.replace(/'/g,'"');
							}
							var d = new Date(_data[i].createTime);
							var date = d.getFullYear()+"/"+(d.getMonth() + 1) +"/"+d.getDate();
							var imgPath = publicJS.tomcat_url+_data[i].typeUrl;
							console.log(imgPath);
							BimMobleBdip.mainPanel.loadElementById();  //拿到markup div里面参数
							var tableId = mobilePanorama.table;
		                    htmli+="<tr id='tr_"+_data[i].id+"'  class='tr_"+_data[i].id+"'>";
		                    	  if(_data[i].name == ""){
		                    		  htmli+="<td  title='"+_data[i].name+"' onclick='mobilePanorama.showRestoreButton("+jsonValue+","+id+")'>未命名文件</td>";
		                    	  }else{
		                    		  htmli+="<td  title='"+_data[i].name+"' onclick='mobilePanorama.showRestoreButton("+jsonValue+","+id+")'>"+_data[i].name+"</td>";
		                    	  }
			                      htmli+="<td  onclick='mobilePanorama.showRestoreButton("+jsonValue+","+id+")'><img src='"+imgPath+"'></td>";
			                      htmli+="<td  onclick='mobilePanorama.showRestoreButton("+jsonValue+","+id+")'>"+date+"</td>";
			                htmli+="</tr>";
							$('.360table').html(htmli);
						}
					}
				}
				//}
			  });
		},
		beforeClick : function(id){
			var currentId = id;
			if(mobilePanorama.passId.length == 0){
				return true;
			}else{
				if(mobilePanorama.passId == currentId){
					return true;
				}else{
					var tr_elem = "tr_" + mobilePanorama.passId;
					$('.'+tr_elem).css("border","0");
					$('.'+tr_elem).css("border-radius","0");
					mobilePanorama.firstClick = true;
					mobilePanorama.id = null;
					return true;
				}
			}
		},
		showRestoreButton : function(jsonValue,id){//点击列表触发事件（定位，选中）
			mobilePanorama.beforeClick(id);
			mobilePanorama.id = id;
			mobilePanorama.restoreMark(jsonValue);
			mobilePanorama.tr_elem = "tr_" + mobilePanorama.id;
			mobilePanorama.passId = mobilePanorama.id;
			if(mobilePanorama.firstClick){
				$('.'+mobilePanorama.tr_elem).css("border","1px solid  rgba(127, 127, 136, 0.69)");
				$('.'+mobilePanorama.tr_elem).css("border-radius","6px");
				mobilePanorama.firstClick = false;
			}else{
				$('.'+mobilePanorama.tr_elem).css("border","0");
				$('.'+mobilePanorama.tr_elem).css("border-radius","0");
				mobilePanorama.firstClick = true;
				mobilePanorama.id = null;
			}
		},
		restoreMark : function(jsonValue){
			BimMobleBdip.view.restoreState(jsonValue);	
			//panoramabodyHide();	//反查后收缩框缩回
		},
		getImage : function(id){  //点击标记触发事件
			mobilePanorama.id = id;
			 var buttons1 = [
			        {
			            text: '请选择',
			            label: true
			        },
			        {
			            text: '查看',
			            onClick:function(){
				    		mobilePanorama.showImage();
				    		//mobilePanorama.id = null;    //当点击模型中查看后在点击列表中的查看，在未选中时还可以继续查看，若将id设为空则不能
				    	},
				    	close : true
			        },
			        {
			            text: '删除',
			            onClick:function(){
				    		mobilePanorama.deletePanaroma(mobilePanorama.id);
				    		mobilePanorama.id = null;
				    	},
			        }
			    ];
			    var buttons2 = [
			        {
			            text: '取消',
			            color: 'red'
			        }
			    ];
			    var groups = [buttons1, buttons2];
			    myApp.actions(groups);
		},
		showImage : function(){
			var id = mobilePanorama.id;
			if(id == null || id == "" || id == undefined || id == 'undefined' || id == 'null'){
				//myApp.alert('请选择您需要查看的内容','BDIP');
				myApp.addNotification({
				    message: '请选择您需要查看的内容',
				    hold:1500,
				    closeIcon:false,
				    closeOnClick:true,
				    additionalClass:"notification-li-custom notification-li-custom-error"
				});
			}else{
				var realurl = publicJS.tomcat_url+"/panorama/getPanoramaById?id="+id;
				$.ajax({
					url: realurl,
				    type: "GET",
					processData: false,
					contentType: false,
					dataType:"json",
					success: function(data){
						var _data = "" ;
						var type = "";
						if(data.code == 200){
							/*var imgsuffix = '.png'; //当图片没有后缀名时强制添加
							_data = data.data;
							var attachment = _data[0].attachment;
							var point = attachment.lastIndexOf("."); 
							if(point == '-1'){
								attachment = attachment+imgsuffix;
								var imgIndex = attachment.lastIndexOf("."); 
								type = attachment.substr(imgIndex);
							}else{
								type = attachment.substr(point); 
							}*/
							_data = data.data;
							var attachment = _data[0].attachment;
							var point = attachment.lastIndexOf("."); 
							type = attachment.substr(point); 
							var file = "http://static.cloud.bimbdip.com/360/";
					    	mobilePanorama.realpath = file +attachment;
						   
						    if(point == '-1' || type == '.png' || type == '.jpg' || type == '.jpeg' || type == '.JPG' || type == '.PNG' || type == '.JPEG'){
						    	mobilePanorama.myPhoto = myApp.photoBrowser({//图片
						    		photos : [{url:mobilePanorama.realpath}],
					    		    backLinkText: '返回',
					    		    swipeToClose : true,
					    		    maxZoom : 3
					    		});
								mobilePanorama.myPhoto.open();
				    		}
						    else if(type == '.MOV' ||type == '.mov' || type == '.avi' || type == '.rmvb' || type == '.rm' || type == '.asf' || type == '.divx' || type == '.mpg' || type == '.mpeg' || type == '.mpe' || type == '.wmv' || type == '.mp4' || type == '.mkv' || type == '.vob'){ //动图、视频
				    			mobilePanorama.myPhoto = myApp.photoBrowser({
									photos : [{html:'<video autoplay="aotoplay" class="u-video" width="300" height="500"  src="'+mobilePanorama.realpath+'" controls=""></video>'}],
					    		    backLinkText: '返回',
					    		    swipeToClose : true
					    		});
								mobilePanorama.myPhoto.open();
				    		}
						    else{
						    	//myApp.alert('该文件手机端暂不支持，请至PC端查看','BDIP');
						    	myApp.addNotification({
						    	    message: '该文件手机端暂不支持，请至PC端查看',
						    	    hold:1500,
						    	    closeIcon:false,
						    	    closeOnClick:true,
						    	    additionalClass:"notification-li-custom notification-li-custom-error"
						    	});
						    	//return ;
						    }
						}
					},
					error: function(data){
					 //alert("error");
						myApp.addNotification({
						    message: '获取数据失败，检查网络后重试',
						    hold:1500,
						    closeIcon:false,
						    closeOnClick:true,
						    additionalClass:"notification-li-custom notification-li-custom-error"
						});
					}
			   });
			}
		},
		deletePanaroma : function(){
			var id = mobilePanorama.id;
			if(id == null || id == undefined || id == '' || id == 'undefined'){
				//myApp.alert('请选择您需要删除的内容','BDIP');
				myApp.addNotification({
				    message: '请选择您需要删除的内容',
				    hold:1500,
				    closeIcon:false,
				    closeOnClick:true,
				    additionalClass:"notification-li-custom notification-li-custom-error"
				});
			}else{
				var realurl = publicJS.tomcat_url+"/panorama/deletePanoramaById";
				myApp.confirm('是否确认删除该资料?','BDIP',
				      function () {
							$.ajax({  
								url:realurl,  
						 		type : 'get',
						 		data : {id:id},
						 		success: function(data){
						 			 //刷新界面
						 			 //myApp.alert('删除成功','BDIP',function(){
									myApp.addNotification({
										message: '删除成功',
									    hold:1500,
									    closeIcon:false,
									    closeOnClick:true,
									    additionalClass:"notification-li-custom notification-li-custom-success"
									});
									var tr_elem = "tr_" + id;
									$("#" + tr_elem).remove();
									var a_elem = "a_" + id;
									$("#" + a_elem).parent().remove();
									mobilePanorama.showSelectPan();
									panoramabodyShow();
									mobilePanorama.id = null;
						 			 //});
						 		}
							});
				      }
				 );
			}
		},
		GetQueryString : function(name){
		     var reg = new RegExp("(^|&)"+ name +"=([^&]*)(&|$)");
		     var r = window.location.search.substr(1).match(reg);
		     if(r!=null)return  unescape(r[2]); return null;
		}
}
/**==========================tzw==全景图===结束==========================**/
/**==========================hw==控制视点保存显示和隐藏===开始==========================**/

function markupbodyShow(){
	//$(".markup-mobile-body").css("left","0px");
	$(".markup-mobile-body").animate({left:"0px"},500);
	$(".markup-mobile-body").css("overflow","hidden");
}

function markupbodyHide(){
	//$(".markup-mobile-body").css("left","-91%");
	$(".markup-mobile-body").animate({left:"-91%"},500);
	setTimeout(function(){
		$(".markup-mobile-body").css("overflow","visible");
	},500);
}

/**==========================hw==控制视点保存显示和隐藏===结束==========================**/

/**==========================tzw==控制资料上传列表显示和隐藏===开始==========================**/
function panoramabodyShow(){
	$("div[name='360ViewTags']").each(function(){
		if(this!=null){
			this.remove();
		}
	});
	$(".overlayDivClass").remove();
	$(".panorama-mobile-body").animate({left:"0px"},500);
	//$(".panorama-mobile-body").css("left","0px");
	$(".panorama-mobile-body").css("overflow","hidden");
	mobilePanorama.closePanorama();
}
function panoramabodyHide(){
	$("div[name='360ViewTags']").each(function(){
		if(this!=null){
			this.remove();
		}
	});
	$(".overlayDivClass").remove();
	//$(".panorama-mobile-body").css("left","-91%");
	$(".panorama-mobile-body").animate({left:"-91%"},500);
	setTimeout(function(){
		$(".panorama-mobile-body").css("overflow","visible");
	},500);
	for(var i =0;i<mobilePanorama._data.length;i++){
		var data = mobilePanorama._data;
		mobilePanorama.gyroext_id = data[i].id;
		mobilePanorama.gyroext_dbid = data[i].dbid;
		mobilePanorama.gyroext_fragId = data[i].fragId;
		mobilePanorama.gyroext_typeUrl = data[i].typeUrl;
		_gyroext.do_mobile(mobilePanorama.gyroext_id,mobilePanorama.gyroext_dbid,mobilePanorama.gyroext_fragId,mobilePanorama.gyroext_id,mobilePanorama.gyroext_typeUrl);
	}
}
/**==========================tzw==控制资料上传列表显示和隐藏===结束==========================**/

/*---------------------------hw--模型离线操作--开始-----------------------------------------*/
//下载路径：static.cloud.bimbdip.com/filebim/wendang/6/model/201711/3e9cf9fc-5c6d-4719-9bb4-1e027ab2bed1/GeometryMetadata.pf
//下载根路径：static.cloud.bimbdip.com/filebim/wendang/
var offlineManager = {
	offlineDomainUrl:null,				//离线模型域名
	downLoadDomainUrl:null,				//下载域名
	downloadFileNamePrefix:null,		//下载文件前缀
	downloadFileTargetPrefix:null,		//下载文件目标路径前缀
	downloadFileTotal:0,				//下载文件总数
	downloadedFile:0,					//已下载数
	downloadWaiting:null,				//plus.nativeUI.showWaiting对象，用于存放下载进度
	offlineModelInfo:null,
	init:function(){
		offlineManager.offlineDomainUrl = "http://localhost:13131/_doc/";
		offlineManager.downLoadDomainUrl = "http://static.cloud.bimbdip.com/";
		offlineManager.downloadFileNamePrefix = "filebim/wendang/";
		offlineManager.downloadFileTargetPrefix = "_doc/"+offlineManager.downloadFileNamePrefix;
		offlineManager.offlineModelInfo={
			name:null,
			id:null,
			baseUrl:null,
			url:null,
			tdid:null
		};
	},
	modelLoadBefore:function(name,id,baseUrl,url,tdid){//模型加入口，判断是否有离线
		offlineManager.offlineModelInfo.name = name;
		offlineManager.offlineModelInfo.id = id;
		offlineManager.offlineModelInfo.baseUrl = baseUrl;
		if(url != null || url != ""){
			url = url.replace(offlineManager.downLoadDomainUrl,offlineManager.offlineDomainUrl).replace(/\s/g,"");;
			offlineManager.offlineModelInfo.url = url;	
		}
		if(tdid != null || tdid != ""){
			tdid = tdid.replace(offlineManager.downLoadDomainUrl,offlineManager.offlineDomainUrl).replace(/\s/g,"");;
			offlineManager.offlineModelInfo.tdid = tdid;
		}
		offlineManager.getLvmFilePath(id,1);
		/*myApp.confirm('该模型暂未离线，是否加载离线模型？', 'BDIP',function(){
			//加载离线模型
		},function(){
			//加载在线模型
		});*/
	},
	getLvmFilePath:function(treeid,modelVersion){ //获取模型离线文件下载路径，开始下载模型
		offlineManager.downloadFileTotal = 0 ;
		offlineManager.downloadedFile = 0 ;
		offlineManager.uploadDownloadProgress();
		var offlineModelPath = "";
		$.ajax({
            type: "GET",
            url:publicJS.tomcat_url+"/modeluploadtask/getLvmFilePath?treeid="+treeid+"&modelVersion="+modelVersion,
            //url:"http://cloud.bimbdip.com/modeluploadtask/getLvmFilePath?treeid="+treeid+"&modelVersion="+modelVersion,
            dataType: "json",
            async: false,
            success: function(data){
            	if(data.code == "200"){
            		_data = data.data;
            		var urlFileList = _data.urlFileList;
            		var urlFileListLength = urlFileList.length ;
            		offlineManager.downloadFileTotal = urlFileListLength ;
            		for(var i = 0 ; i < urlFileListLength ; i++){
	                    offlineManager.checkOfflineFile(urlFileList[i]);
            		}
            	}else{
            		myApp.addNotification({
	                    message: '模型信息出错',
	                    hold:1500,
	                    closeIcon:false,
	                    closeOnClick:true,
	                    additionalClass:"notification-li-custom notification-li-custom-error"
	                });
	                offlineManager.downloadWaiting.close();
            	}
            },
            error: function(data){
                //myApp.alert('获取数据失败，检查网络后重试','BDIP');
                myApp.addNotification({
                    message: '获取数据失败，检查网络后重试',
                    hold:1500,
                    closeIcon:false,
                    closeOnClick:true,
                    additionalClass:"notification-li-custom notification-li-custom-error"
                });
                offlineManager.downloadWaiting.close();
            }
        });
	},
	checkOfflineFile:function(relativeUrl){
		var completeUrl = offlineManager.offlineDomainUrl + offlineManager.downloadFileNamePrefix + relativeUrl ;
		completeUrl = completeUrl.replace(/\s/g,"");
        plus.io.resolveLocalFileSystemURL(completeUrl, function(entry) {
            console.log("文件存在："+relativeUrl);
            offlineManager.downloadedFile++ ;
			offlineManager.uploadDownloadProgress();//更新下载进度
        }, function(e) {
            //文件不存在，需下载
			console.log("文件不存在："+relativeUrl);
			var downloadUrl = offlineManager.downLoadDomainUrl + offlineManager.downloadFileNamePrefix + relativeUrl;
			downloadUrl = encodeURI(downloadUrl);//下载地址需要经过url编码，否则可能会下载失败
			var downloadFileName = offlineManager.downloadFileTargetPrefix + relativeUrl;
			downloadFileName = downloadFileName.replace(/\s/g,"");
			var dtask = plus.downloader.createDownload(downloadUrl , {filename:downloadFileName}, function ( d, status ) {
				// 下载完成
				if ( status == 200 ) { 
					//alert( "Download success: " + d.filename  );
					offlineManager.downloadedFile++ ;
					offlineManager.uploadDownloadProgress();//更新下载进度
					console.log("下载完成："+relativeUrl);
				} else {
					//下载失败,需删除本地临时文件,否则下次进来时会检查到文件已存在
                    console.log("下载失败=" + status+"=="+downloadFileName);
                    if (downloadFileName!=null){
                    	offlineManager.deleteFile(downloadFileName);
                    }
                    offlineManager.downloadWaiting.close();
                    myApp.alert('模型下载失败，请检查网络状况或手机内存是否足够','BDIP');
				}  
			});
			//dtask.addEventListener( "statechanged", onStateChanged, false );
			dtask.start();
        });
	},
	uploadDownloadProgress:function(){ //更新下载进度
		if(offlineManager.downloadedFile == 0 && offlineManager.downloadFileTotal == 0){
			offlineManager.downloadWaiting = plus.nativeUI.showWaiting("模型离线准备...",{back:"none"});
		}else if(offlineManager.downloadFileTotal != 0 && offlineManager.downloadedFile == offlineManager.downloadFileTotal){
			console.log("总数："+offlineManager.downloadFileTotal+"；已下载："+offlineManager.downloadedFile+"加载对象："+offlineManager.downloadWaiting);
			setTimeout(function(){
				offlineManager.downloadWaiting.setTitle("离线已完成");
				offlineManager.downloadWaiting.close();
				offlineManager.downloadWaiting = null ;
				offlineManager.downloadedFile = 0 ;
				offlineManager.downloadFileTotal = 0 ;
				BimMobleBdip.modelLoad(offlineManager.offlineModelInfo.name,offlineManager.offlineModelInfo.id,offlineManager.offlineModelInfo.baseUrl,offlineManager.offlineModelInfo.url,offlineManager.offlineModelInfo.tdid);
			},1100);
		}else{
			var a = offlineManager.downloadedFile/offlineManager.downloadFileTotal*100;
			console.log("总数："+offlineManager.downloadFileTotal+"；已下载："+offlineManager.downloadedFile+"加载对象："+offlineManager.downloadWaiting+"进度："+parseInt(a)+"%");
			setTimeout(function(){
				offlineManager.downloadWaiting.setTitle("模型正在加载:"+parseInt(a)+"%");
			},a*10);
		}
	},
	urlFormat:function(url){ // "/a/b/c"&"/a/b/c/"&"a/b/c"-->"a/b/c/"
		if(url==null || url == undefined || url == ""){
			return "";
		}
		if(url.substring(0,1)=="/"){
			url = url.substring(1,url.length);//	"/a/b/c".substring(1,"/a/b/c".length);
		}
		if(url.substring(url.length-1,url.length)!="/"){
			url = url + "/";
		}
		return url;
	},
	deleteFile:function(relativePath){
		plus.io.resolveLocalFileSystemURL(relativePath, function(entry) {
            entry.remove(function(entry) {
                console.log("文件删除成功==" + relativePath);
            }, function(e) {
                console.log("文件删除失败=" + relativePath);
            });
        });
	}
}
/*---------------------------hw--模型离线操作--结束-----------------------------------------*/