﻿﻿var clr=null;
AutodeskNamespace("Autodesk.ADN.Viewing.Extension");
Autodesk.ADN.Viewing.Extension.DiscussPanelMobile = function (viewer, options) {  
	Autodesk.Viewing.Extension.call(this, viewer, options);
	var currentUrl = BimMobleBdip.currentModelUrl;
	var currentModelid = BimMobleBdip.currentModelId; 
	var currentUserid = $("#userId").val();
	var currentUsername = $("input[name=name]").val();
	var _panel = null;
	var _markupsExtension = null;
	var base_file_url =  publicJS.tomcat_url;
	this.getPanelObject=function(){
	return _panel;
	}
	// js加载回调函数
	this.load = function () {
	    loadCss([base_file_url+'/css/mobile/markup_style.css', base_file_url+'/css/modeltool/viewpoint/spectrum.css'])
	    var viewerToolbar = viewer.getToolbar(true);
	    var ctrlGroup=viewerToolbar.getControl("bimbdip_viewToolBar");
	    var button = ctrlGroup.getControl('BimMobleBdip_button_panoram');
	    _panel = new MarkupPanel(
	      viewer.container,
	      guid(),
	      DiscussMobile.currentPointArr,
	      button.container);
	    _panel.toggleVisibility();
	  return true;
	}
	//  js未加载回调
	this.unload = function () {
		if(_panel) {
		    _panel.unload();
		    _panel = null;
		}
		return true;
	}
	//加载页面css
	function loadCss(css) {
	  css.forEach(function(path){
	    $('<link/>', {
	      rel: 'stylesheet',
	      type: 'text/css',
	      href: path
	    }).appendTo('head');
	  });
	}
  
	//随机id
	function guid() {
		var d = new Date().getTime();
		var guid = 'xxxx-xxxx-xxxx-xxxx'.replace(
			/[xy]/g,
			function (c) {
				var r = (d + Math.random() * 16) % 16 | 0;
				d = Math.floor(d / 16);
				return (c == 'x' ? r : (r & 0x7 | 0x8)).toString(16);
			});
		return guid;
	}

	// 涂鸦文本
	var MarkupPanel = function(parentContainer,panelId,pointArr,btnElement) {
		// 涂鸦文本构造函数
		Autodesk.Viewing.UI.DockingPanel.call(
			this,                               
			parentContainer,                    
			panelId,                            
			'实时讨论',                         
			{shadow: true});                    
			                                    
			                                    
		// 私有成员
		var _thisPanel = this;
		var _layerItems = {};
		var _isMinimized = false;
		var _isVisible = false;
		// 用户页面
		function generateHtml(pointArr,id) {
			//console.log(pointArr);
			// 头
			var html = '<div class="discuss-body-scroll" style="width: 100%;height: 90%;overflow: hidden;overflow-y: auto;">';
			var currentUserId = $("#userId").val();
			pointArr.forEach(function(point,index){
				//console.log(point);
				//console.log(point.json);
				var spanClassName;
				if(point.enable == 0){
					spanClassName = "textNum_clo";
				}else{
					spanClassName = "textNum";
				}
				var createTime = dateFormatUtil(point.createTime);
				// 删除操作上半段
				html += '	<div class="chatContent" name="chatContent_'+point.id+'">';
				html += '		<div class="top">';
				html += '			<img class="chatHeadImage" src="'+point.headImage+'">';
				html += '			<div class="chatUser">';
				html += '				<div class="chatUsermessage">';
				html += '					<div class="chatUserName">'+point.userName+'</div>';
				html += '					<div class="chatTime">'+createTime+'</div>';
				html += '				</div>';
				html += '				<div class="chatDelete">';
				html += '					<span class="viewPointNum"><b class="'+spanClassName+'">'+point.viewPointNum+'</b></span>';
				// 删除操作上半段
				if(currentUserId == point.createBy){
					html += '	<a href="javascript:void(0);" onclick="DiscussMobile.deleteChat('+point.id+')" title="删除">';
					html += '		<img class="deleteLogo" src="'+publicJS.tomcat_url+'/img/modeltool/chatview/recycle46s.png">';
					html += '	</a>';
				}
				// 删除操作下半段
				html += '				</div>';
				html += '			</div>';
				html += '		</div>';
				html += '		<div class="middle" style="text-align:center;">';
				html += '			<a href="javascript:void(0);" onclick="DiscussMobile.focusPoint('+point.json+','+point.id+','+point.dbId+','+point.fragId+','+point.viewPointNum+','+point.enable+')">';
				html += '			<img class="chatPicture" style="height:120px" src="'+point.picture+'">';
				html += '			</a>';
				html += '		</div>';
				html += '	</div>';
				// 尾
				if(index == pointArr.length-1){
					html += '	</div>';
					html += '	<div id="'+id+'-body-show" class="body-show"></div>';
					html += '	<div id="'+id+'-body-hide" class="body-hide"></div>';
				}
			});
			//console.log(html);
			return html;
		}
		
		//初始化页面菜单
		function initialize() {
			_thisPanel.content = document.createElement('div');
			$(_thisPanel.container).addClass('markup discuss-mobile-body');
			$(_thisPanel.container).append(generateHtml(pointArr,panelId));
			
			
			$("#" + panelId + "-body-show").click(discussBodyShow); //显示收缩框
			$("#" + panelId + "-body-hide").click(discussBodyHide); //隐藏收缩框
		}
		
		_thisPanel.unload = function() {
			_thisPanel.setVisible(false);
		}
		_thisPanel.setVisible = function(show) {
			_isVisible = show;
			//btnElement.classList.toggle('active');
			Autodesk.Viewing.UI.DockingPanel.prototype.
				setVisible.call(this, show);
			
			if(show){  
				//viewer.loadExtension('Autodesk.Viewing.MarkupsCore');
				//_markup = viewer.getExtension("Autodesk.Viewing.MarkupsCore");
				//var config = {markupDisableHotkeys:false};
				//_markupsExtension = new Autodesk.Viewing.Extensions.Markups.Core.MarkupsCore(viewer,config);
				//_markupsExtension.load();
			}
			else {
				//viewer.unloadExtension('Autodesk.Viewing.MarkupsCore');
				//_markupsExtension.leaveEditMode();
				//_markupsExtension.hide();
				// 关闭所有点
				DiscussMobile.discussClean();
				
				if(!BimMobleBdip.isFromButtonToDiscuss){
					$(BimMobleBdip.btnElementToDiscuss).removeClass('active');
					$(BimMobleBdip.btnElementToDiscuss).addClass('inactive');
					BimMobleBdip.beVisibleToDiscuss = false;
		    	}							
	    	  	BimMobleBdip.isFromButtonToDiscuss = false;
    	  	    $(".viewcube").hide(); //移动端隐藏右上角的视图立方体
    	  	    $("#toolbar-sectionTool").show();;//移动端剖切显示
			}
		}
		
		_thisPanel.toggleVisibility = function() {
			_panel.setVisible(!_isVisible);
		}
		_thisPanel.initialize = function() {
			this.title = this.createTitleBar(
			  this.titleLabel ||
			  this.container.id);
			
			this.closer = this.createCloseButton();
			
			this.container.appendChild(this.title);
			this.title.appendChild(this.closer);
			this.container.appendChild(this.content);
			
			this.initializeMoveHandlers(this.title);
			this.initializeCloseHandler(this.closer);
		}
		_thisPanel.onTitleDoubleClick = function (event) {
			_isMinimized = !_isMinimized;
			if(_isMinimized) {
				$(_thisPanel.container).addClass('minimized');
			}
			else {
				$(_thisPanel.container).removeClass('minimized');
			}
		}
		initialize();
	}
	MarkupPanel.prototype = Object.create(Autodesk.Viewing.UI.DockingPanel.prototype);
	MarkupPanel.prototype.constructor = MarkupPanel;
};
Autodesk.ADN.Viewing.Extension.DiscussPanelMobile.prototype =Object.create(Autodesk.Viewing.Extension.prototype);
Autodesk.ADN.Viewing.Extension.DiscussPanelMobile.prototype.constructor =Autodesk.ADN.Viewing.Extension.DiscussPanelMobile;
Autodesk.Viewing.theExtensionManager.registerExtension('Autodesk.ADN.Viewing.Extension.DiscussPanelMobile',Autodesk.ADN.Viewing.Extension.DiscussPanelMobile);