﻿var clr=null;
AutodeskNamespace("Autodesk.ADN.Viewing.Extension");
Autodesk.ADN.Viewing.Extension.PanoramaMobile = function (viewer, options) {  
  Autodesk.Viewing.Extension.call(this, viewer, options);
  var currentUrl = BimMobleBdip.currentModelUrl;
  var currentModelid = BimMobleBdip.currentModelId; 
  var currentUserid = $("#userId").val();
  var currentUsername = $("input[name=name]").val();
  var _panel = null;
  var _markupsExtension = null;
  var base_file_url =  publicJS.tomcat_url;
  this.getPanelObject=function(){
		return _panel;
  }
  // js加载回调函数
  this.load = function () {
      loadCss([base_file_url+'/css/mobile/markup_style.css', base_file_url+'/css/modeltool/viewpoint/spectrum.css'])
      var viewerToolbar = viewer.getToolbar(true);
      var ctrlGroup=viewerToolbar.getControl("bimbdip_viewToolBar");
      var button = ctrlGroup.getControl('BimMobleBdip_button_panoram');
      _panel = new MarkupPanel(
        viewer.container,
        guid(),
        button.container);
      _panel.toggleVisibility();
    return true;
  }
  //  js未加载回调
  this.unload = function () {
    if(_panel) {
      _panel.unload();
      _panel = null;
    }
    return true;
  }
  //加载页面css
  function loadCss(css) {
    css.forEach(function(path){
      $('<link/>', {
        rel: 'stylesheet',
        type: 'text/css',
        href: path
      }).appendTo('head');
    });
  }
  // 随机id
  function guid() {
    var d = new Date().getTime();
    var guid = 'xxxx-xxxx-xxxx-xxxx'.replace(
      /[xy]/g,
      function (c) {
        var r = (d + Math.random() * 16) % 16 | 0;
        d = Math.floor(d / 16);
        return (c == 'x' ? r : (r & 0x7 | 0x8)).toString(16);
      });
    return guid;
  }
  // 涂鸦文本
  var MarkupPanel = function(parentContainer,panelId,btnElement) {
    // 涂鸦文本构造函数
    Autodesk.Viewing.UI.DockingPanel.call(
      this,
      parentContainer,
      panelId,
      '资料管理',
      {shadow: true});

		
    // 私有成员
    var _thisPanel = this;
    var _layerItems = {};
    var _isMinimized = false;
    var _isVisible = false;
    // 用户页面    
    function generateHtml(id) {
    	//<input type="button" class="cx_btn" onclick="mobilePanorama.showSelectPan();" value="快速搜索"/>
      var html = '';
      html +='<div class="container">';
      html +='    	<div id="360showbox" class="360showbox showbox360">';
    	html +='  		<div class="360content content360" style="padding: 10px;box-sizing: border-box;font-family: yahei;font-size: 13px;height: 100%;">';
    	html +='  			<div id="tr_search">';
	    html +='				<input id="'+id+'-search_name"  class="search_name" name="name" type="text"/>';
			html +='				<select id="'+id+'-search_typeUrl" class="search_typeUrl" name="typeUrl">';
	    html +='					<option value="" selected="selected">全部</option>';
	    html +='					<option value="/img/modeltool/red.png">安全 </option>';
	    html +='					<option value="/img/modeltool/blue.png">质量</option>';
	    html +='					<option value="/img/modeltool/green.png">进度</option>';
			html +='				</select>';
	    html +='				<div class="search_div" onclick="mobilePanorama.showSelectPan();">搜索</div>';
   		html +='			</div>';
    	html +='  			<div id="tr_foot">';
    	html +='  				<span>资料名称</span>';
    	html +='  				<span>类型</span>';
    	html +=' 				<span>时间</span>';
    	html +='  			</div>';
    	html +='			<table id="'+id+'-360table" class="360table scroll_bar">  ';  					
    	html +='			</table>';
      html +='  		</div>';
    	html +='  	</div>';
			html +='<div id="'+id+'-panel-hide" class="panel-hide" style="display:none"></div>';
			html +='<div id="'+id+'-body-show" class="body-show"></div>';
			html +='<div id="'+id+'-body-hide" class="body-hide"></div>';
			html +='<div id="'+id+'-panorama_div">';
	    html +='    		<button id="'+id+'-p_show" class="btn btn-info" style="margin-left: 27%;"><b>查看</b></button>';
			html +='		<button id="'+id+'-p_del" class="btn btn-info" style="margin-left: 74%;"><b>删除</b></button>';
			html +='</div> ';
     	html +='</div>';
      return html;
    }
    //初始化页面菜单
    function initialize() {
      _thisPanel.content = document.createElement('div');
      	$(_thisPanel.container).addClass('markup panorama-mobile-body height_h');
      	$(_thisPanel.container).append(generateHtml(panelId));  
      	
      	$("#" + panelId + "-body-show").click(panoramabodyShow); //显示收缩框
				$("#" + panelId + "-body-hide").click(panoramabodyHide); //隐藏收缩框
				
				$("#" + panelId + "-p_show").click(showPanorama);
				$("#" + panelId + "-p_del").click(deletePanorama);
    }
    
    function loadElementById(){
    	mobilePanorama.search_name = $("#" + panelId + "-search_name");
			mobilePanorama.search_typeUrl = $("#" + panelId + "-search_typeUrl");
			mobilePanorama.table = $("#" + panelId + "-360table");
    }
    
    function showPanorama(){
    	mobilePanorama.showImage();
    }
    
    function deletePanorama(){
    	mobilePanorama.deletePanaroma();
    }
    
    _thisPanel.loadElementById = loadElementById;
    
    
    _thisPanel.unload = function() {
      _thisPanel.setVisible(false);
    }
    _thisPanel.setVisible = function(show) {
	      _isVisible = show;
	      //btnElement.classList.toggle('active');
	      Autodesk.Viewing.UI.DockingPanel.prototype.
	        setVisible.call(this, show);
	   
	      if(show){  
	    	  BimMobleBdip.isFromButton = false;
	      }
	      else {
	    	  if(!BimMobleBdip.isFromButton){
	    		  $(BimMobleBdip.btnElement).removeClass('active');
				  $(BimMobleBdip.btnElement).addClass('inactive');
				  BimMobleBdip.beVisible = false;
	    	  }
    	  	  mobilePanorama.closePanorama();
    	  	  BimMobleBdip.isFromButton = false;
	      }
    }

    _thisPanel.toggleVisibility = function() {
      _panel.setVisible(!_isVisible);
    }
    _thisPanel.initialize = function() {
      this.title = this.createTitleBar(
        this.titleLabel ||
        this.container.id);

      this.closer = this.createCloseButton();

      this.container.appendChild(this.title);
      this.title.appendChild(this.closer);
      this.container.appendChild(this.content);

      this.initializeMoveHandlers(this.title);
      this.initializeCloseHandler(this.closer);
    }
    _thisPanel.onTitleDoubleClick = function (event) {
      _isMinimized = !_isMinimized;
      if(_isMinimized) {
        $(_thisPanel.container).addClass(
          'minimized');
      }
      else {
        $(_thisPanel.container).removeClass(
          'minimized');
      }
    }
    initialize();
  }
  MarkupPanel.prototype = Object.create(Autodesk.Viewing.UI.DockingPanel.prototype);
  MarkupPanel.prototype.constructor = MarkupPanel;
};
Autodesk.ADN.Viewing.Extension.PanoramaMobile.prototype =Object.create(Autodesk.Viewing.Extension.prototype);
Autodesk.ADN.Viewing.Extension.PanoramaMobile.prototype.constructor =Autodesk.ADN.Viewing.Extension.PanoramaMobile;
Autodesk.Viewing.theExtensionManager.registerExtension('Autodesk.ADN.Viewing.Extension.PanoramaMobile',Autodesk.ADN.Viewing.Extension.PanoramaMobile);