﻿var clr=null;
AutodeskNamespace("Autodesk.ADN.Viewing.Extension");
Autodesk.ADN.Viewing.Extension.MarkupMobile = function (viewer, options) {  
  Autodesk.Viewing.Extension.call(this, viewer, options);
  //var currentUrl = "firstShowModel/Resource/____/_3D_ 154947/_3D_.svf";
  var currentUrl = BimMobleBdip.currentModelUrl;
  var currentModelid = BimMobleBdip.currentModelId; //???
  var currentUserid = $("#userId").val();
  var currentUsername = $("input[name=name]").val();
  var viewType = "0";
  var _panel = null;
  var _markupsExtension = null;
  var base_file_url =  publicJS.tomcat_url;
  var _viewMode = false;
  this.getPanelObject=function(){
		return _panel;
  }
  var markNew=null;
  this.getMarkup = function(data_mark){
		console.log(11);
	  	markNew=data_mark;
	  	_viewMode=false;
	  	return _panel;
  }
  // js加载回调函数
  this.load = function () {
    loadCss([base_file_url+'/css/mobile/markup_style.css', base_file_url+'/css/modeltool/viewpoint/spectrum.css'])
      var viewerToolbar = viewer.getToolbar(true);
      var ctrlGroup=viewerToolbar.getControl("bimbdip_viewToolBar");
      var button = ctrlGroup.getControl('BimMobleBdip_button_viewpoint');
      _panel = new MarkupPanel(
        viewer.container,
        guid(),
        button.container);
      _panel.toggleVisibility();
    return true;
  }

  //  js未加载回调
  this.unload = function () {
    if(_panel) {
      _panel.unload();
      _panel = null;
    }

    return true;
  }

  //加载页面css
  function loadCss(css) {
	  css.forEach(function (path) {
	    $('<link/>', {
	      rel: 'stylesheet',
	      type: 'text/css',
	      href: path
	    }).appendTo('head');
	  });
	}

  // 随机id
  function guid() {
    var d = new Date().getTime();
    var guid = 'xxxx-xxxx-xxxx-xxxx'.replace(
      /[xy]/g,
      function (c) {
        var r = (d + Math.random() * 16) % 16 | 0;
        d = Math.floor(d / 16);
        return (c == 'x' ? r : (r & 0x7 | 0x8)).toString(16);
      });

    return guid;
  }
  // 涂鸦文本
  var MarkupPanel = function(parentContainer,panelId,btnElement) {
    // 涂鸦文本构造函数
    Autodesk.Viewing.UI.DockingPanel.call(
      this,
      parentContainer,
      panelId,
      '视点保存',
      {shadow: true});


   /******************************树状图相关函数从此开始**************************************/
   var zTree, rMenu;//定义全局变量      
   var setting = {
		view: {
			selectedMulti: true
		},	
		edit: {
			enable: true,
			editNameSelectAll: true,
			showRemoveBtn: false,
			showRenameBtn: false
		},
		data: {
			simpleData: {
				enable: true
			},
			keep:{
			  parent:true,
			  leaf:true
			}
		},
		callback: {
			beforeDrag: beforeDrag,
			beforeDrop: beforeDrop,
			beforeRemove: beforeRemove,
			beforeRename: beforeRename,
			onDrop: onDrop,
			beforeClick: beforeClick,
			onClick: onClick,
			//onMouseUp: onMouseUp
		}
	};

	//移入函数
	function beforeDrag(treeId, treeNodes) {
		for (var i=0,l=treeNodes.length; i<l; i++) {
			if (treeNodes[i].drag === false) {
				return false;
			}
		}
		return true;
	}
	//移出函数
	function beforeDrop(treeId, treeNodes, targetNode, moveType) {
		return targetNode ? targetNode.drop !== false : true;
	}
	
	//删除前函数，此函数为了执行后台删除业务而创建
	function beforeRemove(treeId, treeNode){
		if(treeNode.isParent){
			return deleteFolder(treeId, treeNode);
		} else {
			return deleteFile(treeId, treeNode);
		}
	}
	function deleteFolder(treeId, treeNode){
			$.ajax({
		    	  url:publicJS.tomcat_url+"/viewsave/deleteViewDir?did="+treeNode.id+"&modelid="+currentModelid,
		    	  type:"GET",
		    	  dataType:"text",
		    	  processData:false,
		    	  contentType:false,
		    	  success:function(){
		    	  	  _markup.unloadMarkupsAllLayers();
		    	  	  	loadTree();
					    enterViewMode();
					    return true;
		    	  },
				  error:function(){
					  	//myApp.alert("删除目录失败","BDIP");
					  	myApp.addNotification({
						    message: '删除目录失败',
						    hold:1500,
						    closeIcon:false,
						    closeOnClick:true,
						    additionalClass:"notification-li-custom notification-li-custom-error"
						});
		    		  	return false;
				  }
          });
    }
	function deleteFile(treeId, treeNode){
		$.ajax({
			  url:publicJS.tomcat_url+"/viewsave/deleteViewPoint?id="+treeNode.id+"&modelid="+currentModelid,
	    	  type:"GET",
	    	  dataType:"text",
	    	  processData:false,
	    	  contentType:false,
	    	  success:function(){
	    		  _markupsExtension.unloadMarkupsAllLayers();
			  	    loadTree();
			  	    enterViewMode();
			  	    viewer.navigation.setRequestHomeView(true); //回归模型原始状态
			  	    return true;
	    	  },
	    	  error:function(){
	    		  //myApp.alert("删除视点失败","BDIP");
	    		  myApp.addNotification({
	    			    message: '删除视点失败',
	    			    hold:1500,
	    			    closeIcon:false,
	    			    closeOnClick:true,
	    			    additionalClass:"notification-li-custom notification-li-custom-error"
	    			});
	    		  return false;
	    	  }
	     });
	}
	
	//重命名提示
	function beforeRename(treeId, treeNode, newName, isCancel) {
		var fid = 0;
		if(treeNode.getParentNode()){
			fid = treeNode.getParentNode().id;
		}
		if (newName.length == 0) {
			zTree.cancelEditName();
			setTimeout(function(){
				//myApp.alert("新名称不能为空","BDIP");
				myApp.addNotification({
				    message: '新名称不能为空',
				    hold:1500,
				    closeIcon:false,
				    closeOnClick:true,
				    additionalClass:"notification-li-custom notification-li-custom-error"
				});
			},1000)
			return false;
		 } else {
			if(treeNode.isParent){
					return updateFolder(treeId, treeNode, newName, isCancel, fid);
			} else {
					return updateFile(treeId, treeNode, newName, isCancel, fid);
			}
		}
	}
	function updateFolder(treeId, treeNode, newName, isCancel, fid){
		$.ajax({
			  url:publicJS.tomcat_url+"/viewsave/updateViewDirName?fname="+newName+"&did="+treeNode.id+"&fdid="+fid+"&modelid="+currentModelid,
	    	  type:'GET',
	    	  dataType:'text',
	    	  processData:false,
	    	  contentType:false,
	    	  success:function(data){
	    		  if(data!=null && data.length>0 && data==newName){
	    			  zTree.cancelEditName();
	    			  setTimeout(function(){
	    				  //myApp.alert("目录名称已存在","BDIP");
	    				  myApp.addNotification({
	    					    message: '目录名称已存在',
	    					    hold:1500,
	    					    closeIcon:false,
	    					    closeOnClick:true,
	    					    additionalClass:"notification-li-custom notification-li-custom-error"
	    					});
	    			  },500)
	    		  }
	    		  loadTree();
	    		  enterViewMode();
	    	  },
	    	  error:function(){
	    		  zTree.cancelEditName();
	    		  //myApp.alert("重命名失败","BDIP");
	    		  myApp.addNotification({
	    			    message: '重命名失败',
	    			    hold:1500,
	    			    closeIcon:false,
	    			    closeOnClick:true,
	    			    additionalClass:"notification-li-custom notification-li-custom-error"
	    			});
	    		  return false;
	    	  }
	     });
	}
	function updateFile(treeId, treeNode, newName, isCancel, fid){
		$.ajax({
			  url:publicJS.tomcat_url+"/viewsave/updateViewName?name="+newName+"&id="+treeNode.id+"&fid="+fid+"&modelid="+currentModelid,
	    	  type:"GET",
	    	  dataType:'text',
	    	  processData:false,
	    	  contentType:false,
	    	  success:function(obj){
	    		  var targetJson = JSON.parse(obj);
	    		  if(targetJson.code && targetJson.code=="222"){
	    			  zTree.cancelEditName();
					  setTimeout(function(){
						  //myApp.alert("视点名称已存在","BDIP");
						  myApp.addNotification({
							    message: '视点名称已存在',
							    hold:1500,
							    closeIcon:false,
							    closeOnClick:true,
							    additionalClass:"notification-li-custom notification-li-custom-error"
							});
					  },500)
	    		  }
				  loadTree();
				  enterViewMode();
	    	  },
	    	  error:function(){
	    		  zTree.cancelEditName();
	    		  //myApp.alert("重命名失败","BDIP");
	    		  myApp.addNotification({
	    			    message: '重命名失败',
	    			    hold:1500,
	    			    closeIcon:false,
	    			    closeOnClick:true,
	    			    additionalClass:"notification-li-custom notification-li-custom-error"
	    			});
	    		  return false;
	    	  }
	     });
	}
	/***拖拽事件结束后的数据操作***/
	function onDrop(event, treeId, treeNodes, targetNode){
		var msg = "目标文件夹若包含同名视点或目录，系统会自动重命名该对象，确定继续吗？";
		myApp.confirm(msg,"BDIP", 
			function () {
				var id = "0";
				if(!targetNode && event.target.tagName.toLowerCase() != "button" && $(event.target).parents("a").length == 0){
					id = "0";
				}else{
					id = targetNode.id;
				}
				for(var i=0,l=treeNodes.length; i<l; i++){
					if(treeNodes[i].isParent){
						dropParent(id,treeNodes[i].id,treeNodes[i].name);
					} else {
						dropChild(id,treeNodes[i].id,treeNodes[i].name);
					}
				}
		    },
		    function(){
		    	setTimeout(function(){
					loadTree();
				},1000);
		    }
		);
	}
	function dropParent(fdid,did,fname){
		$.ajax({
			  url:publicJS.tomcat_url+"/viewsave/updateParentNode?fdid="+fdid+"&did="+did+"&modelid="+currentModelid+"&fname="+fname,
			  type:'GET',
			  dataType:'text',
			  processData:false,
			  contentType:false,
			  success:function(){
					setTimeout(function(){
						loadTree();
					},1000);
			  },
			  error:function(){
				  //myApp.alert("父节点拖拽失败","BDIP");
				  myApp.addNotification({
					    message: '父节点拖拽失败',
					    hold:1500,
					    closeIcon:false,
					    closeOnClick:true,
					    additionalClass:"notification-li-custom notification-li-custom-error"
				  });
			  }
		 });
	}
	function dropChild(fid,id,name){
		$.ajax({
			  url:publicJS.tomcat_url+"/viewsave/updateChildNode?fid="+fid+"&id="+id+"&modelid="+currentModelid+"&name="+name,
	    	  type:'GET',
	    	  dataType:'text',
	    	  processData:false,
	    	  contentType:false,
	    	  success:function(){
					setTimeout(function(){
						loadTree();
					},1000);
	    	  },
	    	  error:function(){
	    		  //myApp.alert("子节点拖拽失败","BDIP");
	    		  myApp.addNotification({
					    message: '父节点拖拽失败',
					    hold:1500,
					    closeIcon:false,
					    closeOnClick:true,
					    additionalClass:"notification-li-custom notification-li-custom-error"
				  });
	    	  }
	     });
	}
	
	/*function onMouseUp(event, treeId, treeNode){
		if(!treeNode && event.target.tagName.toLowerCase() != "button" && $(event.target).parents("a").length == 0){
			zTree.cancelSelectedNode();
			//oViewer.navigation.setRequestHomeView(true); //回归模型原始状态
			isFirstClick = true;
			enterViewMode();
		}
	}*/
	
	var passId = '';
	var isFirstClick = true;
	var passFolderId = '';
	var clickFolder = true;
	/***点击事件之前的操作**/
	function beforeClick(treeId, treeNode){
			if(!treeNode.isParent){//点击视点
				var currentId = treeNode.id;
				if(passId.length==0){
					return true;
				} else {
					if(passId==currentId){
						return true;
					}else{
						enterViewMode();
						isFirstClick=true;
						var markups = $('.dockingPanel.docking-markup');
						for(var i=0;i<markups.length; i++){
							if(markups[i].style.display == "block"){
								BimMobleBdip.showTool = 1;
							}
						}
			 	        return true;
					}
				}
			} else {//点击父节点
				//isFirstClick=true;
				var currentId = treeNode.id;
				if(passId.length==0){
					return true;
				} else {
					if(passId==currentId){
						return true;
					}else{
						enterViewMode();
						clickFolder=true;
			 	        return true;
					}
				}
			}
	}
	function onclickFolderShowButton(){  //当点击视点文件时显示重命名、删除、分享按钮
		$("#" + panelId + "-m_share")[0].style.display = "none";
		$("#" + panelId + "-m_folder")[0].style.display = "none";
		$("#" + panelId + "-m_childfolder")[0].style.display = "block";
		$("#" + panelId + "-m_newpoint")[0].style.display = "block";
		$("#" + panelId + "-m_ren")[0].style.display = "block";
		$("#" + panelId + "-m_del")[0].style.display = "block";
		$("#" + panelId + "-m_ren")[0].style.marginLeft = '60.5%';
		$("#" + panelId + "-m_childfolder")[0].style.marginLeft = '11%';
		$("#" + panelId + "-m_newpoint")[0].style.marginLeft = "37%";
		$("#" + panelId + "-m_del")[0].style.marginLeft = "84%";
	}
	
	function onclickFileShowButton(){  //当点击视点文件时显示重命名、删除、分享按钮
		$("#" + panelId + "-m_childfolder")[0].style.display = "none";
		$("#" + panelId + "-m_newpoint")[0].style.display = "none";
		$("#" + panelId + "-m_folder")[0].style.display = "none";
		$("#" + panelId + "-m_ren")[0].style.display = "block";
		$("#" + panelId + "-m_del")[0].style.display = "block";
		$("#" + panelId + "-m_del")[0].style.marginLeft = "48%";
		$("#" + panelId + "-m_share")[0].style.display = "block";
		$("#" + panelId + "-m_ren")[0].style.marginLeft = '58px';
		$("#" + panelId + "-m_share")[0].style.marginLeft = "77%";
	}
	/***每个视点图节点的点击事件****/
	var count =0;
	function onClick(event, treeId, treeNode){
			BimMobleBdip.treeNode = treeNode;
			//视点触发事件
			if(!treeNode.isParent){
					onclickFileShowButton();//显示重命名、删除、分享按钮
					passId = treeNode.id;
					var guid = treeNode.id;
					var vname=treeNode.name;
					var markup=treeNode.markupData;
					var markupList = new Array();
					if(isFirstClick) {
						if(BimMobleBdip.toolPanel != null){
							BimMobleBdip.toolPanel.enterViewMode();
							//BimMobleBdip.toolPanel.enterViewModeToDrag(); //拖动
						}
						myApp.showIndicator();   //开始转圈圈
						var json=treeNode.json.replace(/'/g,'"');
						var jsonObject = JSON.parse(json);
						viewer.restoreState(jsonObject);	
						setTimeout(function(){
							enterEditMode();
							if(markup && markup.replace(/(^\s*)|(\s*$)/g, "").length>0){
								markupList = markup.split("@#@");
								if(markupList!=null && markupList.length>0){
									for(var i=0,l=markupList.length; i<l; i++){
										var singleMarkup = markupList[i].split("@BIM@");
										_markupsExtension.loadMarkups(
												singleMarkup[1].replace(/'/g,'"'),
												singleMarkup[0]);
									}
								}
							}
							myApp.hideIndicator();		//结束转圈圈
						},600);
						
						if(BimMobleBdip.count == 1){
							if(zTree.getSelectedNodes()[0] && !zTree.getSelectedNodes()[0].isParent){
								if($('.btn-save').html() == "保存"){
									$('.btn-save').html("更新") ;
								}
							}
							if(BimMobleBdip.toolPanel != null){
								BimMobleBdip.toolPanel.setVisible(true);
								setTimeout(function(){
									BimMobleBdip.toolPanel.setEditMode("circle");
								},300);
								//BimMobleBdip.toolPanel.setEditMode("circle");
							}
						}else{
							if(BimMobleBdip.showTool == 0){
								setTimeout(function(){
									viewer.unloadExtension('Autodesk.ADN.Viewing.Extension.MobileMarkupTool');
									viewer.loadExtension('Autodesk.ADN.Viewing.Extension.MobileMarkupTool');
									BimMobleBdip.toolPanel = viewer.loadedExtensions['Autodesk.ADN.Viewing.Extension.MobileMarkupTool'].getToolPanel();
									BimMobleBdip.toolPanel.setEditMode("circle");
									BimMobleBdip.showTool = 1;
									BimMobleBdip.toolPanel.changeButton();
									if(zTree.getSelectedNodes()[0] && !zTree.getSelectedNodes()[0].isParent){
										if($('.btn-save').html() == "保存"){
											$('.btn-save').html("更新") ;
										}
									}
								}, 300);
							}else{
								if(zTree.getSelectedNodes()[0] && !zTree.getSelectedNodes()[0].isParent){
									if($('.btn-save').html() == "保存"){
										$('.btn-save').html("更新") ;
									}
								}
							}
						}
					    isFirstClick=false;
					}
	 	          else {
	 	        	  $(".viewcube").remove();
	 	        	  zTree.cancelSelectedNode();
	 	        	  hideButton();
	 	              enterViewMode();
	 	        	  $("#" + panelId + "-m_folder")[0].style.display = "block";
	 	            _markupsExtension.unloadMarkupsAllLayers();
	 	              isFirstClick=true;
	 	              BimMobleBdip.showTool = 0;
	 	              if(BimMobleBdip.Toolbar !=null || BimMobleBdip.Toolbar !=undefined){
	 	            	 BimMobleBdip.Toolbar.setVisible(false);
	 	              }
	 	              BimMobleBdip.count = 0;
	 	              if(BimMobleBdip.toolPanel !=null || BimMobleBdip.toolPanel !=undefined){
	 	            	 BimMobleBdip.toolPanel.setVisible(false);
	 	              }
	 	              if($('.btn-save').html()== "更新"){
						$('.btn-save').html("保存");
	 	              }
	 	          }
			} 
			else {
				if(BimMobleBdip.toolPanel != null){
					BimMobleBdip.toolPanel.enterViewMode();
				}
				_markupsExtension.clear();
				_markup.unloadMarkupsAllLayers();
				
				if($('.btn-save').html()== "更新"){
					$('.btn-save').html("保存");
		        }
				passId = treeNode.id;
				if(clickFolder){
					onclickFolderShowButton();
					clickFolder = false;
				}else{
					hideButton();
					zTree.cancelSelectedNode();
					$("#" + panelId + "-m_folder")[0].style.display = "block";
					clickFolder = true;
					/*if(BimMobleBdip.toolPanel !=null || BimMobleBdip.toolPanel !=undefined){
						BimMobleBdip.Toolbar.setVisible(false);
					}*/
				}
				//zTree.expandNode(treeNode);
			}
	}
	
	/**右键菜单方法--新建文件夹**/
	function addTreeNode() {
		//hideRMenu();
		var id = randomWord(true,16,32);
		var fid = 0;
		var parentNode = null;
		var newNode;
		if(zTree.getSelectedNodes()[0] && zTree.getSelectedNodes()[0].isParent){
			fid = zTree.getSelectedNodes()[0].id;
			parentNode = zTree.getSelectedNodes()[0];
		}
		//保存到数据库
		var fd = new FormData();
        fd.append("did",id);
        fd.append("fdid",fid);
        fd.append("url",currentUrl);
        fd.append("type",viewType);
		fd.append("userid",currentUserid);
		fd.append("username",currentUsername);
		fd.append("modelid",currentModelid);
	    $.ajax({
    	  url:publicJS.tomcat_url+"/viewsave/createViewDir",
    	  type:'POST',
    	  data:fd,
		  dataType:'json',
    	  processData:false,
    	  contentType:false,
    	  success:function(obj){
    		  	var targetJson = obj.data;
				newNode = {id:id, pId:fid, name:targetJson.name, isParent:true, open:false};
				zTree.addNodes(parentNode, newNode);
				var currentNode = zTree.getNodeByParam("id", id, parentNode);
				zTree.selectNode(currentNode);
				zTree.editName(currentNode);
    	  },
    	  error:function(){
    		  //myApp.alert("保存失败","BDIP");
    		  myApp.addNotification({
				    message: '保存失败',
				    hold:1500,
				    closeIcon:false,
				    closeOnClick:true,
				    additionalClass:"notification-li-custom notification-li-custom-error"
			  });
    	  }
	   });
	}
	function randomWord(randomFlag, min, max){
	    var str = "",
	        range = min,
	        arr = ['0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 
	               'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 
	               'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 
	               'u', 'v', 'w', 'x', 'y', 'z', 'A', 'B', 'C', 'D', 
	               'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 
	               'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 
	               'Y', 'Z'];
	    // 随机产生
	    if(randomFlag){
	        range = Math.round(Math.random() * (max-min)) + min;
	    }
	    for(var i=0; i<range; i++){
	        pos = Math.round(Math.random() * (arr.length-1));
	        str += arr[pos];
	    }
	    return str;
	}
	
	/***删除一个节点**/
	function removeTreeNode() {
		//hideRMenu();
		var nodes = zTree.getSelectedNodes();
		if (nodes && nodes.length>0) {
			if (nodes[0].isParent) {
				 myApp.confirm('要删除的节点是父节点，确认删除吗？',"BDIP", 
					function () {
					 	beforeRemove("#" + panelId + "-treeDemo", nodes[0]);
						zTree.removeNode(nodes[0]);
				    }
				 );
			} else {
				myApp.confirm('确认删除吗？',"BDIP", 
					function () {
						beforeRemove("#" + panelId + "-treeDemo", nodes[0]);
						zTree.removeNode(nodes[0]);
				    }
				);
			}
		}
	}
	
	/***重命名一个节点**/
	function renameTreeNode() {
		//hideRMenu();
		//$('.node_name').css('color','#e4393c');
		var nodes = zTree.getSelectedNodes();
		if (nodes && nodes.length>0) {
			zTree.selectNode(nodes[0]);
			zTree.editName(nodes[0]);//重命名方法
		}
	}
	//tzw
	function shareTreeNode() {
		var nodes = zTree.getSelectedNodes();
		if(nodes==null || nodes == ""){
			$("#qrcode").html("");
			//myApp.alert("请选择需要分享的视点","BDIP");
			myApp.addNotification({
			    message: '请选择需要分享的视点',
			    hold:1500,
			    closeIcon:false,
			    closeOnClick:true,
			    additionalClass:"notification-li-custom notification-li-custom-error"
			});
		}else{
			if (nodes && nodes.length>0) {
				if(!nodes[0].isParent){
					BimMobleBdip.getPointById(nodes);
					myApp.popup('.popup-share');
				}else{
					//myApp.alert("该文件属于视点文件夹，不可分享","BDIP");
					myApp.addNotification({
					    message: '该文件属于视点文件夹，不可分享',
					    hold:1500,
					    closeIcon:false,
					    closeOnClick:true,
					    additionalClass:"notification-li-custom notification-li-custom-error"
					});
				}
			}
		}
	}
	var _timer = -1;
	function getContentTxt(url,callback){
		if(_timer!=-1){
			clearInterval(_timer);
			_timer = -1;
		}
	    //新建图片
	    var image = new Image();
	    image.src = url;
	    //解决canvas无法读取画布问题 
	    image.setAttribute('crossOrigin', 'anonymous');
	    //通加载图片完毕保证快速读取
	    var base64 = "";
	    image.onload = function(){
	    	//console.log(2);
	    	_timer = setInterval(function(){
	    		//console.log(3);
	    		base64 = getBase64Image(image);
	    		//console.log(base64);
	    		// if(base64 && (base64.indexOf('==')>-1 || base64.indexOf('=')>-1)){
	    		if(base64){
	    			if(_timer!=-1){
						clearInterval(_timer);
						_timer = -1;
					}
	        		if(callback){
	        		 	callback(base64);	
	        		}
	        	}
	    	},100);	        
	    }
	}
   function getBase64Image(img){
	    var canvas = document.createElement("canvas");
	    canvas.width = 150;
	    //console.log(img)
	    canvas.height = 150;
	    var ctx = canvas.getContext("2d");
	    ctx.drawImage(img,0,0,150,150);
	    var ext = img.src.substring(img.src.lastIndexOf(".")+1).toLowerCase();
	    //console.log(canvas)
	    var dataURL = canvas.toDataURL("image/jpeg");
	    return dataURL;
	}
	
	function ishave(url,okCallback,failCallback){
		var timeStart = new Date().getTime();
		jQuery.ajax({
			   "url":url,
			   "type":'HEAD',
			   "timeout" : 2000, //超时时间设置，单位毫秒
			   "error": function() {
			   		var timespan = new Date().getTime() - timeStart;
			   		console.log("页面不存在，耗时"+timespan+"毫秒");
			   		this.mrequest = false;
			       	if(failCallback){
	                	failCallback();//alert("页面不存在");
			       	}
	                
			   },
			   "success": function() {
			   		var timespan = new Date().getTime() - timeStart;
			   		console.log("页面存在，耗时"+timespan+"毫秒");
			   		this.mrequest = true;
					if(okCallback){
		            	okCallback();
					}
			   }
		});
	}



	/****************************************树状图相关函数到此结束***************************************/	
		
    // 私有成员
    var _thisPanel = this;
    var _controlIds = [];
    var _layerItems = {};
    var MarkupsCore = null;
    var _isVisible = false;
    var _isMinimized = false;
    var onceEdit = false;  

    // 用户页面    
    function generateHtml(id) {
      var html = '';
      html += '<div class="container">';
      html += '    	<div class="navBox" id="" >';
	    html += '		<div id="search" class="search">';
		  html += '          <b class="imgsearch" ></b>';
		  html += '          <input type="text"  id="'+id+'-searchtxt"  value="请输入内容，点击搜索" onfocus="if(value==\'请输入内容，点击搜索\')  {value=\'\'}" onblur="if (value==\'\') {value=\'请输入内容，点击搜索\'}"   name="name">';
		  html += '          <b class="clo1"  id="'+id+'-close">×</b>';
		  html += '          <button id="'+id+'-imgsearch" class="btnSearch" >搜索</button>';
		  html += '      </div>';
      html += '      </div>';
	    html += '    <div class="layer-list" id="'+id+'-layer-list" >';
	    html += '      		<ul id="'+id+'-treeDemo" class="ztree" name="zTreeRoot"></ul>';
	    html += '    </div> ';
	    html += '    <div id="tool_btn_box">';
	    html += '    		<button id="'+id+'-m_folder" class="btn btn-info"><b>新建目录</b></button>';
	    html += '    		<button id="'+id+'-m_childfolder" class="btn btn-info"><b>新建子目录</b></button>';
			html += '		<button id="'+id+'-m_newpoint" class="btn btn-info"><b>新建视点</b></button>';
			html += '		<button id="'+id+'-m_ren" class="btn btn-info"><b id="'+id+'-m_renName">重命名</b></button>';
			html += '		<button id="'+id+'-m_del" class="btn btn-info"><b id="'+id+'-m_shanchu">删除</b></button>';
			html += '		<button id="'+id+'-m_share" class="btn btn-info"> <b>分享</b></button>';
			html += '</div> ';
			html += '<div id="'+id+'-body-show" class="body-show"></div>';
			html += '<div id="'+id+'-body-hide" class="body-hide"></div>';
     	html += '</div>';
      return html;
    }
    function hideButton(){
  		$("#" + panelId + "-m_childfolder")[0].style.display = "none";
			$("#" + panelId + "-m_newpoint")[0].style.display = "none";
			$("#" + panelId + "-m_ren")[0].style.display = "none";
			$("#" + panelId + "-m_del")[0].style.display = "none";
			$("#" + panelId + "-m_share")[0].style.display = "none";
    }
    //初始化页面菜单
    function initialize() {
      _thisPanel.content = document.createElement('div');
      	$(_thisPanel.container).addClass('markup markup-mobile-body');
      	$(_thisPanel.container).append(generateHtml(panelId));  
    	/**除“新建目录”按钮外，隐藏所以按钮**/
      	hideButton();
      	/*****************给保存按钮和涂鸦样式绑定点击事件*****************************/
      	$("#" + panelId + "-btn-save").click(onSaveLayer);
				$("#" + panelId + "-imgsearch").click(openSearch); //打开搜索
				$("#" + panelId + "-close").click(closeShow); //关闭搜索
				
				$("#" + panelId + "-body-show").click(markupbodyShow);
				$("#" + panelId + "-body-hide").click(markupbodyHide);
				
				/**开始给树状图绑定点击事件**/
				$("#" + panelId + "-m_folder").click(addTreeNode); //新建文件夹
				$("#" + panelId + "-m_childfolder").click(addTreeNode); //新建子目录
				$("#" + panelId + "-m_del").click(removeTreeNode); //删除
				$("#" + panelId + "-m_ren").click(renameTreeNode); //重命名
				$("#" + panelId + "-m_share").click(shareTreeNode); //分享
				$("#" + panelId + "-m_newpoint").click(showMobileMarkupTool); //新建视点打开涂鸦工具条
      	/**给树状图绑定点击事件结束**/
      	/***加载树**/
      	loadTree();
    }
    
    //加载树执行函数
    var zNodestemp = null;
    function loadTree(){
		zNodestemp = loadTreeData();
	    /***开始生成树**/
	    $.fn.zTree.init($("#" + panelId + "-treeDemo"), setting, zNodestemp);
			zTree = $.fn.zTree.getZTreeObj(panelId + "-treeDemo");
			rMenu = $("#" + panelId + "-rMenu");
  	    /***生成树结束，可以自由使用事先定义好的zTree函数**/
    }
  //专职加载树状图数据源的函数
	function loadTreeData(){
		/***加载树状图数据源开始***/
		var zNodes = '[';
		var zNodestemp;
		var item=null;
		/**异步获取文件夹树--数据源**/
		$.ajax({
			url:publicJS.tomcat_url+"/viewsave/getAllViewDirByModelid?modelid="+currentModelid,
			type:'GET',
			dataType:'json',
			async: false,
			success:function(obj){
				var data=obj.data;
				dataJson=JSON.parse(data);
				if(dataJson==null || dataJson == ""){
					hideButton();
					$("#" + panelId + "-m_folder")[0].style.display = "block";
				}else{
					for(var i=0;i<dataJson.length;i++){
						item = {
								id: dataJson[i][2].did,
								pId: dataJson[i][0].fdid,
								name: dataJson[i][1].fname,
								isViewPoint:true,
								isParent: true,
								open:false,
								drop:true
						}
						//一个文件夹节点
						zNodes += "{\"id\":\"" + item.id + "\",";
						zNodes += "\"pId\":\"" + item.pId + "\",";
						zNodes += "\"name\":\"" + item.name + "\",";
						zNodes += "\"isViewPoint\":" + item.isViewPoint + ",";
						zNodes += "\"isParent\":" + item.isParent + ",";
						zNodes += "\"open\":" + item.open + ",";
						zNodes += "\"drop\":" + item.drop + "},";
					} 	  
				}
			},
			error:function(){
				//myApp.alert("获取参数失败","BDIP");
				myApp.addNotification({
				    message: '获取数据失败，检查网络后重试',
				    hold:1500,
				    closeIcon:false,
				    closeOnClick:true,
				    additionalClass:"notification-li-custom notification-li-custom-error"
				});
			}
		});
		/**异步获取视点图树--数据源**/
		$.ajax({
			url:publicJS.tomcat_url+"/viewsave/getAllViewPointByModelid?modelid="+currentModelid,
			type:'get',
			dataType:'json',
			async: false,
			success:function(obj){
				var data=obj.data;
				dataJson=JSON.parse(data);
				for(var i=0;i<dataJson.length;i++){
					item = {
							id: dataJson[i][5].id,
							pId: dataJson[i][6].fid,
							name: dataJson[i][4].name,
							markupData:dataJson[i][3].mark,
							json:dataJson[i][0].json,
							add_id:dataJson[i][8].add_id,
							isViewPoint:true,
							isParent: false,
							drop:false
					}
					//一个视点图节点
					zNodes += "{\"id\":\"" + item.id + "\",";
					zNodes += "\"pId\":\"" + item.pId + "\",";
					zNodes += "\"name\":\"" + item.name + "\",";
					zNodes += "\"markupData\":\"" + item.markupData + "\",";
					zNodes += "\"json\":\"" + item.json + "\",";
					zNodes += "\"add_id\":\"" + item.add_id + "\",";
					zNodes += "\"isViewPoint\":" + item.isViewPoint + ",";
					zNodes += "\"isParent\":" + item.isParent + ",";
					zNodes += "\"drop\":" + item.drop + "},";
				}
			},
			error:function(){
				//myApp.alert("获取参数失败","BDIP");
				myApp.addNotification({
				    message: '获取数据失败，检查网络后重试',
				    hold:1500,
				    closeIcon:false,
				    closeOnClick:true,
				    additionalClass:"notification-li-custom notification-li-custom-error"
				});
			}
		});
		if(zNodes.length>1){
			zNodes = zNodes.substring(0,zNodes.length-1);//去除最后的","
		}      	  
		zNodes += ']';
		zNodestemp = JSON.parse(zNodes);//转换为json对象
		return zNodestemp;
	}
	
    //保存
    function onSaveLayer() {
    	//debugger;
    	if(zTree.getSelectedNodes()[0] && !zTree.getSelectedNodes()[0].isParent){
    		var targetNode = zTree.getSelectedNodes()[0];
			updateTreeNode(targetNode);
    	} else {
		  var dataUrl = viewer.getScreenShotBuffer();
		  //压缩dataUrl
		  compressImg(dataUrl,300,600,function(finalDataUrl){
		    if (finalDataUrl) {
		    	console.log("压缩后的dataUrl数据："+finalDataUrl);
		    	var compressBlob = BimMobleBdip.dataURLtoBlob(finalDataUrl);
		    	saveViewPoint(compressBlob);
		    }else{
		    	console.log("压缩失败，用原始的dataUrl数据："+dataUrl);
		    	var originalBlob = BimMobleBdip.dataURLtoBlob(dataUrl);
		    	saveViewPoint(originalBlob);
		    }
		  });
		}
    }
    function saveViewPoint(blob){
    	  //添加一个子节点到树结构中
	      var id = guid();
		  var fid = 0;
		  var parentNode = null;
		  var newNode;
	      if (zTree.getSelectedNodes()[0] && zTree.getSelectedNodes()[0].isParent) {
				fid = zTree.getSelectedNodes()[0].id;
				parentNode = zTree.getSelectedNodes()[0];
	      }		
	      //var name = getViewName();
		  var data_mark="";
		  var markup_id = randomWord(true,16,32);
		  if(!_viewMode){
			  //var markString = _markupsExtension.generateData().replace(/\"/g,"'");
			  var markString = markNew;
			  if(markString!=null && markString.length>0){
				 data_mark += markup_id+"@BIM@"+markString;
			  }
		  }
		  
		  var tmpState=viewer.getState({ viewport:true });
		  var jsonString=JSON.stringify(tmpState);
		  jsonString=jsonString.replace(/\"/g,"'");
		
		  var fd = new FormData();
		  fd.append("jsonString",jsonString);
		  fd.append("image",blob);
		  fd.append("guid",id);
		  fd.append("markup",data_mark);
		  fd.append("fid",fid);
		  fd.append("url",currentUrl);
		  fd.append("add_id",id);
		  fd.append("type",viewType);
		  fd.append("userid",currentUserid);
		  fd.append("username",currentUsername);
		  fd.append("modelid",currentModelid);
		  //保存到数据库

		  myApp.showIndicator();   //开始转圈圈
		  $.ajax({
				url:publicJS.tomcat_url+"/viewsave/createViewPoint",
				type:'POST',
				data:fd,
				dataType:'json',
				processData:false,
				contentType:false,
				beforeSend:function(){
					//$("#" + panelId + "-btn-save").attr({ disabled: "disabled" });
					//$('#load_div').show();
					//$("#" + panelId + "-layer-list").append("<div id='load'><img src='icon/loading01.jpg' style='width:100px;height:100px'/></div>");src='icon/loading01.jpg' style='width:100px;height:100px'/></div>");
				},
				success:function(obj){
					markupbodyShow();
					//$('.dockingPanel.markup').show();
					/*$('#load_cont').html('<img class="suc_img" src="icon/success.png"><b class="suc_cont">保存成功</b>');
					setTimeout(function hiddenIoad() {
										//关闭load,还原load内容
										$('#load_div').hide();
										$('#load_cont').html('<img class="load_img" src="icon/loading01.gif" /><b  class="load_b" >正在保存，请稍后~</b>');
					}, 2000);*/
  		    var targetJson = obj.data; 
					newNode = {id:targetJson.id, pId:fid, name:targetJson.name, isParent:false};
					zTree.addNodes(parentNode, newNode);
					var currentNode = zTree.getNodeByParam("id", targetJson.id, parentNode);
					zTree.selectNode(currentNode);
					zTree.editName(currentNode);
					myApp.hideIndicator();		//结束转圈圈
				},
				error:function(){
					//myApp.alert("保存失败","BDIP");
					myApp.addNotification({
					    message: '保存失败',
					    hold:1500,
					    closeIcon:false,
					    closeOnClick:true,
					    additionalClass:"notification-li-custom notification-li-custom-error"
					});
				}
		});
    }
    
    //更新涂鸦
	function updateTreeNode(targetNode){
	    var dataUrl = viewer.getScreenShotBuffer();
	    //压缩dataUrl
	    compressImg(dataUrl,300,600,function(finalDataUrl){
		    if (finalDataUrl) {
		    	console.log("压缩后的dataUrl数据："+finalDataUrl);
		    	var compressBlob = BimMobleBdip.dataURLtoBlob(finalDataUrl);
		    	updateViewPoint(compressBlob,targetNode);
		    }else{
		    	console.log("压缩失败，用原始的dataUrl数据："+dataUrl);
		    	var originalBlob = BimMobleBdip.dataURLtoBlob(dataUrl);
		    	updateViewPoint(originalBlob,targetNode);
		    }
	    });
	}
	function updateViewPoint(blob,targetNode){
		var upd_mark="";
		var bef_mark=zTree.getSelectedNodes()[0].markupData;
		var markupArray = new Array();
		if(bef_mark.length>0){
			markupArray = bef_mark.split("@#@");
		}
		var markup_id = randomWord(true,16,32);
		if(!_viewMode){
			//var markString = _markupsExtension.generateData().replace(/\"/g,"'");
			var markString =markNew;
			if(markString!=null && markString.length>0){
				upd_mark += markup_id+"@BIM@"+markString;
				markupArray.push(upd_mark);
			}
		}
		var markups = markupArray.join("@#@");

	    var tmpState=viewer.getState();//getState({ viewport:true })
	    var jsonString=JSON.stringify(tmpState);
	    jsonString=jsonString.replace(/\"/g,"'");
	    
	    var fd = new FormData();
	    fd.append("jsonString",jsonString);
	    fd.append("image",blob);
	    fd.append("markup",markups);
	    fd.append("id",targetNode.id);
	    //保存到数据库
	    myApp.showIndicator();   //开始转圈圈
	    $.ajax({
	  	  url:publicJS.tomcat_url+"/viewsave/updateViewMarkup",
	  	  type:'POST',
	  	  data:fd,
	  	  dataType:'text',
	  	  processData:false,
	  	  contentType:false,
	  	  success:function(){
	  		  //操作成功，刷新页面
	  		  //$('.dockingPanel.markup').show();
	  		  markupbodyShow();
  	  		  loadTree();
  	  		_markupsExtension.unloadMarkupsAllLayers();
  	  		_viewMode = true;
  	  		  isFirstClick = true;
  		    _markupsExtension.clear();
  		    zTree.selectNode(targetNode);
  		    myApp.hideIndicator();		//结束转圈圈
	  	  },
	  	  error:function(){
	  		//myApp.alert("更新失败","BDIP");
	  		myApp.addNotification({
	  		    message: '更新失败',
	  		    hold:1500,
	  		    closeIcon:false,
	  		    closeOnClick:true,
	  		    additionalClass:"notification-li-custom notification-li-custom-error"
	  		});
	  	  }
	    });
	}
  
	 //**********************************根据关键字搜索*************************
	
	function openSearch(){
		selectByName();
	}
	 function closeShow() {
	 	   $('.search input[type=text]').val("");
	  	   loadTree();
	 }
	 
	var searchData = null ;
    function selectByName(){
    	  var zNodes = '[';
          var zNodestemp;
          var item=null;
		  var fid = 0;
		  var parentNode = null;
		  var nodes = zTree.getSelectedNodes();
		  console.log(nodes);
      var name = $("#" + panelId + "-searchtxt").val(); //${id}-search
      name = name.replace(/(^\s*)|(\s*$)/g, "");
		  if(name && name.length>0 && name!='请输入搜索内容...'){
			  if(nodes[0] && nodes[0].isParent){
					parentNode = nodes[0];
			  }
			  var zNodes = zTree.getNodesByFilter(
					  function(node){
						  if(node.isParent){
							    var extraParam = name;
								var tempParentNode = node;
								var tempNodes = zTree.getNodesByFilter(
									function(tempNode){
										return !tempNode.isParent && tempNode.name.indexOf(extraParam)>-1;
									},
									false,
									tempParentNode,
									extraParam
								);
								if(tempNodes && tempNodes.length>0){
									//console.log("内部最终的结果"+JSON.stringify(tempNodes));
									return true; 
								}
						  }else{
								//console.log("进入子");
								if(node.name.indexOf(name)>-1){
									return true;
								}
							}
							return false;
					},
					false,
					parentNode,
					name
			  );
			  var finalNodes = new Array();
			  if(zNodes && zNodes.length>0){
				  var itemP,itemS;
					for(var i=0;i<zNodes.length;i++){
						var targetNode = zNodes[i];
						if(targetNode.isParent){
							itemP = {
								//一个文件夹节点
								"id":targetNode.id,
								"pId":targetNode.pId,
								"name":targetNode.name,
								"isViewPoint":targetNode.isViewPoint,
								"isParent":targetNode.isParent,
								"open":targetNode.open,
								"drop":targetNode.drop
							};
							finalNodes.push(itemP);
						}else{
							itemS = {
								//一个视点图节点
								"id":targetNode.id,
								"pId":targetNode.pId,
								"name":targetNode.name,
								"markupData":targetNode.markupData,
								"json":targetNode.json,
								"add_id":targetNode.add_id,
								"isViewPoint":targetNode.isViewPoint,
								"isParent":targetNode.isParent,
								"drop":targetNode.drop
							};
							finalNodes.push(itemS);
						}
					}
			  }else{
					finalNodes = zNodes;
			  }
			  /*** 最终加上选择的父目录 **/
			  if(finalNodes && finalNodes.length>0){
				  if(parentNode){
					  	var parentNodeItem = {
							//选择的根节点
							"id":parentNode.id,
							"pId":parentNode.pId,
							"name":parentNode.name,
							"isViewPoint":parentNode.isViewPoint,
							"isParent":parentNode.isParent,
							"open":parentNode.open,
							"drop":parentNode.drop	
						}
						finalNodes.push(parentNodeItem);
				   }
			  }
			  console.log("最终的结果长度："+finalNodes.length +",内容为："+JSON.stringify(finalNodes));
		  	  $.fn.zTree.init($('#' + panelId + '-treeDemo'), setting, finalNodes);
					$('.search input[type=text]').val(name);
	  	}else{
	  		//myApp.alert("请输入查询的视点名称","BDIP");
	  		myApp.addNotification({
	  		    message: '请输入查询的视点名称',
	  		    hold:1500,
	  		    closeIcon:false,
	  		    closeOnClick:true,
	  		    additionalClass:"notification-li-custom notification-li-custom-error"
	  		});
	  	}
    }
    
    //新建视点打开工具条
    var tool = null;
    function showMobileMarkupTool(){
    	if($('.btn-save').html()== "更新"){
			$('.btn-save').html("保存");
        }
    	if(BimMobleBdip.toolPanel != null){
    		BimMobleBdip.toolPanel.setVisible(true);
    	}
		if(BimMobleBdip.count==0){
    		if(BimMobleBdip.toolPanel !=null || BimMobleBdip.toolPanel !=undefined){
    			BimMobleBdip.toolPanel.setVisible(false);
             }
			setTimeout(function(){
				viewer.unloadExtension('Autodesk.ADN.Viewing.Extension.MobileMarkupTool');
				viewer.loadExtension('Autodesk.ADN.Viewing.Extension.MobileMarkupTool');
				BimMobleBdip.toolPanel = viewer.loadedExtensions['Autodesk.ADN.Viewing.Extension.MobileMarkupTool'].getToolPanel();
				BimMobleBdip.count = 1;
			}, 300);
		}
		markupbodyHide();
    }
    
     //通过id将mark字段内容清空而达到保存过的涂鸦被清除的效果
    function removeMark(){
			var treeNode = BimMobleBdip.treeNode;
			var id = treeNode.id;
			var newMark = "";
			var readurl = publicJS.tomcat_url + "/viewsave/removeMarkById?id="+id+"&markup="+newMark;
			$.ajax({
				url : readurl,
				type : 'POST',
				dataType : 'json',
				processData : false,
				contentType : false,
				success : function(data){
					if(data.code=="200"){
						var markup = data.data;
						BimMobleBdip.treeNode.markupData = markup;
						zTree.updateNode(BimMobleBdip.treeNode);
					}
					_markupsExtension.unloadMarkupsAllLayers();
				},
				error : function(data){
					console.log("移除涂鸦失败....");
				}
			});
		}
    /************************************分隔线***********************************************/

    //编辑模式
    function enterEditMode() {
      _viewMode = false;
        onceEdit = true;
      _markupsExtension.show();
      //_markupsExtension.enterEditMode();//拖动
    }
    
    //浏览模式
    function enterViewMode() {
      _viewMode = true;
        onceEdit = false;
     // _markupsExtension.leaveEditMode();//拖动
      _markupsExtension.hide();
    }
    
    function cancelTree(){  //点击工具条中的Cancel按钮取消视点列表中选中视点事件
    	zTree.cancelSelectedNode();
    }
   
    _thisPanel.unload = function() {
      _thisPanel.setVisible(false);
    }
    _thisPanel.onSaveLayer=onSaveLayer;
    _thisPanel.enterEditMode=enterEditMode;
	_thisPanel.enterViewMode=enterViewMode;
	_thisPanel.cancelTree=cancelTree;
	_thisPanel.hideButton=hideButton;
	
	_thisPanel.removeMark=removeMark;//清除保存过的视点涂鸦
	
	
	
    _thisPanel.setVisible = function(show) {
	      _isVisible = show;
	      //btnElement.classList.toggle('active');
	      Autodesk.Viewing.UI.DockingPanel.prototype.
	        setVisible.call(this, show);
	   
	      if(show){  
	        	viewer.loadExtension('Autodesk.Viewing.MarkupsCore');
	    	  	_markup = viewer.getExtension("Autodesk.Viewing.MarkupsCore");
	    	  	var config = {markupDisableHotkeys:false};
	    	  	_markupsExtension = new Autodesk.Viewing.Extensions.Markups.Core.MarkupsCore(viewer,config);
	    	  	_markupsExtension.load();
	    	  	enterViewMode();
	      }
	      else {
		  	  	_markupsExtension.leaveEditMode();
    	  	  	_markupsExtension.hide();
		  		viewer.unloadExtension('Autodesk.Viewing.MarkupsCore');
		  		//_markupsExtension.markup = null;
    	  	    if(BimMobleBdip.toolPanel == null || BimMobleBdip.toolPanel ==undefined || BimMobleBdip.toolPanel ==''){
    	  	    	
    	  	    }else{
    	  	    	BimMobleBdip.toolPanel.setVisible(show);
    	  	    }
	    	  	if(!BimMobleBdip.isFromButtonToPoint){
		    	  $(BimMobleBdip.btnElementToPoint).removeClass('active');
					  $(BimMobleBdip.btnElementToPoint).addClass('inactive');
					  BimMobleBdip.beVisibleToPoint = false;
		    	}
	    	  	BimMobleBdip.isFromButtonToPoint = false;
    	  	    //$(btnElement).removeClass('active');
    	  	    BimMobleBdip.showTool = 0 ;
    	  	    $(".viewcube").hide(); //移动端隐藏右上角的视图立方体
    	  	    $("#toolbar-sectionTool").show();;//移动端剖切显示 
    	  	    BimMobleBdip.CancelSelectBox();
	      }
    }

    _thisPanel.toggleVisibility = function() {
      _panel.setVisible(!_isVisible);
    }
    _thisPanel.initialize = function() {
      this.title = this.createTitleBar(
        this.titleLabel ||
        this.container.id);

      this.closer = this.createCloseButton();

      this.container.appendChild(this.title);
      this.title.appendChild(this.closer);
      this.container.appendChild(this.content);

      this.initializeMoveHandlers(this.title);
      this.initializeCloseHandler(this.closer);
    }
    _thisPanel.onTitleDoubleClick = function (event) {
      _isMinimized = !_isMinimized;
      if(_isMinimized) {
        $(_thisPanel.container).addClass(
          'minimized');
      }
      else {
        $(_thisPanel.container).removeClass(
          'minimized');
      }
    }
    initialize();
  }
  MarkupPanel.prototype = Object.create(Autodesk.Viewing.UI.DockingPanel.prototype);
  MarkupPanel.prototype.constructor = MarkupPanel;
};
Autodesk.ADN.Viewing.Extension.MarkupMobile.prototype =Object.create(Autodesk.Viewing.Extension.prototype);
Autodesk.ADN.Viewing.Extension.MarkupMobile.prototype.constructor =Autodesk.ADN.Viewing.Extension.MarkupMobile;
Autodesk.Viewing.theExtensionManager.registerExtension('Autodesk.ADN.Viewing.Extension.MarkupMobile',Autodesk.ADN.Viewing.Extension.MarkupMobile);