AutodeskNamespace("Autodesk.ADN.Viewing.Extension");

Autodesk.ADN.Viewing.Extension.MobileMarkupTool = function (viewer, options) {
		Autodesk.Viewing.Extension.call(this, viewer, options);
		
		var _panel = null;
		var toolbar = null;
		var toolbarWidth = null;
		var _viewMode = true;
		var onceEdit = false;
		var _markup = null;
		var _markupsExtension = null;
		this.getToolPanel = function(){
		  	return _panel;
		}
		
		this.load = function () {
			_panel = new Panel(viewer.container,guid());
			_panel.setVisible(true);
			console.log('Autodesk.ADN.Viewing.Extension.DockingPanel loaded');
			return true;
		}

		// 随机id
		function guid() {
			var d = new Date().getTime();
			var guid = 'xxxx-xxxx-xxxx-xxxx'.replace(
				/[xy]/g,
				function (c) {
					var r = (d + Math.random() * 16) % 16 | 0;
					d = Math.floor(d / 16);
					return (c == 'x' ? r : (r & 0x7 | 0x8)).toString(16);
				});
			return guid;
		}

		var Panel = function(parentContainer, id) {
			var _thisPanel = this;
			_thisPanel.content = document.createElement('div');
			Autodesk.Viewing.UI.DockingPanel.call(
				this,
				parentContainer,
				id,
				'工具条',
				{shadow:true}
			);
			$(_thisPanel.container).addClass('docking-markup');
			
			/*******************************我是一条华丽的分割线（开始）**********************************/
			function initialize(){
				var container=id + '-dropdown-mode-container';
				var dropdown = createDropdownMenu(container,'涂鸦类型');
				$('#' +id + '-btn-save').click(onSave);
			}
			
			function changeButton(){
				var btnSave = $('.btn-save')[0];
			}
			//保存视点
			function onSave(){
				var data_mark = "";
				if(_markupsExtension.duringEditMode){
					data_mark = _markupsExtension.generateData();
					data_mark=data_mark.replace(/\"/g,"'");
				}
				BimMobleBdip.view.loadedExtensions["Autodesk.ADN.Viewing.Extension.MarkupMobile"].getMarkup(data_mark).onSaveLayer();
				enterViewMode();
			}
			
		    function createDropdownMenu(parent, title) {
		        var html = [
		            '<div  class="container">',
			            	'<div id="'+id+'-tymenu" class="dropdown chart-dropdown">',
				            	'<ul id="' + id + '-dropdown-menu1" class="dropdown-ul-mobile">',
					            	'<li  hidden="true">',
										'<input type="hidden" value="cir" name="circle">',
										'<img src="" alt="" title="圆" id="' + id + '-cir">',
									'</li>',
						            '<li>',
										'<input type="hidden" value="arro" name="arrow">',
										'<img src="" alt="" title="箭头" id="' + id + '-arro">',
									'</li>',
									'<li>',
										'<input type="hidden" value="line" name="freehand">',
										'<img src="" alt="" title="自由线" id="' + id + '-line">',
									'</li>',
									'<li>',
										'<input type="hidden" value="txt" name="text" >',
										'<img src="" alt="" title="文本" id="' + id + '-txt">',
									'</li>',
									'<li>',
				            			'<input type="hidden" value="undo" name="undo" >',
				            			'<img src="" alt="" title="撤销" id="' + id + '-undo">',
				            		'</li>',
				            		'<li>',
				            			'<input type="hidden" value="delete" name="delete" >',
				            			'<img src="" alt="" title="清除" id="' + id + '-delete">',
				            		'</li>',
				            		'<li>',
				            			'<input type="hidden" value="cancel" name="cancel" >',
				            			'<img src="" alt="" title="Cancel" id="' + id + '-cancel">',
				            		'</li>',
				            	'</ul>',
				            '</div>',
					         '<button class="btn-save"  id="' +id+ '-btn-save"  data-placement="bottom" data-toggle="tooltip">保存</button>',
					'</div>',
		        ];
		        $(_thisPanel.container).append(html.join('\n'));
  	      		var drop_menu = document.getElementById(id+'-dropdown-menu1');
  	      		var drop_inputs = drop_menu.getElementsByTagName("input");
  	      		var drop_imgs = drop_menu.getElementsByTagName("img");
  	      		function changehs(){
  	      			for (var i = 0; i < drop_inputs.length; i++) {
					drop_imgs[i].src = publicJS.tomcat_url + "/img/icon/"+ drop_inputs[i].value + "h.png";
  					}
  	      		}
  	      		changehs();
      		    //drop_imgs[0].src = publicJS.tomcat_url + "/img/icon/"+ drop_inputs[0].value + "w.png";
  	      		for (var i = 0; i < drop_imgs.length; i++) {
      				drop_imgs[i].index = i;
      				drop_imgs[i].onclick = function(){
      					markupbodyHide();
      					if(!onceEdit){
      						enterEditMode();
      						onceEdit = true;
      					}
      					var j = this.index;
      					changehs();
      					this.src = publicJS.tomcat_url + "/img/icon/"+ drop_inputs[j].value + "w.png";
      					setEditMode(drop_inputs[j].name);
      				}
  	      		}		
		    }
			//设置涂鸦样式
			var MarkupCore=Autodesk.Viewing.Extensions.Markups.Core;
		    var unloadTool = 0;
			function setEditMode(mode) {
				switch(mode){
					case 'circle':    
						enterEditModeToDrag();
						break;
				
					case 'arrow':    
						enterEditMode();
						var mode = new MarkupCore.EditModeArrow(_markupsExtension);
						_markupsExtension.changeEditMode(mode);
						break;
						
					case 'freehand':    
						enterEditMode();
						var mode = new MarkupCore.EditModeFreehand(_markupsExtension);
						_markupsExtension.changeEditMode(mode);
						break;
						
					case 'text':    
						enterEditMode();
						var mode = new MarkupCore.EditModeText(_markupsExtension);
						_markupsExtension.changeEditMode(mode);
						break;
						
					case 'undo':    //撤销
						_markupsExtension.undo();
						break;
						
					case 'delete':    //清除
						//_markupsExtension.clear();
						_markupsExtension.unloadMarkupsAllLayers();
						BimMobleBdip.mainPanel.removeMark(); //清除保存过的涂鸦视点
						break;
						
					case 'cancel':     //还原
					     BimMobleBdip.count = 0; //当新建视点时出现工具并判断出现次数
					     BimMobleBdip.showTool  = 0;  //当点击视点时出现工具并判断出现次数
					     unloadTool = 1;
					     _panel.setVisible(false);
					   	 if($('.btn-save').html()== "更新"){
							$('.btn-save').html("保存");
		 	             }
					     BimMobleBdip.mainPanel.enterViewMode();
					     $(".viewcube").hide(); //移动端隐藏右上角的视图立方体
			    	  	 $("#toolbar-sectionTool").show();//移动端剖切显示
			    	  	 //markupbodyShow();
			    	  	 //$(".body-show").hide();
						 break;
				}
			}
			/*******************************我是一条华丽的分割线（结束）**********************************/
			_thisPanel.changeButton = changeButton;
			_thisPanel.setEditMode = setEditMode;
			_thisPanel.enterViewMode = enterViewMode;
			_thisPanel.enterEditModeToDrag = enterEditModeToDrag;
			_thisPanel.enterViewModeToDrag = enterViewModeToDrag;
			
			//点击视点时可拖动不可涂鸦
			function enterEditModeToDrag(){
				_viewMode = false;
			      onceEdit = true;
			    _markupsExtension.show();
			}
			function enterViewModeToDrag(){
				_viewMode = true;
			      onceEdit = false;
			    _markupsExtension.hide();
			}
			
			//进入编辑模式
			function enterEditMode(){
				_viewMode = false;
			      onceEdit = true;
			    _markupsExtension.show();
			    _markupsExtension.enterEditMode();
			}
			//进入浏览模式
			function enterViewMode(){
				_viewMode = true;
			      onceEdit = false;
			    _markupsExtension.leaveEditMode();
			    _markupsExtension.hide();
			}
			
			// 显示面板
			_thisPanel.setVisible = function(show) {
				Autodesk.Viewing.UI.DockingPanel.prototype.setVisible.call(this, show);
				if(show){  
						viewer.loadExtension('Autodesk.Viewing.MarkupsCore');
			    	  _markup = viewer.getExtension("Autodesk.Viewing.MarkupsCore");
			    	    var config = {markupDisableHotkeys:false};
			    	  _markupsExtension = new Autodesk.Viewing.Extensions.Markups.Core.MarkupsCore(viewer,config);
			    	  _markupsExtension.load();
			    	    //enterViewMode();
			    	  enterViewModeToDrag();
				}
			    else {
			    	if(unloadTool ==1){
			    		_markupsExtension.leaveEditMode();
						_markupsExtension.hide();
			    	}else{
			    		 viewer.unloadExtension('Autodesk.Viewing.MarkupsCore');
					   _markupsExtension.leaveEditMode();
					   _markupsExtension.hide();
			    	}
			    }  
			}

			// 初始化
			_thisPanel.initialize = function() {
				this.title = this.createTitleBar(this.titleLabel || this.container.id);

				this.closer = this.createCloseButton();
				this.container.appendChild(this.title);
				this.title.appendChild(this.closer);
				this.container.appendChild(this.content);
				this.initializeMoveHandlers(this.title);
				this.initializeCloseHandler(this.closer);
			};

			// 标题双击事件（隐藏页面）
			var _isMinimized = false;
			_thisPanel.onTitleDoubleClick = function (event) {
      				_isMinimized = !_isMinimized;
      				if(_isMinimized) {
      					$(_thisPanel.container).addClass(
      					'docking-panel-minimized');
      				}
      				else {
      					$(_thisPanel.container).removeClass(
      					'docking-panel-minimized');
      				}
			};
			initialize();
		};

		Panel.prototype = Object.create(Autodesk.Viewing.UI.DockingPanel.prototype);
		Panel.prototype.constructor = Panel;

		// 添加需要的css
		var css = [
		           
		          ].join('\n');

		$('<style type="text/css">' + css + '</style>').appendTo('head');
	};
	
	Autodesk.ADN.Viewing.Extension.MobileMarkupTool.prototype =
		Object.create(Autodesk.Viewing.Extension.prototype);

	Autodesk.ADN.Viewing.Extension.MobileMarkupTool.prototype.constructor =
		Autodesk.ADN.Viewing.Extension.MobileMarkupTool;

	Autodesk.Viewing.theExtensionManager.registerExtension(
			'Autodesk.ADN.Viewing.Extension.MobileMarkupTool',
			Autodesk.ADN.Viewing.Extension.MobileMarkupTool);