AutodeskNamespace("Autodesk.ADN.Viewing.Extension");

Autodesk.ADN.Viewing.Extension.MarkupTool.NewEdition = function (viewer, options) {
		Autodesk.Viewing.Extension.call(this, viewer, options);
		
		var _panel = null;
		var toolbar = null;
		var toolbarWidth = null;
		
		this.getToolPanel = function(){
		  	return _panel;
		}
		
		this.load = function () {
			_panel = new Panel(viewer.container,guid());
			_panel.setVisible(true);
			console.log('Autodesk.ADN.Viewing.Extension.DockingPanel loaded');
			return true;
		}

		// 随机id
		function guid() {
			var d = new Date().getTime();
			var guid = 'xxxx-xxxx-xxxx-xxxx'.replace(
				/[xy]/g,
				function (c) {
					var r = (d + Math.random() * 16) % 16 | 0;
					d = Math.floor(d / 16);
					return (c == 'x' ? r : (r & 0x7 | 0x8)).toString(16);
				});
			return guid;
		}

		var Panel = function(parentContainer, id) {
			var _thisPanel = this;
			_thisPanel.content = document.createElement('div');
			Autodesk.Viewing.UI.DockingPanel.call(
				this,
				parentContainer,
				id,
				'工具条',
				{shadow:true}
			);
			$(_thisPanel.container).addClass('docking-markup');
			
			/*******************************我是一条华丽的分割线（开始）**********************************/
			function initialize(){
				var container=id + '-dropdown-mode-container';
				var dropdown = createDropdownMenu(container,'涂鸦类型');
			}
			
		    function createDropdownMenu(parent, title) {
		        var html = [
		            '<div  class="container"  style="margin:0  auto;  padding:0px;">',
		             
		            '<div id="'+id+'-tymenu" class="dropdown chart-dropdown" style="width:100%;height:30%;color:red;float:left">',
			            	'<ul id="' + id + '-dropdown-menu1" class="dropdown-ul">',
					            '<li>',
									'<input type="hidden" value="arro" name="arrow">',
									'<img src="" alt="" title="箭头" id="' + id + '-arro">',
								'</li>',
								'<li>',
									'<input type="hidden" value="cir" name="circle" >',
									'<img src="" alt="" title="圆" id="' + id + '-cir">',
								'</li>',
								'<li>',
									'<input type="hidden" value="lace" name="cloud" >',
									'<img src="" alt="" title="花边" id="' + id + '-lace">',
								'</li>',
								'<li>',
									'<input type="hidden" value="line" name="freehand">',
									'<img src="" alt="" title="自由线" id="' + id + '-line">',
								'</li>',
								'<li>',
									'<input type="hidden" value="rect" name="rectangle">',
									'<img src="" alt="" title="矩形" id="' + id + '-rect">',
								'</li>',
								'<li>',
									'<input type="hidden" value="txt" name="text" >',
									'<img src="" alt="" title="文本" id="' + id + '-txt">',
								'</li>',
			            		'<li>',
			            			'<input type="hidden" value="undo" name="undo" >',
			            			'<img src="" alt="" title="撤销" id="' + id + '-undo">',
			            		'</li>',
			            		'<li>',
			            			'<input type="hidden" value="redo" name="redo" >',
			            			'<img src="" alt="" title="上一步" id="' + id + '-redo">',
			            		'</li>',
			            		'<li>',
			            			'<input type="hidden" value="delete" name="delete" >',
			            			'<img src="" alt="" title="清除" id="' + id + '-delete">',
			            		'</li>',
			            		'<li>',
			            			'<input type="hidden" value="cancel" name="cancel" >',
			            			'<img src="" alt="" title="Cancel" id="' + id + '-cancel">',
			            		'</li>',
			            	'</ul>',
			            '</div>',
					'</div>',
		        ];
		        $(_thisPanel.container).append(html.join('\n'));
  	      		var drop_menu = document.getElementById(id+'-dropdown-menu1');
  	      		var drop_inputs = drop_menu.getElementsByTagName("input");
  	      		var drop_imgs = drop_menu.getElementsByTagName("img");
  	      		function changehs(){
  	      			for (var i = 0; i < drop_inputs.length; i++) {
					drop_imgs[i].src = publicJS.tomcat_url + "/img/icon/"+ drop_inputs[i].value + "h.png";
  					}
  	      		}
  	      		changehs();
      		    drop_imgs[0].src = publicJS.tomcat_url + "/img/icon/"+ drop_inputs[0].value + "w.png";
  	      		for (var i = 0; i < drop_imgs.length; i++) {
      				drop_imgs[i].index = i;
      				drop_imgs[i].onclick = function(){
      					if(!bimViewPointNew.onceEdit){
      						bimViewPointNew.enterEditMode();
      					}
      					var j = this.index;
      					changehs();
  					this.src = publicJS.tomcat_url + "/img/icon/"+ drop_inputs[j].value + "w.png";
      					setEditMode(drop_inputs[j].name);
      				}
  	      		}		
		    }
			
			//隐藏工具栏
		    function hiddenTool(){
		    	var div_id = id+'-tymenu';
	        	var div_menu=document.getElementById(id);
	        	div_menu.style.display="none";
	        	toolbarWidth = $('#guiviewer3d-toolbar').width();
		    }
			//设置涂鸦样式
			var MarkupCore=Autodesk.Viewing.Extensions.Markups.Core;
			function setEditMode(mode) {
				switch(mode){
					case 'arrow':    
						bimViewPointNew.enterEditMode();
						var mode = new MarkupCore.EditModeArrow(bimViewPointNew.markup);
						bimViewPointNew.markup.changeEditMode(mode);
						break;
						
					case 'circle':    
						bimViewPointNew.enterEditMode();
						var mode = new MarkupCore.EditModeCircle(bimViewPointNew.markup);
						bimViewPointNew.markup.changeEditMode(mode);
						break;
						
					case 'cloud':    
						bimViewPointNew.enterEditMode();
						var mode = new MarkupCore.EditModeCloud(bimViewPointNew.markup);
						bimViewPointNew.markup.changeEditMode(mode);
						break;
						
					case 'freehand':    
						bimViewPointNew.enterEditMode();
						var mode = new MarkupCore.EditModeFreehand(bimViewPointNew.markup);
						bimViewPointNew.markup.changeEditMode(mode);
						break;
						
					case 'rectangle':    
						bimViewPointNew.enterEditMode();
						var mode = new MarkupCore.EditModeRectangle(bimViewPointNew.markup);
						bimViewPointNew.markup.changeEditMode(mode);
						break;
						
					case 'text':    
						bimViewPointNew.enterEditMode();
						var mode = new MarkupCore.EditModeText(bimViewPointNew.markup);
						bimViewPointNew.markup.changeEditMode(mode);
						break;
						
					case 'undo':    //撤销
						bimViewPointNew.markup.undo();
						break;
						
					case 'redo':     //上一步
						bimViewPointNew.markup.redo();
						break;
						
					case 'delete':    //清除
						bimViewPointNew.markup.clear();
						break;
						
					case 'cancel':     //还原
						_panel.setVisible(false);
						bimViewPointNew.count = 0;
						break;
				}
			}
			/*******************************我是一条华丽的分割线（结束）**********************************/
			// 显示面板
			_thisPanel.setVisible = function(show) {
				Autodesk.Viewing.UI.DockingPanel.prototype.setVisible.call(this, show);
				if(show){  
		        	toolbar = document.getElementById("guiviewer3d-toolbar");
		        	toolbar.style.display = "none";
			    }
			    else {
			    	if(bimViewPointNew.markup){
						bimViewPointNew.markup.leaveEditMode();
						bimViewPointNew.markup.hide();
					}
			    	bimViewPointNew.onceEdit = false;
				   	_panel = null;
				   	bimViewPointNew.toolPanel = null;
				   	hiddenTool();
				   	setTimeout(function(){
				   		toolbar.style.display = "block";
				   	},500);
			    }  
			}

			// 初始化
			_thisPanel.initialize = function() {
				this.title = this.createTitleBar(this.titleLabel || this.container.id);

				this.closer = this.createCloseButton();
				this.container.appendChild(this.title);
				this.title.appendChild(this.closer);
				this.container.appendChild(this.content);
				this.initializeMoveHandlers(this.title);
				this.initializeCloseHandler(this.closer);
			};

			// 标题双击事件（隐藏页面）
			var _isMinimized = false;
			_thisPanel.onTitleDoubleClick = function (event) {
      				_isMinimized = !_isMinimized;
      				if(_isMinimized) {
      					$(_thisPanel.container).addClass(
      					'docking-panel-minimized');
      				}
      				else {
      					$(_thisPanel.container).removeClass(
      					'docking-panel-minimized');
      				}
			};
			initialize();
		};

		Panel.prototype = Object.create(Autodesk.Viewing.UI.DockingPanel.prototype);
		Panel.prototype.constructor = Panel;

		// 添加需要的css
		var css = [
		           	'div.docking-markup {',
		           		'left: calc(52% - 399px);',
		           		'width: 45%;',
		           		'resize: none;',
		           		'display:block;',
		           		'height:40px !important;',
		           	    'padding-top: 8px;',
		           		'min-width: 41%;',
		           		'min-height: 40px;',
		           		'bottom: 30px;',
		           		'position: absolute;',
		           	'}',
		           	
		           	'div.dockingPanelTitle {',
		           		'display:block;',
		           	'}',
		           	
		           	'div.dockingPanelClose {',
		           		'display:block;',
		           	'}',
		          ].join('\n');

		$('<style type="text/css">' + css + '</style>').appendTo('head');
	};
	
	Autodesk.ADN.Viewing.Extension.MarkupTool.NewEdition.prototype =
		Object.create(Autodesk.Viewing.Extension.prototype);

	Autodesk.ADN.Viewing.Extension.MarkupTool.NewEdition.prototype.constructor =
		Autodesk.ADN.Viewing.Extension.MarkupTool.NewEdition;

	Autodesk.Viewing.theExtensionManager.registerExtension(
			'Autodesk.ADN.Viewing.Extension.MarkupTool.NewEdition',
			Autodesk.ADN.Viewing.Extension.MarkupTool.NewEdition);