'use strict';

var switchCss = '\n\n   .onoffswitch {\n      position: relative; width: 66px;\n      -webkit-user-select:none; -moz-user-select:none; -ms-user-select: none;\n    }\n\n    .onoffswitch-checkbox {\n        display: none;\n    }\n\n    .onoffswitch-label {\n        display: block; overflow: hidden; cursor: pointer;\n        border: 2px solid #999999; border-radius: 20px;\n    }\n\n    .onoffswitch-inner {\n        display: block; width: 200%; margin-left: -100%;\n        transition: margin 0.3s ease-in 0s;\n    }\n\n    .onoffswitch-inner:before, .onoffswitch-inner:after {\n        display: block; float: left; width: 50%; height: 23px; padding: 0; line-height: 23px;\n        font-size: 11px;\n        color: white;\n        font-family: Trebuchet, Arial, sans-serif;\n        font-weight: bold;\n        box-sizing: border-box;\n    }\n\n    .onoffswitch-inner:before {\n        content: "EDIT";\n        padding-left: 10px;\n        background-color: #42C542;\n        color: #FFFFFF;\n    }\n\n    .onoffswitch-inner:after {\n        content: " VIEW";\n        padding-right: 10px;\n        background-color: #EEEEEE; color: #999999;\n        text-align: right;\n    }\n\n    .onoffswitch-switch {\n        display: block; width: 18px; margin: 2.5px;\n        background: #FFFFFF;\n        position: absolute; top: 0; bottom: 0;\n        right: 39px;\n        border: 2px solid #999999; border-radius: 20px;\n        transition: all 0.3s ease-in 0s;\n    }\n\n    .onoffswitch-checkbox:checked + .onoffswitch-label .onoffswitch-inner {\n        margin-left: 0;\n    }\n\n    .onoffswitch-checkbox:checked + .onoffswitch-label .onoffswitch-switch {\n        right: 0px;\n    }\n\n  ';

$('<style type="text/css">' + switchCss + '</style>').appendTo('head');

/////////////////////////////////////////////////////////////////
// Generates random guid to use as DOM id
//
/////////////////////////////////////////////////////////////////
function guid() {

    var d = new Date().getTime();

    var guid = 'xxxx-xxxx-xxxx-xxxx'.replace(/[xy]/g, function (c) {
        var r = (d + Math.random() * 16) % 16 | 0;
        d = Math.floor(d / 16);
        return (c == 'x' ? r : r & 0x7 | 0x8).toString(16);
    });

    return guid;
}

/////////////////////////////////////////////////////////////
//
//
/////////////////////////////////////////////////////////////
function createSwitchButton(parent, checked, onChanged) {

    var inputId = guid();

    var labelId = guid();

    var html = ['<div class="onoffswitch">', '<input id="' + inputId + '" type="checkbox" name="onoffswitch"', 'class="onoffswitch-checkbox" ' + (checked ? "checked" : "") + '>', '<label id="' + labelId + '" class="onoffswitch-label" for="myonoffswitch">', '<span class="onoffswitch-inner"></span>', '<span class="onoffswitch-switch"></span>', '</label>', '</div>'];

    $(parent).append(html.join('\n'));

    $('#' + labelId).click(function (e) {

        var input = $('#' + inputId)[0];

        input.checked = !input.checked;

        onChanged(input.checked);
    });
}