var bimViewPointNew = {
	//全局变量名：变量值	
    btnElement : null,/***视点保存按钮对象**/
	markup : null,/***视点保存涂鸦对象**/	
	toolPanel : null,/***视点保存涂鸦工具条对象**/
	onceEdit : false,/***工具条中判断是否已经点击涂鸦类型一次**/
	count : 0,  /***判断工具条出现次数**/
	currentUrl : null,/***模型路径**/
	currentModelid : null,/***模型id**/
	currentUserid : null,/***用户id**/
	currentUsername : null,/***用户名**/
	viewType : "0",/***视点类型**/
	passId : null,/***预存储zTree之前一个点击的节点id**/
	viewMode : true,/***标记是否处于涂鸦的编辑模式**/
	beVisible : false,/***按钮 的选中切换判断**/
	isFirstClick : true,/***判断是否第一次点击zTree的节点**/
	zNodestemp : null,/***zTree数据**/
	zTree : null,/***zTree对象**/
	rMenu : null,/***zTree的右键对象**/
	setting : null,/***中zTree的属性配置对象**/
	/*** 初始化参数 **/
	initialize : function () {
		document.getElementById("div_viewpoint").style.top = "0px";
		
		/*** 定义button按钮对象 **/
		var viewer = BimBdip.view;
		var viewerToolbar = viewer.getToolbar(true);
		var ctrlGroup=viewerToolbar.getControl("bimbdip_viewToolBar");
		var button = ctrlGroup.getControl('bimbdip_button_viewpoint');
		bimViewPointNew.btnElement = button.container;
		
		/*** 获取当前用户和模型信息 **/
		bimViewPointNew.currentUrl = BimBdip.view_modelUrl;
		bimViewPointNew.currentModelid = BimBdip.lvmid;
		bimViewPointNew.currentUserid = BimBdip.currentUserid;
		bimViewPointNew.currentUsername = BimBdip.currentUsername;
		
		/*** 初始化zTree全局变量 **/
		bimViewPointNew.passId = null;
		bimViewPointNew.isFirstClick = true;
		bimViewPointNew.zNodestemp = null;
		bimViewPointNew.zTree = null;
		bimViewPointNew.rMenu = null;
		bimViewPointNew.setting = {
			view: {
				selectedMulti: false
			},	
			edit: {
				enable: true,
				editNameSelectAll: true,
				showRemoveBtn: false,
				showRenameBtn: false
			},
			data: {
				simpleData: {
					enable: true
				},
				keep:{
					parent:true,
					leaf:true
				}
			},
			check: {
				enable: true,
				chkStyle: "checkbox",
				chkboxType: {"Y":"s","N":"s"}
			},
			callback: {
				beforeDrag: bimViewPointNew.beforeDrag,
				beforeDrop: bimViewPointNew.beforeDrop,
				beforeRemove: bimViewPointNew.beforeRemove,
				beforeRename: bimViewPointNew.beforeRename,
				onDrop: bimViewPointNew.onDrop,
				onRightClick: bimViewPointNew.OnRightClick,
				beforeClick: bimViewPointNew.beforeClick,
				onClick: bimViewPointNew.onClick,
				onMouseUp: bimViewPointNew.onMouseUp,
				beforeCheck: bimViewPointNew.beforeCheck,
				onCheck: bimViewPointNew.onCheck
			}
		};
	},
	//清除之前的Panel弹框
	dockingPanelNone : function () {
        //关闭历史回话
        if(bimHistory){
        	hideButtonForHistory();
        }
        //关闭碰撞点上传
        if(bimCollision){
        	hideButtonForClash();
        }
	},
	//加载视点列表
	viewpoint_load : function () {
		var _this = this;
		_this.dockingPanelNone();
		_this.initialize();
		_this.toggleVisibilityForViewPoint();
	},
	viewpoint_unload : function () {
		bimViewPointNew.setVisibleForViewPoint(false);
	},
	hiddenViewPoint : function () {
		$(bimViewPointNew.btnElement).removeClass('active');
		$(bimViewPointNew.btnElement).addClass('inactive');
		bimViewPointNew.beVisible = false;
		var viewer = BimBdip.view;
		//侧边栏收起
		/*$('#div_viewpoint').css('right','-375px');*/
		hideSidePanel();
   		window.parent.hideSidePanel();
		//关闭涂鸦等
		bimViewPointNew.clearTree();
		bimViewPointNew.count = 0;
		bimViewPointNew.viewMode = true;
		if(bimViewPointNew.markup){
			bimViewPointNew.markup.leaveEditMode();
			bimViewPointNew.markup.hide();
			viewer.unloadExtension('Autodesk.Viewing.MarkupsCore');	
			bimViewPointNew.markup = null;
		}
		if(bimViewPointNew.toolPanel!=null){
			bimViewPointNew.toolPanel.setVisible(false);
		}
	},
	//修改enter按键事件
	viewpoint_keydown : function(e) {
		if(e.keyCode=='13'){
			bimViewPointNew.filterNodes();
		}
	},
	//转换baseUrl为Blob格式
	viewpoint_dataURLtoBlob : function (dataurl) {
		var arr = dataurl.split(','), mime = arr[0].match(/:(.*?);/)[1],
		bstr = atob(arr[1]), n = bstr.length, u8arr = new Uint8Array(n);
		while(n--){
			u8arr[n] = bstr.charCodeAt(n);
		}
		return new Blob([u8arr], {type:mime});
	},
	enterEditMode : function () {
		//alert("编辑模式.....");
		bimViewPointNew.viewMode = false;
		bimViewPointNew.onceEdit = true;
		bimViewPointNew.markup.show();
		bimViewPointNew.markup.enterEditMode();
	},
	enterViewMode : function () {
		//alert("浏览模式..");
		bimViewPointNew.viewMode = true;
		bimViewPointNew.onceEdit = false;
		bimViewPointNew.markup.leaveEditMode();
		bimViewPointNew.markup.hide();
	},
	// 随机id
	getGuid : function () {
		var d = new Date().getTime();
		var guid = 'xxxx-xxxx-xxxx-xxxx'.replace(
			/[xy]/g,
			function (c) {
				var r = (d + Math.random() * 16) % 16 | 0;
				d = Math.floor(d / 16);
				return (c == 'x' ? r : (r & 0x7 | 0x8)).toString(16);
			});
		return guid;
	},
	randomWord : function (randomFlag, min, max){
		var str = "",
		range = min,
		arr = ['0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 
		       'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 
		       'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 
		       'u', 'v', 'w', 'x', 'y', 'z', 'A', 'B', 'C', 'D', 
		       'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 
			   'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 
			   'Y', 'Z'];
		// 随机产生
		if(randomFlag){
			range = Math.round(Math.random() * (max-min)) + min;
		}
		for(var i=0; i<range; i++){
			pos = Math.round(Math.random() * (arr.length-1));
			str += arr[pos];
		}
		return str;
	},
	//显示工具条
	showMarkTool : function (){
		if(bimViewPointNew.count==0){
			BimBdip.view.unloadExtension('Autodesk.ADN.Viewing.Extension.MarkupTool.NewEdition');
			BimBdip.view.loadExtension('Autodesk.ADN.Viewing.Extension.MarkupTool.NewEdition');
			bimViewPointNew.toolPanel = BimBdip.view.loadedExtensions['Autodesk.ADN.Viewing.Extension.MarkupTool.NewEdition'].getToolPanel();
			bimViewPointNew.count = 1;
		}
	},
	//显示切换
	setVisibleForViewPoint : function (show){
		var viewer = BimBdip.view;
		bimViewPointNew.beVisible = show;
		bimViewPointNew.btnElement.classList.toggle('active');
		if(show){
			//定义涂鸦等
			viewer.loadExtension('Autodesk.Viewing.MarkupsCore');
			var config = {markupDisableHotkeys:false};
			bimViewPointNew.markup = new Autodesk.Viewing.Extensions.Markups.Core.MarkupsCore(viewer,config);
			bimViewPointNew.markup.load();
			bimViewPointNew.enterViewMode();
			if(!bimViewPointNew.zTree){
				bimViewPointNew.loadTree();
			}
			//侧边栏弹出
			/*$('#div_viewpoint').css('right','0px');*/
		}else{
			//侧边栏收起
			/*$('#div_viewpoint').css('right','-375px');*/
			//关闭涂鸦等
			//bimViewPointNew.clearTree();
			bimViewPointNew.count = 0;
			bimViewPointNew.viewMode = true;
			if(bimViewPointNew.markup){
				bimViewPointNew.markup.leaveEditMode();
				bimViewPointNew.markup.hide();
				viewer.unloadExtension('Autodesk.Viewing.MarkupsCore');	
				bimViewPointNew.markup = null;
			}
			if(bimViewPointNew.toolPanel!=null){
				bimViewPointNew.toolPanel.setVisible(false);
			}
		}
	},
	//按钮事件控制函数
	toggleVisibilityForViewPoint : function (){
		bimViewPointNew.setVisibleForViewPoint(!bimViewPointNew.beVisible);
	},
	/***************************************zTree  starting***************************************/
	//节点复选框被勾选之前的事件	
	beforeCheck : function (treeId, treeNode){
		return true;
	},
	//节点复选框勾选时的事件
	onCheck : function (event, treeId, treeNode){
		if (!treeNode.checked) {
			var parentNodes = treeNode.getPath();
			bimViewPointNew.allGoneParent(parentNodes);
		}else{
			var papaNode = treeNode.getParentNode();
			bimViewPointNew.loopCheck(papaNode);
		}
	},
	loopCheck : function (papaNode){
		if(papaNode!=null){
			var allDo = true;
			var allChild = papaNode.children;
			if(allChild && allChild.length>0){
				for (var i = 0; i < allChild.length; i++) {
					if (allChild[i].checked) {
						continue;
					}else{
						allDo = false;
						break;
					}
				}
			}
			if(allDo){
				papaNode.checked = true;
				bimViewPointNew.zTree.updateNode(papaNode,false);
				papaNode = papaNode.getParentNode();
				bimViewPointNew.loopCheck(papaNode);
			}else{
				var parentNodes = papaNode.getPath();
				bimViewPointNew.allGoneParent(parentNodes);
			}
		}
	},
	allGoneParent : function (parentNodes){
		if(parentNodes && parentNodes.length>0){
			for (var i = 0; i < parentNodes.length; i++) {
				parentNodes[i].checked = false;
				bimViewPointNew.zTree.updateNode(parentNodes[i],false);
			}
		}
	},
	//移入函数
	beforeDrag : function (treeId, treeNodes) {
		for (var i=0,l=treeNodes.length; i<l; i++) {
			if (treeNodes[i].drag === false) {
				return false;
			}
		}
		return true;
	},
	//移出函数
	beforeDrop : function (treeId, treeNodes, targetNode, moveType) {
		return targetNode ? targetNode.drop !== false : true;
	},

	//删除前函数，此函数为了执行后台删除业务而创建
	beforeRemove : function (treeId, treeNode){
		if(treeNode.isParent){
			return bimViewPointNew.deleteFolder(treeId, treeNode);
		} else {
			return bimViewPointNew.deleteFile(treeId, treeNode);
		}
	},
	deleteFolder : function (treeId, treeNode){
		$.ajax({
	    	  url:publicJS.tomcat_url+"/viewsave/deleteViewDir?did="+treeNode.id+"&modelid="+bimViewPointNew.currentModelid,
	    	  type:"GET",
	    	  dataType:"text",
	    	  processData:false,
	    	  contentType:false,
	    	  success:function(){
	    	  	  bimViewPointNew.markup.unloadMarkupsAllLayers();
	    	  	  bimViewPointNew.loadTree();
	    	  	  bimViewPointNew.enterViewMode();
//				  setTimeout(function(){
//				  	alert("删除成功！");
//				  },500)
				  //BimBdip.view.navigation.setRequestHomeView(true); //回归模型原始状态
			  	  return true;	 		
	    	  },
	    	  error:function(){
	    		  Dialog.alert("删除目录失败");
	    		  return false;
	    	  }
	     });
	},
	deleteFile : function (treeId, treeNode){
		$.ajax({
	    	  url:publicJS.tomcat_url+"/viewsave/deleteViewPoint?id="+treeNode.id+"&modelid="+bimViewPointNew.currentModelid,
	    	  type:"GET",
	    	  dataType:"text",
	    	  processData:false,
	    	  contentType:false,
	    	  success:function(){
			  	  bimViewPointNew.markup.unloadMarkupsAllLayers();
			  	  bimViewPointNew.loadTree();
			  	  bimViewPointNew.enterViewMode();
//				  setTimeout(function(){
//				  	alert("删除成功！");
//				  },500)
				  BimBdip.view.navigation.setRequestHomeView(true); //回归模型原始状态
			  	  return true;
	    	  },
	    	  error:function(){
	    		  Dialog.alert("删除视点失败");
	    		  return false;
	    	  }
	     });
	},

	//重命名提示
	beforeRename : function (treeId, treeNode, newName, isCancel) {
		var oldName = treeNode.name;
		var fid = 0;
		if(treeNode.getParentNode()){
			fid = treeNode.getParentNode().id;
		}
		if (newName.replace(/(^\s*)|(\s*$)/g, "").length == 0) {
			//zTree.cancelEditName();
			Dialog.alert("禁止输入空的名称！");
			setTimeout(function(){
			  //Dialog.alert("新名称不能为空");
				bimViewPointNew.zTree.cancelEditName();
			},500)
			return false;
		} else {
			if(treeNode.isParent){
				return bimViewPointNew.updateFolder(treeId, treeNode, newName, isCancel, fid, oldName);
			} else {
				return bimViewPointNew.updateFile(treeId, treeNode, newName, isCancel, fid, oldName);
			}
		}
	},
	updateFolder : function (treeId, treeNode, newName, isCancel, fid, oldName){
		$.ajax({
	    	  url:publicJS.tomcat_url+"/viewsave/updateViewDirName?fname="+newName+"&did="+treeNode.id+"&fdid="+fid+"&modelid="+bimViewPointNew.currentModelid,
	    	  type:"GET",
	    	  dataType:"text",
	    	  processData:false,
	    	  contentType:false,
	    	  success:function(obj){
	    	  	  var targetJson = JSON.parse(obj);
	    		  if(targetJson.code && targetJson.code=="222"){
	    			  //zTree.cancelEditName();
	    			  Dialog.alert("目录名称已存在");
	    			  setTimeout(function(){
		    	      	//Dialog.alert("目录名称已存在");
	    				treeNode.name = oldName;  
	    				bimViewPointNew.zTree.editName(treeNode);  
	    			  },100);
	    		  }else{
	    			  bimViewPointNew.loadTree();
	    			  bimViewPointNew.enterViewMode();
	    		  }
	    	  },
	    	  error:function(){
	    		  bimViewPointNew.zTree.cancelEditName();
	    		  Dialog.alert("重命名失败");
	    		  return false;
	    	  }
	     });
	},
	updateFile : function (treeId, treeNode, newName, isCancel, fid, oldName){
		$.ajax({
	    	  url:publicJS.tomcat_url+"/viewsave/updateViewName?name="+newName+"&id="+treeNode.id+"&fid="+fid+"&modelid="+bimViewPointNew.currentModelid,
	    	  type:"GET",
	    	  dataType:"text",
	    	  processData:false,
	    	  contentType:false,
	    	  success:function(obj){
	    	  	  var targetJson = JSON.parse(obj);
	    		  if(targetJson.code && targetJson.code=="222"){
	    			  //zTree.cancelEditName();
	    			  Dialog.alert("视点名称已存在");
					  setTimeout(function(){
					  	//Dialog.alert("视点名称已存在");
						treeNode.name = oldName;
						bimViewPointNew.zTree.editName(treeNode);  
					  },100);
	    		  }else{
	    			  bimViewPointNew.loadTree();
	    			  bimViewPointNew.enterViewMode();
	    		  }
	    	  },
	    	  error:function(){
	    		  bimViewPointNew.zTree.cancelEditName();
	    		  Dialog.alert("重命名失败");
	    		  return false;
	    	  }
	     });
	},

	/***拖拽事件结束后的数据操作***/
	onDrop : function (event, treeId, treeNodes, targetNode){
		var msg = "目标文件夹若包含同名视点或目录，系统会自动重命名该对象，确定继续吗？";
		Dialog.confirm(
			msg,function(){
				var id = "0";
				if(!targetNode && event.target.tagName.toLowerCase() != "button" && $(event.target).parents("a").length == 0){
					id = "0";
				}else{
					id = targetNode.id;
				}
				for(var i=0,l=treeNodes.length; i<l; i++){
					if(treeNodes[i].isParent){
						bimViewPointNew.dropParent(id,treeNodes[i].id,treeNodes[i].name);
					} else {
						bimViewPointNew.dropChild(id,treeNodes[i].id,treeNodes[i].name);
					}
				}
			},function (){
				setTimeout(function(){
					bimViewPointNew.loadTree();
				},500);
			}
		);
	},
	dropParent : function (fdid,did,fname){
		$.ajax({
			url:publicJS.tomcat_url+"/viewsave/updateParentNode?fdid="+fdid+"&did="+did+"&modelid="+bimViewPointNew.currentModelid+"&fname="+fname,
			type:'GET',
			dataType:'text',
			processData:false,
			contentType:false,
			success:function(){
				setTimeout(function(){
					bimViewPointNew.loadTree();
				},500);
			},
			error:function(){
				Dialog.alert("父节点拖拽失败");
			}
		});
	},
	dropChild : function (fid,id,name){
		$.ajax({
			url:publicJS.tomcat_url+"/viewsave/updateChildNode?fid="+fid+"&id="+id+"&modelid="+bimViewPointNew.currentModelid+"&name="+name,
			type:'GET',
			dataType:'text',
			processData:false,
			contentType:false,
			success:function(){
				setTimeout(function(){
					bimViewPointNew.loadTree();
				},500);
			},
			error:function(){
				Dialog.alert("子节点拖拽失败");
			}
		});
	},
	onMouseUp : function (event, treeId, treeNode){
		if(!treeNode && event.target.tagName.toLowerCase() != "button" && $(event.target).parents("a").length == 0){
			bimViewPointNew.zTree.cancelSelectedNode();
			bimViewPointNew.isFirstClick = true;
			bimViewPointNew.enterViewMode();
		}
	},
	/***点击事件之前的操作**/
	beforeClick : function (treeId, treeNode){
		if(!treeNode.isParent){
			var currentId = treeNode.id;
			if(!bimViewPointNew.passId || bimViewPointNew.passId.length==0){
				return true;
			} else {
				if(bimViewPointNew.passId==currentId){
					return true;
				}else{
					//bimViewPointNew.markup.unloadMarkupsAllLayers();
					bimViewPointNew.enterViewMode();
					bimViewPointNew.isFirstClick=true;
					return true;
				}
			}
		} else {
			bimViewPointNew.isFirstClick=true;
			return true;
		}
	},
	/***每个视点图节点的点击事件****/
	onClick : function (event, treeId, treeNode){
		if(!treeNode.isParent){
			bimViewPointNew.passId = treeNode.id;
			var vname=treeNode.name;
			var markup=treeNode.markupData;
			var markupList = new Array();
			if(bimViewPointNew.isFirstClick) {
				showMask("loading...");
				bimViewPointNew.markup.unloadMarkupsAllLayers();
				bimViewPointNew.enterViewMode();
				var json=treeNode.json.replace(/'/g,'"');
				var jsonObject = JSON.parse(json);
				BimBdip.view.restoreState(jsonObject);
				setTimeout(function(){
					bimViewPointNew.enterEditMode();
					if(markup && markup.replace(/(^\s*)|(\s*$)/g, "").length>0){
						markupList = markup.split("@#@");
						if(markupList!=null && markupList.length>0){
							//showMask("loading...");
							for(var i=0,l=markupList.length; i<l; i++){
								var singleMarkup = markupList[i].split("@BIM@");
								bimViewPointNew.markup.loadMarkups(
										singleMarkup[1].replace(/'/g,'"'),
										singleMarkup[0]);
							}
							//hideMask();
						}
					}
				},500);
				bimViewPointNew.isFirstClick=false;
				hideMask();
			}else {
				bimViewPointNew.markup.unloadMarkupsAllLayers();
				bimViewPointNew.isFirstClick=true;
				bimViewPointNew.enterViewMode();
			}
		} else {
			bimViewPointNew.markup.unloadMarkupsAllLayers();
			//BimBdip.view.navigation.setRequestHomeView(true); //回归模型原始状态
			bimViewPointNew.enterViewMode();
		}
	},

	/**右键菜单相关**/
	OnRightClick : function (event, treeId, treeNode) {
		if (!treeNode && event.target.tagName.toLowerCase() != "button" && $(event.target).parents("a").length == 0) {
			bimViewPointNew.zTree.cancelSelectedNode();
			bimViewPointNew.showRMenu("root", event.clientX, event.clientY);
		} else if (treeNode && !treeNode.noR) {
			bimViewPointNew.zTree.selectNode(treeNode);
			if(treeNode.isParent){
				bimViewPointNew.showRMenu("parent", event.clientX, event.clientY);
			} else {
				bimViewPointNew.showRMenu("node", event.clientX, event.clientY);
			}
		}
	},
	showRMenu : function (type, x, y) {
		var left = window.innerWidth - 270;
		var top = parseInt(document.getElementById("div_viewpoint").style.top) - 5;
		$("#rMenu_viewpoint ul").show();
		if (type=="root") {
			$("#vp_m_add").show();
			$("#vp_m_del").hide();
			$("#vp_m_ren").hide();
			$("#vp_m_updateMark").hide();
		} else if (type=="parent"){
			$("#vp_m_add").show();
			$("#vp_m_del").show();
			$("#vp_m_ren").show();
			$("#vp_m_updateMark").hide();
		} else {
			$("#vp_m_add").hide();
			$("#vp_m_del").show();
			$("#vp_m_ren").show();
			$("#vp_m_updateMark").show();
		}
		bimViewPointNew.rMenu.css({"top":y-top+"px", "left":x-left+"px", "visibility":"visible"});
		$("body").bind("mousedown", bimViewPointNew.onBodyMouseDown);
	},
	hideRMenu : function () {
		if (bimViewPointNew.rMenu) bimViewPointNew.rMenu.css({"visibility": "hidden"});
		$("body").unbind("mousedown", bimViewPointNew.onBodyMouseDown);
	},
	onBodyMouseDown : function (event){
		if (!(event.target.id == "rMenu_viewpoint" || $(event.target).parents("#rMenu_viewpoint").length>0)) {
			bimViewPointNew.rMenu.css({"visibility" : "hidden"});
		}
	},
	/*** 销毁zTree **/
	clearTree : function () {
		if(bimViewPointNew.zTree){
			bimViewPointNew.zTree.destroy();
		}
	},
	/**加载树执行函数**/
	loadTree : function (){
		/***获取数据**/
		bimViewPointNew.zNodestemp = bimViewPointNew.loadTreeData();
		/***开始生成树**/
		$.fn.zTree.init($("#treeDemo_viewpoint"), bimViewPointNew.setting, bimViewPointNew.zNodestemp);
		bimViewPointNew.zTree = $.fn.zTree.getZTreeObj("treeDemo_viewpoint");
		bimViewPointNew.rMenu = $("#rMenu_viewpoint");
		/***生成树结束，可以自由使用事先定义好的zTree函数**/
	},
	/**专职加载树状图数据源的函数**/
	loadTreeData : function (){
		/***加载树状图数据源开始***/
		var zNodes = '[';
		var zNodestemp;
		var item=null;
		/**异步获取文件夹树--数据源**/
		$.ajax({
			url:publicJS.tomcat_url+"/viewsave/getAllViewDirByModelid?modelid="+bimViewPointNew.currentModelid,
			type:'GET',
			dataType:'json',
			async: false,
			success:function(obj){
				var data=obj.data;
				dataJson=JSON.parse(data);
				for(var i=0;i<dataJson.length;i++){
					item = {
							id: dataJson[i][2].did,
							pId: dataJson[i][0].fdid,
							name: dataJson[i][1].fname,
							isViewPoint:true,
							isParent: true,
							open:false,
							drop:true
					}
					//一个文件夹节点
					zNodes += "{\"id\":\"" + item.id + "\",";
					zNodes += "\"pId\":\"" + item.pId + "\",";
					zNodes += "\"name\":\"" + item.name + "\",";
					zNodes += "\"isViewPoint\":" + item.isViewPoint + ",";
					zNodes += "\"isParent\":" + item.isParent + ",";
					zNodes += "\"open\":" + item.open + ",";
					zNodes += "\"drop\":" + item.drop + "},";
				} 	  
			},
			error:function(){
				Dialog.alert("获取参数失败");
			}
		});
		/**异步获取视点图树--数据源**/
		$.ajax({
			url:publicJS.tomcat_url+"/viewsave/getAllViewPointByModelid?modelid="+bimViewPointNew.currentModelid,
			type:'get',
			dataType:'json',
			async: false,
			success:function(obj){
				var data=obj.data;
				dataJson=JSON.parse(data);
				for(var i=0;i<dataJson.length;i++){
					item = {
							id: dataJson[i][5].id,
							pId: dataJson[i][6].fid,
							name: dataJson[i][4].name,
							markupData:dataJson[i][3].mark,
							json:dataJson[i][0].json,
							picture:dataJson[i][1].pic,
							add_id:dataJson[i][8].add_id,
							type:dataJson[i][9].type,
							info:dataJson[i][12].info,
							isViewPoint:true,
							isParent: false,
							drop:false
					}
					//一个视点图节点
					zNodes += "{\"id\":\"" + item.id + "\",";
					zNodes += "\"pId\":\"" + item.pId + "\",";
					zNodes += "\"name\":\"" + item.name + "\",";
					zNodes += "\"markupData\":\"" + item.markupData + "\",";
					zNodes += "\"json\":\"" + item.json + "\",";
					zNodes += "\"picture\":\"" + item.picture + "\",";
					zNodes += "\"add_id\":\"" + item.add_id + "\",";
					zNodes += "\"type\":\"" + item.type + "\",";
					zNodes += "\"info\":\"" + item.info + "\",";
					zNodes += "\"isViewPoint\":" + item.isViewPoint + ",";
					zNodes += "\"isParent\":" + item.isParent + ",";
					zNodes += "\"drop\":" + item.drop + "},";
				}
			},
			error:function(){
				Dialog.alert("获取参数失败");
			}
		});
		if(zNodes.length>1){
			zNodes = zNodes.substring(0,zNodes.length-1);//去除最后的","
		}      	  
		zNodes += ']';
		zNodestemp = JSON.parse(zNodes);//转换为json对象
		return zNodestemp;
	},
	/*** 创建一个视点 **/
	onSaveLayer : function () {
		if(bimViewPointNew.zTree.getSelectedNodes()[0] && !bimViewPointNew.zTree.getSelectedNodes()[0].isParent){
			var targetNode = bimViewPointNew.zTree.getSelectedNodes()[0];
			bimViewPointNew.updateTreeNode(targetNode);
		} else {
			var dataUrl = BimBdip.view.getScreenShotBuffer();
			//压缩dataUrl
			compressImg(dataUrl,600,300,function(finalDataUrl){
			    if (finalDataUrl) {
			    	console.log("压缩后的dataUrl数据："+finalDataUrl);
			    	var compressBlob = bimViewPointNew.viewpoint_dataURLtoBlob(finalDataUrl);
			    	bimViewPointNew.saveViewPoint(compressBlob);
			    }else{
			    	console.log("压缩失败，用原始的dataUrl数据："+dataUrl);
			    	var originalBlob = bimViewPointNew.viewpoint_dataURLtoBlob(dataUrl);
			    	bimViewPointNew.saveViewPoint(originalBlob);
			    }
			});
		}
	},
	/*** 保存视点动作 **/
	saveViewPoint : function (blob){
		console.log("转换后的blob对象："+blob);
		//添加一个子节点到树结构中
		var id = bimViewPointNew.getGuid();
		var fid = 0;
		var parentNode = null;
		var newNode;
		if (bimViewPointNew.zTree.getSelectedNodes()[0] && bimViewPointNew.zTree.getSelectedNodes()[0].isParent) {
			fid = bimViewPointNew.zTree.getSelectedNodes()[0].id;
			parentNode = bimViewPointNew.zTree.getSelectedNodes()[0];
		}
		var tmpState=BimBdip.view.getState();
		var jsonString=JSON.stringify(tmpState);
		jsonString=jsonString.replace(/\"/g,"'");

		var data_mark="";
		var markup_id = bimViewPointNew.randomWord(true,16,32);
		if(!bimViewPointNew.viewMode){
			var markString = bimViewPointNew.markup.generateData().replace(/\"/g,"'");
			if(markString!=null && markString.replace(/(^\s*)|(\s*$)/g, "").length>0){
				data_mark += markup_id+"@BIM@"+markString;
			}
		}
		var fd = new FormData();
		fd.append("jsonString",jsonString);
		fd.append("image",blob);
		fd.append("guid",id);
		fd.append("markup",data_mark);
		fd.append("fid",fid);
		fd.append("url",bimViewPointNew.currentUrl);
		fd.append("add_id",id);
		fd.append("type",bimViewPointNew.viewType);
		fd.append("userid",bimViewPointNew.currentUserid);
		fd.append("username",bimViewPointNew.currentUsername);
		fd.append("modelid",bimViewPointNew.currentModelid);
		//保存到数据库
		showMask();
		$.ajax({
			url:publicJS.tomcat_url+"/viewsave/createViewPoint",
			type:'POST',
			data:fd,
			dataType:'json',
			processData:false,
			contentType:false,
			success:function(obj){
				changeMask("保存完毕");
				hideMask();
				var targetJson = obj.data; 
				newNode = {id:targetJson.id, pId:fid, name:targetJson.name, isParent:false};
				bimViewPointNew.zTree.addNodes(parentNode, newNode);
				var currentNode = bimViewPointNew.zTree.getNodeByParam("id", targetJson.id, parentNode);
				bimViewPointNew.zTree.selectNode(currentNode);
				bimViewPointNew.zTree.editName(currentNode);
			},
			error:function(){
				changeMask("保存失败，请检查网络");
				hideMask();
			}
		});
	},
	/*** 更新视点 **/
	updateTreeNode : function (targetNode){
		var dataUrl = BimBdip.view.getScreenShotBuffer();
		//压缩dataUrl
		compressImg(dataUrl,600,300,function(finalDataUrl){
		    if (finalDataUrl) {
		    	console.log("压缩后的dataUrl数据："+finalDataUrl);
		    	var compressBlob = bimViewPointNew.viewpoint_dataURLtoBlob(finalDataUrl);
		    	bimViewPointNew.updateViewPoint(compressBlob,targetNode);
		    }else{
		    	console.log("压缩失败，用原始的dataUrl数据："+dataUrl);
		    	var originalBlob = bimViewPointNew.viewpoint_dataURLtoBlob(dataUrl);
		    	bimViewPointNew.updateViewPoint(originalBlob,targetNode);
		    }
		});
	},
	updateViewPoint : function (blob,targetNode) {
		var upd_mark="";
		var bef_mark=targetNode.markupData;
		var markupArray = new Array();
		if(bef_mark.length>0){
			markupArray = bef_mark.split("@#@");
		}
		var markup_id = bimViewPointNew.randomWord(true,16,32);
		if(!bimViewPointNew.viewMode){
			var markString = bimViewPointNew.markup.generateData().replace(/\"/g,"'");
			if(markString!=null && markString.replace(/(^\s*)|(\s*$)/g, "").length>0){
				upd_mark += markup_id+"@BIM@"+markString;
				markupArray.push(upd_mark);
			}
		}
		var markups = markupArray.join("@#@");
		
		var tmpState=BimBdip.view.getState();
		var jsonString=JSON.stringify(tmpState);
		jsonString=jsonString.replace(/\"/g,"'");
		
		var fd = new FormData();
		fd.append("jsonString",jsonString);
		fd.append("image",blob);
		fd.append("markup",markups);
		fd.append("id",targetNode.id);
		//保存到数据库
		showMask("更新中...");
		$.ajax({
			url:publicJS.tomcat_url+"/viewsave/updateViewMarkup",
			type:'POST',
			data:fd,
			dataType:'text',
			processData:false,
			contentType:false,
			success:function(){
				changeMask("更新完毕");
				hideMask();
				//操作成功，刷新页面
				bimViewPointNew.loadTree();
				bimViewPointNew.enterViewMode();
				bimViewPointNew.passId = null;
				bimViewPointNew.isFirstClick = true;
			},
			error:function(){
				changeMask("更新失败，请检查网络");
				hideMask();
			}
		});
	},
	/**右键菜单方法--新建文件夹**/
	addTreeNode : function () {
		bimViewPointNew.hideRMenu();
		var id = bimViewPointNew.randomWord(true,16,32);
		var fid = 0;
		var nodeLevel = 0;
		var parentNode = null;
		var newNode = null;
		if(bimViewPointNew.zTree.getSelectedNodes()[0] && bimViewPointNew.zTree.getSelectedNodes()[0].isParent){
			fid = bimViewPointNew.zTree.getSelectedNodes()[0].id;
			parentNode = bimViewPointNew.zTree.getSelectedNodes()[0];
			nodeLevel = parentNode.level;
			console.log("当前文件夹的等级为："+nodeLevel);
		}
		if(nodeLevel < 2){
			bimViewPointNew.addTreeNodeAction(id,fid,parentNode,newNode);
		}else{
			Dialog.alert("最大可创建三层目录");
		}
	},
	addTreeNodeAction : function (id,fid,parentNode,newNode){
		//保存到数据库
		var fd = new FormData();
		fd.append("did",id);
		fd.append("fdid",fid);
		fd.append("url",bimViewPointNew.currentUrl);
		fd.append("type",bimViewPointNew.viewType);
		fd.append("userid",bimViewPointNew.currentUserid);
		fd.append("username",bimViewPointNew.currentUsername);
		fd.append("modelid",bimViewPointNew.currentModelid);
		$.ajax({
			url:publicJS.tomcat_url+"/viewsave/createViewDir",
			type:"POST",
			data:fd,
			dataType:"json",
			processData:false,
			contentType:false,
			success:function(obj){
				var targetJson = obj.data;
				newNode = {id:id, pId:fid, name:targetJson.name, isParent:true, open:false};
				bimViewPointNew.zTree.addNodes(parentNode, newNode);
				var currentNode = bimViewPointNew.zTree.getNodeByParam("id", id, parentNode);
				bimViewPointNew.zTree.selectNode(currentNode);
				bimViewPointNew.zTree.editName(currentNode);
			},
			error:function(){
				Dialog.alert("保存失败,请检查网络");
			}
		});
	},
	/***删除一个节点**/
	removeTreeNode : function () {
		bimViewPointNew.hideRMenu();
		var nodes = bimViewPointNew.zTree.getSelectedNodes();
		if (nodes && nodes.length>0) {
			if (nodes[0].isParent) {
				var msg = "确认删除该目录及其视点吗？";
				Dialog.confirm(msg,function(){
					bimViewPointNew.beforeRemove("#treeDemo_viewpoint",nodes[0]);
					bimViewPointNew.zTree.removeNode(nodes[0]);
					Dialog.alert("删除成功");
				});
			} else {
				var msg = "确认删除该视点吗？";
				Dialog.confirm(msg,function(){
					bimViewPointNew.beforeRemove("#treeDemo_viewpoint",nodes[0]);
					bimViewPointNew.zTree.removeNode(nodes[0]);
					Dialog.alert("删除成功");
				});
			}
		}
	},
	/***重命名一个节点**/
	renameTreeNode : function () {
		bimViewPointNew.hideRMenu();
		var nodes = bimViewPointNew.zTree.getSelectedNodes();
		if (nodes && nodes.length>0) {
			bimViewPointNew.zTree.selectNode(nodes[0]);
			bimViewPointNew.zTree.editName(nodes[0]);//重命名方法
		}	
	},
	/***右键更新涂鸦**/
	updateMark : function (){
		bimViewPointNew.hideRMenu();
		var selectedNodes = bimViewPointNew.zTree.getSelectedNodes();
		var targetNode = null;
		if(selectedNodes && selectedNodes.length>0){
			targetNode = selectedNodes[0];
			bimViewPointNew.updateTreeNode(targetNode);
		}
	},
	/***批量删除视点**/
	deleteViewPoints : function (){
		var checkedNodes = bimViewPointNew.zTree.getCheckedNodes();
		var msg = "确认删除吗？";
		if(checkedNodes && checkedNodes.length>0){
			for(var i=0; i<checkedNodes.length; i++){
				if(checkedNodes[i].isParent && checkedNodes[i].children && checkedNodes[i].children.length>0){
					msg = "您选择了包含有视点的目录，确认继续删除吗？";
					break;
				}
			}
			Dialog.confirm(msg,function(){
				bimViewPointNew.deleteBatch(checkedNodes);
			});
		}else{
			Dialog.alert("请勾选要删除的视点");
		}
	},
	deleteBatch : function (checkedNodes){
		var parentIdArr =[];
		var sonIdArr = [];
		//防止传空对象给后台接口导致请求出错
		for(var j=0; j<checkedNodes.length; j++){
			var currentNode = checkedNodes[j];
			if(currentNode.isParent){
				parentIdArr.push(currentNode.id);							
			}else{
				sonIdArr.push(currentNode.id);
			}
		}
		if(parentIdArr==null || parentIdArr.length==0){
			parentIdArr.push("");
		}
		if(sonIdArr==null || sonIdArr.length==0){
			sonIdArr.push("");
		}
		$.ajax({
	    	url:publicJS.tomcat_url+"/viewsave/deleteBatch",
	    	type:"GET",
			data:{"parentDelIds":parentIdArr,"sonDelIds":sonIdArr,"modelid":bimViewPointNew.currentModelid},
			traditional:true,
	    	success:function(){
	    		Dialog.alert("删除成功！");
	    		bimViewPointNew.markup.unloadMarkupsAllLayers();
	    		bimViewPointNew.loadTree();
	    		bimViewPointNew.enterViewMode();
	    	},
	    	error:function(){
	    		Dialog.alert("删除失败！");
	    	}
	    });
	},
	
	/***************************************zTree  ending***************************************/
	
	
	/***************************************search  starting***************************************/
	
	/***搜索视点**/
	selectByName : function (){
		var zNodes = '[';
		var zNodestemp;
		var item=null;
		var fid = 0;
		var nodes = bimViewPointNew.zTree.getSelectedNodes();
		var name = $("#vp-searchtxt").val();
		name = name.replace(/(^\s*)|(\s*$)/g, "");
		if(name && name.length>0 && name!='请输入搜索内容...'){
			if (nodes && nodes.length>0) {
				if (nodes[0].isParent) {
					fid = nodes[0].id;
					var parentNodes = nodes[0].getPath();
					if(parentNodes && parentNodes.length>0){
						//获取树结构
						item = {
							isParent: true,
							open: true,
							drop: true
						}
						for (var i=0;i<parentNodes.length;i++) {
							var bottomNode = parentNodes[i];
							zNodes += "{\"id\":\"" + bottomNode.id + "\",";
							zNodes += "\"pId\":\"" + bottomNode.pId + "\",";
							zNodes += "\"name\":\"" + bottomNode.name + "\",";
							zNodes += "\"isParent\":" + item.isParent + ",";
							zNodes += "\"open\":" + item.open + ",";
							zNodes += "\"drop\":" + item.drop + "},";	
						}
					}
				}
			}
			//获取视点图节点
			$.ajax({
				url:publicJS.tomcat_url+"/viewsave/searchViewPoint?name="+name+"&fid="+fid+"&modelid="+bimViewPointNew.currentModelid,
				type:'GET',
				dataType:'json',
				async: false,
				success:function(obj){
					var data = JSON.parse(obj.data);
					//获取搜索后的数据（刷新树状图）
					for(var i=0;i<data.length;i++){
						item = {
          				  	id: data[i][5].id,
          				  	add_id:data[i][6].add_id,
  	      		            pId: data[i][7].fid,
  	      		            name: data[i][4].name,
  	      		            markupData:data[i][3].mark,
  	      		            json:data[i][0].json,
  	      		            isParent: false,
  	      		            drop:false
						}
						//一个视点图节点
  	      				zNodes += "{\"id\":\"" + item.id + "\",";
						zNodes += "\"add_id\":\"" + item.add_id + "\",";
  	      				zNodes += "\"pId\":\"" + item.pId + "\",";
  	      				zNodes += "\"name\":\"" + item.name + "\",";
  	      				zNodes += "\"markupData\":\"" + item.markupData + "\",";
  	      				zNodes += "\"json\":\"" + item.json + "\",";
  	      				zNodes += "\"isParent\":" + item.isParent + ",";
  	      				zNodes += "\"drop\":" + item.drop + "},";
					}
				},
				error:function(data){
					Dialog.alert("查询失败!");
				}
			});
			if(zNodes.length>1){
				zNodes = zNodes.substring(0,zNodes.length-1);//去除最后的","
			}      	  
			zNodes += ']';
			zNodestemp = JSON.parse(zNodes);//转换为json对象
			$.fn.zTree.init($("#treeDemo_viewpoint"), bimViewPointNew.setting, zNodestemp);
			$("#vp-searchtxt").val(name);
		}else{
			Dialog.alert("请输入查询的视点名称");
		}
	},
	closeShow : function () {
		$("#vp-searchtxt").val("请输入搜索内容...");
		bimViewPointNew.loadTree();
	},
	/***过滤节点**/
	filterNodes : function () {
		var parentNode = null;
		var nodes = bimViewPointNew.zTree.getSelectedNodes();
		var name = $("#vp-searchtxt").val();
		name = name.replace(/(^\s*)|(\s*$)/g, "");
		if(name && name.length>0 && name!='请输入搜索内容...'){
			if(nodes[0] && nodes[0].isParent){
				parentNode = nodes[0];
			}
			var zNodes = bimViewPointNew.zTree.getNodesByFilter(
				function(node){
					//console.log("参与第一层filter的Node："+node.name+",是否是父："+node.isParent);
					if(node.isParent){
						//console.log("进入父");
						var extraParam = name;
						var tempParentNode = node;
						var tempNodes = bimViewPointNew.zTree.getNodesByFilter(
							function(tempNode){
								return !tempNode.isParent && tempNode.name.indexOf(extraParam)>-1;
							},
							false,
							tempParentNode,
							extraParam
						);
						if(tempNodes && tempNodes.length>0){
							//console.log("内部最终的结果"+JSON.stringify(tempNodes));
							return true; 
						}
					}else{
						//console.log("进入子");
						if(node.name.indexOf(name)>-1){
							return true;
						}
					}
					return false;
				},
				false,
				parentNode,
				name
			);
			var finalNodes = new Array();
			if(zNodes && zNodes.length>0){
				var itemP,itemS;
				for(var i=0;i<zNodes.length;i++){
					var targetNode = zNodes[i];
					if(targetNode.isParent){
						itemP = {
							//一个文件夹节点
							"id":targetNode.id,
							"pId":targetNode.pId,
							"name":targetNode.name,
							"isViewPoint":targetNode.isViewPoint,
							"isParent":targetNode.isParent,
							"open":targetNode.open,
							"drop":targetNode.drop
						};
						finalNodes.push(itemP);
					}else{
						itemS = {
							//一个视点图节点
							"id":targetNode.id,
							"pId":targetNode.pId,
							"name":targetNode.name,
							"markupData":targetNode.markupData,
							"json":targetNode.json,
							"picture":targetNode.picture,
							"add_id":targetNode.add_id,
							"type":targetNode.type,
							"info":targetNode.info,
							"isViewPoint":targetNode.isViewPoint,
							"isParent":targetNode.isParent,
							"drop":targetNode.drop
						};
						finalNodes.push(itemS);
					}
				}
			}else{
				finalNodes = zNodes;
			}
			
			/*** 最终加上选择的父目录 **/
			if(finalNodes && finalNodes.length>0){
				if(parentNode){
					var parentNodeItem = {
						//选择的根节点
						"id":parentNode.id,
						"pId":parentNode.pId,
						"name":parentNode.name,
						"isViewPoint":parentNode.isViewPoint,
						"isParent":parentNode.isParent,
						"open":parentNode.open,
						"drop":parentNode.drop	
					}
					finalNodes.push(parentNodeItem);
				}
			}
			
			console.log("最终的结果长度："+finalNodes.length +",内容为："+JSON.stringify(finalNodes));
			$.fn.zTree.init($("#treeDemo_viewpoint"), bimViewPointNew.setting, finalNodes);
			$("#vp-searchtxt").val(name);
		}else{
			Dialog.alert("请输入查询的视点名称");
		}
	}
	
	/***************************************search  ending***************************************/
	
} 