﻿ var _gyroext = null;
function MyUIExtension(viewer, options) {
    Autodesk.Viewing.Extension.call(this, viewer, options);
}
function getModifiedWorldBoundingBox(fragIds, fragList) {
        var fragbBox = new THREE.Box3();
        var nodebBox = new THREE.Box3();
        fragIds.forEach(function(fragId) {
            fragList.getWorldBounds(fragId, fragbBox);
            nodebBox.union(fragbBox);
        });
        return nodebBox;
}

MyUIExtension.prototype = Object.create(Autodesk.Viewing.Extension.prototype);
MyUIExtension.prototype.constructor = MyUIExtension;

MyUIExtension.prototype.onToolbarCreated = function() {
    this.viewer.removeEventListener(av.TOOLBAR_CREATED_EVENT, this.onToolbarCreatedBinded);
    this.onToolbarCreatedBinded = null;
    this.createUI();
};

MyUIExtension.prototype.createUI = function() {
    var viewer = this.viewer;
    var button_Gyro_for_Moving_Obj1 = new Autodesk.Viewing.UI.Button('btn-move-obj1');
    button_Gyro_for_Moving_Obj1.icon.style.backgroundImage = 'url(360js/qj.png)';
    
    button_Gyro_for_Moving_Obj1.addClass('btn-move-obj1');
    button_Gyro_for_Moving_Obj1.setToolTip('绑定全景图');
    
    // SubToolbar
    this.subToolbar = new Autodesk.Viewing.UI.ControlGroup('my-custom-buttons-toolbar');
    //this.subToolbar.addControl(button_Gyro_for_Moving_Obj1);
    //viewer.toolbar.addControl(this.subToolbar);
};

MyUIExtension.prototype.load = function() {
    var viewer = this.viewer;
    if (this.viewer.toolbar) {
        // Toolbar is already avaislable, create the UI
        this.createUI();
        var options = {};
       _gyroext = new  Autodesk.ADN.Viewing.Extension.Annotation(viewer,options);
       // viewer.loadExtension('Autodesk.ADN.Viewing.Extension.Annotation');
       _gyroext.load();
        //不同的load对象  1、根据方法，在文件的开头对应，根据名字，在文件的最后定义
    } else {
        // Toolbar hasn't been created yet, wait until we get notification of its creation
        this.onToolbarCreatedBinded = this.onToolbarCreated.bind(this);
        this.viewer.addEventListener(av.TOOLBAR_CREATED_EVENT, this.onToolbarCreatedBinded);
    }
    return true;
};

MyUIExtension.prototype.unload = function() {
    this.viewer.toolbar.removeControl(this.subToolbar);
    return true;
};

Autodesk.Viewing.theExtensionManager.registerExtension('MyUIExtension', MyUIExtension);

function show1(id){
	try{
	     $(".parmaBox1").css({"opacity":"1","top":"200px"});
	     $('#ifm0').attr("src","../modeltool/360jsp/show?id="+id);
	     setTimeout(function(){
	    	 //alert(id+"----"+1);
	    	// window[1].showPanorama();
	     }, 500);
	}catch(e){

	};
}

